Package: Morgan2013
Type: Package
Title: Supporting material, CSAMA2013
Version: 1.0.1
Author: Marc Carlson, Valerie Obenchain, Herv\'e Pag\`es, Paul
    Shannon, Dan Tenenbaum, Martin Morgan
Maintainer: Biocore Team c/o BioC user list
        <bioconductor@stat.math.ethz.ch>
License: Artistic-2.0
Description: This package contains supporting material for lectures
    and labs delivered by Martin Morgan during the CSAMA 2013 course.
Imports: BiocInstaller
Suggests: Biostrings, ShortRead, Rsamtools, GenomicRanges, rtracklayer,
        RNAseqData.HNRNPC.bam.chr14, org.Hs.eg.db,
        BSgenome.Hsapiens.UCSC.hg19, TxDb.Hsapiens.UCSC.hg19.knownGene,
        Homo.sapiens, TxDb.Dmelanogaster.UCSC.dm3.ensGene, GO.db,
        MotifDb, seqnames.db, SNPlocs.Hsapiens.dbSNP.20120608,
        GenomicFeatures, biomaRt, AnnotationHub, VariantAnnotation,
        ensemblVEP, VariantTools, gmapR, LungCancerLines, Gviz, shiny,
        parallel, lattice, edgeR
Packaged: 2013-07-05 22:30:37 UTC; mtmorgan

## create a DNAStringSet covering the single range in roi but
## incorporating variants given by x, a GRanges object returned by
## callVariants

variantSequences <-
    function(x, roi, refSeq, ...)
{
    stopifnot(length(roi) == 1L)

    ## sequence in region of interest, replicated for each variant
    x <- subsetByOverlaps(x, roi)
    at <- split(start(x) - start(roi) + 1L, x$id)
    alt <- split(x$alt, x$id)
    alts <- Map(replaceLetterAt, at=at, letter=alt, refSeq)
    DNAStringSet(alts)
}

matchPWMs <-
    function(pwms, subject, min.score="80%", ...)
{
    subject <- as(subject, "DNAString")
    hits <- lapply(pwms, matchPWM, subject, min.score=min.score, ...)
    good <- sapply(hits, function(hit) isTRUE(width(hit) > 0))
    hits <- hits[good]

    ## Post-calculate the scores of the hits:
    scores <- Map(function(pwm, hit) {
        PWMscoreStartingAt(pwm, subject(hit), start(hit))
    }, pwms[names(hits)], hits)

    DataFrame(PWM=rep(names(hits), elementLengths(hits)),
              score=unlist(scores, use.names=FALSE),
              start=unlist(lapply(hits, start)),
              end=unlist(lapply(hits, end)),
              seq=do.call(c, lapply(unname(hits), as, "DNAStringSet")))
}

library(shiny)

shinyUI(pageWithSidebar(

  headerPanel("SummarizedExperiment Viewer"),

  sidebarPanel(
    checkboxInput("show_expt_data",
                  "Experiment data"),
    checkboxInput("show_col_data",
                  "Column data"),
    selectInput("transform", "Transform",
        choices = c("none", "asinh", "sqrt",
          "log1"))
      ),
  
  mainPanel(
    verbatimTextOutput("overview"),
    conditionalPanel(
        "input.show_expt_data == true",
        verbatimTextOutput("expt_data")),
    conditionalPanel(
        "input.show_col_data == true",
        tableOutput("col_data")),
    plotOutput("heatmap"))

))

### R code from vignette source 'D1_GeneAnnotations.Rnw'

###################################################
### code chunk number 1: setup
###################################################
options(digits=2)
library(org.Dm.eg.db)
CONNECTION_OK <- tryCatch({ 
    con <- url("http://google.com", "r"); close(con); TRUE
}, error=function(...) FALSE)


###################################################
### code chunk number 2: PKG_OK
###################################################
PKG_OK <- packageDescription("Morgan2013")$Version >= "0.9.0"
stopifnot(PKG_OK)


###################################################
### code chunk number 3: select
###################################################
library(org.Dm.eg.db)
cols(org.Dm.eg.db)
keytypes(org.Dm.eg.db)
uniprotKeys <- head(keys(org.Dm.eg.db, keytype="UNIPROT"))
cols <- c("SYMBOL", "PATH")
select(org.Dm.eg.db, keys=uniprotKeys, cols=cols, keytype="UNIPROT")


###################################################
### code chunk number 4: select-kegg
###################################################
kegg <- select(org.Dm.eg.db, "00310", c("UNIPROT", "SYMBOL"), "PATH")
nrow(kegg)
head(kegg, 3)


###################################################
### code chunk number 5: tt-to-eg
###################################################
library(Morgan2013)
library(edgeR)
library(org.Dm.eg.db)
data(lrTest)
tt <- as.data.frame(topTags(lrTest))


###################################################
### code chunk number 6: tt-to-eg2
###################################################
fbids <- rownames(tt)
cols <- c("ENTREZID", "SYMBOL")
anno <- select(org.Dm.eg.db, fbids, cols, "FLYBASE")
ttanno <- merge(tt, anno, by.x=0, by.y="FLYBASE")
dim(ttanno)
head(ttanno, 3)


###################################################
### code chunk number 7: biomaRt1 (eval = FALSE)
###################################################
## library(biomaRt)
## head(listMarts(), 3)                      ## list the marts
## head(listDatasets(useMart("ensembl")), 3) ## mart datasets
## ensembl <-                                ## fully specified mart
##     useMart("ensembl", dataset = "hsapiens_gene_ensembl")
## 
## head(listFilters(ensembl), 3)             ## filters
## myFilter <- "chromosome_name"
## head(filterOptions(myFilter, ensembl), 3) ## return values
## myValues <- c("21", "22")
## head(listAttributes(ensembl), 3)          ## attributes
## myAttributes <- c("ensembl_gene_id","chromosome_name")
## 
## ## assemble and query the mart
## res <- getBM(attributes =  myAttributes, filters =  myFilter,
##              values =  myValues, mart = ensembl)

library(shiny)
library(lattice)
library(parathyroidSE)

shinyServer(function(input, output) {

  dataset <- reactive({
      data(parathyroidGenesSE)
      parathyroidGenesSE
  })

  output$overview <- renderPrint({
      print(dataset())
  })

  output$expt_data <- renderPrint({
    print(exptData(dataset())[[1]])
  })

  output$col_data <- renderTable({
    df0 <-colData(dataset())
    df <- as.data.frame(df0[, 3:8])
    rownames(df) <- df0$run
    df
  })

})

library(shiny)
library(lattice)
library(RColorBrewer)
library(parathyroidSE)
data(parathyroidGenesSE)

shinyServer(function(input, output) {

  dataset <- reactive({
    ## get and transform data
    m0 <- assay(parathyroidGenesSE)
    m <- switch(input$transform,
                none=m0,
                asinh=asinh(m0),
                sqrt=sqrt(m0),
                log1=log(m0 + 1))
    ## cluster distances and determine order
    ## as in heatmap()
    cor_m <- cor(m)
    ddr <- as.dendrogram(hclust(dist(cor_m)))
    w <- rowMeans(cor_m)
    ddr <- reorder(ddr, w)
    o <- order.dendrogram(ddr)
    ## return re-ordered data
    parathyroidGenesSE[,o]
  })

  output$overview <- renderPrint({
    print(dataset())
  })

  output$expt_data <- renderPrint({
    print(exptData(dataset())[[1]])
  })

  output$col_data <- renderTable({
    df0 <-colData(dataset())
    df <- as.data.frame(df0[, 3:8])
    rownames(df) <- df0$run
    df
  })

  output$heatmap <- renderPlot({
    m <- dataset()
    corm <- cor(assay(m))
    colnames(corm) <- colData(m)$run
    col0 <- brewer.pal(11, "RdYlGn")
    col <- colorRampPalette(col0)(100)
    print(levelplot(corm,
        cuts=length(col) - 1,
        col.regions=col,
        aspect="iso",
        xlab=NULL, ylab=NULL,
        scales=list(x=list(draw=FALSE))))
  })

})

library(shiny)
library(parathyroidSE)

shinyServer(function(input, output) {

    dataset <- reactive({
        data(parathyroidGenesSE)
        parathyroidGenesSE
    })

    output$overview <- renderPrint({
        print(dataset())
    })

})

library(shiny)

shinyUI(pageWithSidebar(

  headerPanel("SummarizedExperiment Viewer"),

  sidebarPanel(
    checkboxInput("show_expt_data",
                  "Experiment data"),
    checkboxInput("show_col_data",
                  "Column data"),
    selectInput("transform", "Transform",
        choices = c("none", "asinh", "sqrt",
          "log1"))
    ),
   
  mainPanel(
      verbatimTextOutput("overview"))

))

isInDbSNP <- 
    function(vcf, seqname, rsid=TRUE) 
{
    snpLocs <- getSNPlocs(seqname)
    idx <-                    # correct seqname, width of variant == 1
        ((seqnames(vcf) == seqname) & (width(rowData(vcf)) == 1L))
    idx <- as.vector(idx)
    snps <- rowData(vcf)[idx]
    result <- rep(NA, nrow(vcf))
    result[idx] <- if (rsid) {
        sub("rs", "", names(snps)) %in% snpLocs[["RefSNP_id"]]
    } else {
        start(snps) %in% snpLocs[["loc"]]
    }
    result
}

%% \VignetteIndexEntry{Lab: Annotation, Variants, and Visualization}

\documentclass[a4paper]{report}

\usepackage{BioconductorVignette}
\graphicspath{{annotation-visualization-variants/}}

\title{Annotations, Visualization, and Variants}
\author{
  Marc Carlson, Valerie Obenchain, Herv\'e Pag\`es, Paul Shannon,
  Dan Tenenbaum, Martin
  Morgan\footnote{\href{mailto:mtmorgan@fhcrc.org}{mtmorgan@fhcrc.org}}
}
\date{June 23 -- 28, 2013}

<<setup, echo=FALSE>>=
library(Morgan2013)
@ 

\begin{document}

\maketitle
\tableofcontents

\part{Annotation and Visualization (Intermediate)}

\include{annotation-visualization-variants/D1_GeneAnnotations}
\include{annotation-visualization-variants/D2_GenomicAnnotations}
\include{annotation-visualization-variants/D3_Visualization}

\part{Variants (Advanced)}

\include{annotation-visualization-variants/D4_CalledVariants}
\include{annotation-visualization-variants/D5_StructuralVariants}
\include{annotation-visualization-variants/D6_RegulatoryVariants}

\addcontentsline{toc}{chapter}{References}
\bibliographystyle{abbrv}
\bibliography{References}

\end{document}

%% \VignetteIndexEntry{Lab: Sequences, Reads, Alignments and Ranges}

\documentclass[a4paper]{report}

\usepackage{BioconductorVignette}
\graphicspath{{sequences-reads-ranges-alignments/}}

\title{Sequences, Reads, Alignments, and Ranges}
\author{
  Marc Carlson, Valerie Obenchain, Herv\'e Pag\`es, Paul Shannon,
  Dan Tenenbaum, Martin
  Morgan\footnote{\href{mailto:mtmorgan@fhcrc.org}{mtmorgan@fhcrc.org}}
}
\date{June 23 -- 28, 2013}

<<setup, echo=FALSE>>=
library(Morgan2013)
@ 

\begin{document}

\maketitle
\tableofcontents

\include{sequences-reads-ranges-alignments/A1_SequenceAnalysis}
\include{sequences-reads-ranges-alignments/A2_ReadsAndStrings}
\include{sequences-reads-ranges-alignments/A3_AlignmentsAndRanges}
\include{sequences-reads-ranges-alignments/A4_LargeData}

\addcontentsline{toc}{chapter}{References}
\bibliographystyle{abbrv}
\bibliography{References}

\end{document}

%% \VignetteIndexEntry{Talk: Sequences, Reads, Alignments, and Ranges}

\documentclass[a4paper, notitlepage]{beamer}

\usepackage{BioconductorSlides}
\title{Working with Large Data}
\author{
  Martin
  Morgan\footnote{\href{mailto:mtmorgan@fhcrc.org}{mtmorgan@fhcrc.org}}
}
\date{June 23 -- 28, 2013}

<<setup, echo=FALSE>>=
library(Morgan2013)
@ 

\begin{document}

\begin{frame}
  \maketitle
\end{frame}

\begin{frame}[t, fragile]
  \frametitle{Write efficient \R{} code}
  \begin{columns}[t]
    \column{.4\textwidth}
    \begin{enumerate}
    \item \textbf<1>{Vectorize}
    \item \textbf<2>{Pre-allocate and fill}
    \item \textbf<3>{Exploit existing software}
    \item \textbf<4>{Use appropriate algorithms}
    \item \textbf<5>{Avoid expensive conveniences}
    \end{enumerate}
    \column{.6\textwidth}
    \begin{description}
      \only<1>{
      \item[Symptom] It takes too long to perform a simple
        mathematical calculation
      \item[Solution] Vectorize, e.g., \Rcode{log(x)}, \Rcode{x \%*\% y}
      }\only<2>{
      \item[Symptom] A loop appends to a result vector; it starts
        quickly but then gets slower and slower!
      \item[Solution] Fill a pre-allocated result vector or, better,
        use \Rcode{result <- lapply(x, function(...) ...)}.
      }\only<3>{
      \item[Symptom] Everyone must be doing this, why do I feel like
        I'm re-inventing the wheel (and doing it poorly!)?
      \item[Solution] Use established, performant software, e.g.,
        \Biocpkg{limma}, \Biocpkg{DESeq2}
      }\only<4>{
      \item[Symptom] Execution time increases dramatically as data
        size increases
      \item[Solution] Choose algorithms that scale linearly or better
        with data size.
      }\only<5>{
      \item[Symptom] An over-zealous `feature' hurts performance
      \item[Solution] Avoid the feature, e.g., \Rcode{l =
          list(a=1:3); unlist(l, use.names=FALSE)}
      }\only<6>{
      \item 
      }
    \end{description}
  \end{columns}
  \medskip\only<6>{
  \begin{center}
    \begin{minipage}[c]{.8\linewidth}
      \emph{There are many fast ways to get the wrong answer} --
      R.\ Gentleman
    \end{minipage}
  \end{center}
  }
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Manage data and processors}
  \begin{columns}[t]
    \column{.37\textwidth}
    \bigskip\par
    \begin{enumerate}
    \item \textbf<1>{Restriction}
    \item \textbf<2>{Sampling}
    \item \textbf<3>{Iteration}
    \item \textbf<4>{Parallel evaluation}
    \end{enumerate}
    \column{.63\textwidth}
\begin{semiverbatim}\only<1>{
library(Rsamtools)
gr <- GRanges("chr7", 
  IRanges(100000, width=100))
param <- ScanBamParam(
  what = c("rname", "pos", "cigar"),
  which = gr)
scanBam("a.bam", param = param)
}\only<2>{
library(ShortRead)
samp <- FastqSampler("end1.fastq")
yield(samp)
set.seed(123); yield(samp)
set.seed(123); yield(samp)
}\only<3>{
library(Rsamtools)
bf <-
  BamFile("a.bam", yieldSize=1e6)
open(bf)
repeat \{
  gl <- readGAlignments(bf)
  if (length(gl) == 0)
    break;
  ## do work
\}
close(bf)
}\only<4>{
library(parallel)
options(mc.cores=detectCores)
fls <- c("a.bam", "b.bam")

## sequential
x0 <- lapply(fls, countBam)

## parallel, 1 core per BAM file
x1 <- mclapply(fls, countBam)

identical(x0, x1)  # TRUE
}\end{semiverbatim}
\only<4>{Other parallel solutions possible, e.g., clusters, Windows}
  \end{columns}
\end{frame}

\begin{frame}{Acknowledgments}
  \begin{columns}
    \column{.5\textwidth}
    \begin{itemize}
    \item Vince Carey
    \item Michael Lawrence
    \item Herv\'e Pag\`es
    \item Valerie Obenchain
    \end{itemize}
    \column{.5\textwidth}
    \begin{itemize}
    \item Marc Carlson
    \item Paul Shannon
    \item Dan Tenenbaum
    \end{itemize}
  \end{columns}
\end{frame}

\end{document}

%% \VignetteIndexEntry{Talk: Sequences, Reads, Alignments, and Ranges}

\documentclass[a4paper, notitlepage]{beamer}

\usepackage{BioconductorSlides}
\title{Sequences, Reads, Ranges, and Alignments}
\author{
  Martin
  Morgan\footnote{\href{mailto:mtmorgan@fhcrc.org}{mtmorgan@fhcrc.org}}
}
\date{June 23 -- 28, 2013}

<<setup, echo=FALSE>>=
library(Morgan2013)
@ 

\begin{document}

\begin{frame}
  \maketitle
\end{frame}

\begin{frame}{Overview}
  \begin{enumerate}
  \item Sequences -- \Biocpkg{Biostrings}, \Biocpkg{BSgenome},
    (\Biocpkg{Rsamtools})
  \item Reads -- \Biocpkg{ShortRead}
  \item Ranges -- \Biocpkg{GenomicRanges}
  \item Alignments -- \Biocpkg{Rsamtools}
  \item Working with large data
  \end{enumerate}
\end{frame}

\begin{frame}{Sequences -- \Biocpkg{Biostrings}}
  \begin{tabular}{lll}
    One & Many \\\hline
    \Rclass{DNAString} & \Rclass{DNAStringSet} \\
    \Rclass{RNAString} & \Rclass{RNAStringSet} \\
    \Rclass{AAString} & \Rclass{AAStringSet} \\
    \Rclass{BString} & \Rclass{BStringSet}
  \end{tabular}
  \bigskip\par
  \begin{tabular}{ll}
    Operation & Examples \\\hline
    Access & \Rfunction{length}, \Rfunction{nchar} \\
    Compare & \Rfunction{match}, \Rfunction{sort} \\
    Edit & \Rfunction{subseq}, \Rfunction{translate} \\
    Count & \Rfunction{alphabetFrequency}, \Rfunction{consensusMatrix} \\
    Match & \Rfunction{stringDist}, \Rfunction{matchPattern} \\
    & \Rfunction{pairwiseAlignment}, \Rfunction{matchPWM} \\
    I/O & \Rfunction{readDNAStringSet}, \Rfunction{writeXStringSet}
  \end{tabular}
\end{frame}

\begin{frame}[fragile]
  \frametitle{Whole-genome sequences}
  \Biocpkg{BSgenome}
  \begin{itemize}
  \item Pre-built or custom-made -- \texttt{vignette("BSgenomeForge")}
  \item Load chromome-at-a-time or selected sequences into memory
  \end{itemize}
  \Biocpkg{Rsamtools}: \Rfunction{FaFile}
  \begin{itemize}
  \item Point to standard FASTA file on disk
  \item Index -- \Rfunction{indexFa}
  \item Query -- \Rfunction{scanFa}
  \end{itemize}
  Tasks?
\end{frame}

\begin{frame}[fragile]
  \frametitle{Reads -- \Biocpkg{ShortRead}}
\begin{semiverbatim}
 HWI-EAS299_4_30M2BAAXX:5:1:1513:1024 length=37
GTTTTGTCCAAGTTCTGGTAGCTGAATCCTGGGGCGC
+HWI-EAS299_4_30M2BAAXX:5:1:1513:1024 length=37
IIIIIIIIIIIIIIIIIIIIIIIIIIII+HIIII<IE
\end{semiverbatim}
  Input
  \begin{itemize}
  \item \Rfunction{readFastq}
  \item \Rfunction{FastqSampler} \& \Rfunction{yield};
    \Rfunction{FastqStreamer} \& \Rfunction{yield}
  \item \Rfunction{trimTails}, \ldots
  \end{itemize}
  Manipulation
  \begin{itemize}
  \item \Rfunction{sread}, \Rfunction{quality}, \ldots
  \item \Rfunction{frequentSequences}, \Rfunction{alphabetByCycle}, \ldots
  \item \Rfunction{qa}, \Rfunction{report}
  \end{itemize}
\end{frame}

\begin{frame}{Ranges -- \Biocpkg{GenomicRanges}}
  \Rclass{GRanges}
  \begin{itemize}
  \item Ranges in genomic space -- seqname, start / end / width,
    strand ($+$, $-$, $*$)
  \item Annotation (e.g., regulatory regions, genes, exons) or data
    (e.g., reads, peaks, variants)
  \end{itemize}
  Operations
  \begin{description}
  \item[Intra-range] \Rfunction{flank}, \Rfunction{narrow}, \ldots
  \item[Inter-range] \Rfunction{range}, \Rfunction{disjoin},
    \Rfunction{gaps}, \Rfunction{coverage}, \ldots
  \item[Between] \Rfunction{countOverlaps}, \Rfunction{findOverlaps},
    \Rfunction{summarizeOverlaps} (\Biocpkg{GenomicRanges}), \ldots
  \end{description}
\end{frame}

\begin{frame}{Ranges -- \Biocpkg{GenomicRanges}}
  \Rclass{GRangesList}
  \begin{itemize}
  \item List-like, where all elements are \Rclass{GRanges}
  \item Annontation (e.g., exons within genes) or data (e.g., gapped
    alignments)
  \end{itemize}
  Advanced: derived from \Biocpkg{IRanges} package \Rclass{CompressedList} class
  \begin{itemize}
  \item \Rclass{CompressedList}: \emph{many} homogenous elements
  \item Internally, a single \Rclass{GRanges} and a `partitioning'
    describing how elements of the \Rclass{GRanges} are separated into
    groups.
  \item Some operations (e.g., \Rfunction{unlist}, \Rfunction{relist})
    very fast.
  \item Common pattern for implementation: unlist, transform, relist.
  \end{itemize}
  Tasks?
\end{frame}

\begin{frame}{Alignments -- \Biocpkg{Rsamtools}}
  \Rclass{GappedAlignments} (\Rclass{GAlignments})
  \begin{itemize}
  \item \Rfunction{readGappedAlignments} (\Rfunction{readGAlignments})
  \item (Bioc-devel: \Rfunction{readGAlignmentsList})
  \item Also: \Rfunction{scanBam}, \Rfunction{asBam},
    \Rfunction{indexBam}, \Rfunction{quickCountBam}, \ldots
  \end{itemize}
  \Rclass{BamFile} / \Rclass{BamFileList}
  \begin{itemize}
  \item A \emph{type} (for method selection, e.g.,
    \Rfunction{coverage}) and \Rfunarg{yieldSize}
  \end{itemize}
  \Rclass{ScanBamParam}: optional argument to input functions
  \begin{itemize}
  \item \Rfunarg{what}: (additional) fields to return
  \item \Rfunarg{which}: restrict query to specific \Rclass{GRanges}
  \item \Rfunarg{flag}: restrict read input, e.g., marked as passing
    quality control, not optical duplicates, plus strand
  \item \ldots
  \end{itemize}
  Tasks?
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Working with large data}
  \begin{columns}[t]
    \column{.37\textwidth}
    \bigskip\par
    \begin{enumerate}
    \item \textbf<1>{Restriction}
    \item \textbf<2>{Sampling}
    \item \textbf<3>{Iteration}
    \item \textbf<4>{Parallel evaluation}
    \end{enumerate}
    \column{.63\textwidth}
\begin{semiverbatim}\only<1>{
library(Rsamtools)
gr <- GRanges("chr7", 
  IRanges(100000, width=100))
param <- ScanBamParam(
  what = c("rname", "pos", "cigar"),
  which = gr)
scanBam("a.bam", param = param)
}\only<2>{
library(ShortRead)
samp <- FastqSampler("end1.fastq")
yield(samp)
set.seed(123); yield(samp)
set.seed(123); yield(samp)
}\only<3>{
library(Rsamtools)
bf <-
  BamFile("a.bam", yieldSize=1e6)
open(bf)
repeat \{
  gl <- readGAlignments(bf)
  if (length(gl) == 0)
    break;
  ## do work
\}
close(bf)
}\only<4>{
library(parallel)
options(mc.cores=detectCores)
fls <- c("a.bam", "b.bam")

## sequential
x0 <- lapply(fls, countBam)

## parallel, 1 core per BAM file
x1 <- mclapply(fls, countBam)

identical(x0, x1)  # TRUE
}\end{semiverbatim}
\only<4>{Other parallel solutions possible, e.g., clusters, Windows}
  \end{columns}
\end{frame}

\begin{frame}{Acknowledgements}
  \begin{columns}[t]
    \column{.5\textwidth}
    \Biocpkg{IRanges}, \Biocpkg{GenomicRanges}
    \begin{itemize}
    \item Michael Lawrence
    \item Herv\'e Pag\`es
    \item Patrick Aboyoun
    \item Valerie Obenchain
    \end{itemize}
    \Biocpkg{Biostrings}, \Biocpkg{BSgenome}
    \begin{itemize}
    \item Herv\'e Pag\`es
    \end{itemize}
    \column{.5\textwidth}
    And\ldots
    \begin{itemize}
    \item Marc Carlson
    \item Paul Shannon
    \item Dan Tenenbaum
    \end{itemize}
    \Bioconductor{} mailing list
  \end{columns}
\end{frame}

\end{document}

%% \VignetteIndexEntry{Motifs and Position Weight Matricies}

\documentclass[a4paper, notitlepage]{beamer}

\usepackage{BioconductorSlides}
\title{Motifs and Position Weight Matrices}
\author{
  Martin
  Morgan\footnote{\href{mailto:mtmorgan@fhcrc.org}{mtmorgan@fhcrc.org}}
}
\date{June 23 -- 28, 2013}

<<setup, echo=FALSE>>=
options(showHeadLines=2, showTailLines=1, max.print=1000, width=50)
library(Morgan2013)
library(Biostrings)
library(BSgenome.Dmelanogaster.UCSC.dm3)
library(MotifDb)
library(seqLogo)
@ 

\begin{document}

\begin{frame}
  \maketitle
\end{frame}

\begin{frame}{Position weight matrix (PWM)}
  \begin{itemize}
  \item A probabilistic description of (short) sequences
  \item Useful for describing, e.g., transcription factor binding sites
  \item Easy to construct and use, e.g., scanning genomic sequences
    for occurence of binding motifs
  \item A quick case study
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Position weight matrix}
  \begin{itemize}
  \item HNF4alpha transcription factor binding sites
<<HNF4alpha, echo=FALSE>>=
library(Biostrings)
data(HNF4alpha)
HNF4alpha
@ 
\item Consensus matrix / position frequency matrix (first 7 columns)
<<HNF4alpha-consensusMatrix, echo=FALSE>>=
consensusMatrix(HNF4alpha)[1:4,1:7]
@ 
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Position weight matrix}
  \begin{itemize}
  \item Approximately: log probability $p_{ij}$ of symbol $i$ at
    position $j$, given background (prior) probability $b_i$,
    $log_2(p_{ij} / b_i)$
  \item Scaled so possible score ranges from 0 to 1
<<HNF4alpha-PFM, echo=FALSE>>=
pwm <- PWM(consensusMatrix(HNF4alpha)[1:4,])
round(pwm, 3)[,1:7]
@ 
\item Score a `subject' sequence by adding elements of corresponding
  entries in PWM
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Use}
<<pwm-example>>=
library(Biostrings)
data(HNF4alpha)
pfm <- consensusMatrix(HNF4alpha)
pwm <- PWM(consensusMatrix(HNF4alpha))
@ 
\Biocpkg{seqLogo}:\par
\begin{center}
  \includegraphics[width=\textwidth]{seqlogo.pdf}
\end{center}
<<seqlogo, echo=FALSE>>=
pdf("seqlogo.pdf", width=7, height=3)
pfm1 <- sweep(pfm, 2, colSums(pfm), "/")[1:4,]
seqLogo(pfm1)
x <- dev.off()
@ 
\end{frame}

\begin{frame}[fragile]{Use}
<<hits>>=
library(BSgenome.Dmelanogaster.UCSC.dm3)
hits <- matchPWM(pwm, Dmelanogaster$chr3R)
length(hits)
head(hits)
@ 
\end{frame}

\begin{frame}[fragile]{Use}
  \begin{columns}
    \column{.5\textwidth}
    \begin{itemize}
    \item Scores
<<pwm-score>>=
scores <- 
  PWMscoreStartingAt(
    pwm, subject(hits), 
    start(hits))
hist(scores)
@   
%% 
\item Minus strand -- take the \Rfunction{reverseComplement} of the
  PWM!
    \end{itemize}
<<pwm-scores, echo=FALSE>>=
pdf("scores.pdf")
hist(scores, cex.axis=2)
x <- dev.off()
@ 
    \column{.5\textwidth}
    \includegraphics{scores.pdf}
  \end{columns}
\end{frame}

\begin{frame}{Software}
  \begin{itemize}
  \item \Biocpkg{Biostrings} for PWM matching
  \item \Biocpkg{MotifDb} for a catalog of known motifs
  \item \Biocpkg{seqLogo} for visualization
  \end{itemize}
\end{frame}

\begin{frame}{Case study}
  \begin{itemize}
  \item Huang et al., 2013, Highly Recurrent TERT
    Promoter Mutations in Human Melanoma, Science 339:957
  \item Prior whole-genome sequencing of malignant melanomas; two
    somatic telomerase reverse transcriptase (TERT) promoter mutations
    in 17 of 19 cases: C228T and C250T
  \item Validate \& extend to additional tumor cell lines
  \item C228T and C250T introduce E-twenty-six (ETS) transcription
    factor binding sites
  \item Suggests plausible MAP kinase pathway; recurrent somatic
    mutations in regulatory regions as driver events in cancer
  \end{itemize}
\end{frame}

\begin{frame}{Case study}
  Lab workflow:
  \begin{itemize}
  \item (Call variants in TERT promoter region)
  \item Score catalog of known PWMs for match to reference versus
    variant sequence
  \end{itemize}
\end{frame}

\begin{frame}{Acknowledgments}
  \begin{itemize}
  \item Paul Shannon (\Biocpkg{MotifDb}; lab workflow)
  \item Herv\'e Pag\`es (\Biocpkg{Biostrings})
  \item Patrick Aboyoun (\Rfunction{PWM} \& friends)
  \item Valerie Obenchain (lab workflow)
  \end{itemize}
\end{frame}

\end{document}

%% \VignetteIndexEntry{Talk: Introduction to R / Bioconductor}

\documentclass[]{beamer}

\usepackage{BioconductorSlides}
\title{Introduction to \R{} and \Bioconductor{}}
\author{
  Martin
  Morgan\footnote{\href{mailto:mtmorgan@fhcrc.org}{mtmorgan@fhcrc.org}}
}
\date{June 23 -- 28, 2013}

<<setup, echo=FALSE>>=
library(Morgan2013)
@ 

\begin{document}

\begin{frame}
  \maketitle
\end{frame}

\begin{frame}{Overview}
\begin{columns}[t]
  \column{.5\textwidth}\R{}
  \begin{enumerate}
  \item Vectors, data frames, arrays
  \item Statistical concepts
  \item Functions
  \item Packages
  \item From script to collaboration
  \item HELP!
  \end{enumerate}
  \column{.5\textwidth}\Bioconductor{}
  \begin{enumerate}
  \item A short history
  \item Sequence analysis
  \item Classes, generics and methods
  \item HELP!
  \end{enumerate}
\end{columns}
\end{frame}

\section{R}

\begin{frame}[fragile]
  \frametitle{Vectors, data frames, arrays}
<<vectors>>=
x <- c(1, 2, 3, 4, 5)
x
log(x)
x[c(3, 2)]
x[3:2]
x[c(TRUE, FALSE)]
@ 
\end{frame}

\begin{frame}[fragile]
  \frametitle{Vectors, data frames, arrays}
<<data-frames>>=
df <- data.frame(
    age = c(17, 23, 32, 37),
    sex = c("Male", "Female", "Female", "Male"))
df
df[df$age < 30 & df$sex == "Male", ]
@ 
\end{frame}

\begin{frame}[fragile]
  \frametitle{Vectors, data frames, arrays}
<<matrixs>>=
m <- matrix(1:8, 2, 4)
m
log(m)
rowSums(m)
@ 
\end{frame}

\begin{frame}[fragile]
  \frametitle{Statistical concepts}
<<stat-concepts>>=
df$sex
df$height <- c(180, 172, NA, 177)
df
@ 
\end{frame}

\begin{frame}{Functions}
  \begin{description}
  \item[\Rfunction{dir}, \Rfunction{read.table} (and friends),
    \Rfunction{scan}] List files, input data.
  \item[\Rfunction{c}, \Rfunction{factor}, \Rfunction{data.frame},
    \Rfunction{matrix}] Create objects.
  \item[\Rfunction{summary}, \Rfunction{table}, \Rfunction{xtabs}]
    Summarize, cross-tabulate variables.
  \item[\Rfunction{t.test}, \Rfunction{aov}, \Rfunction{lm},
    \Rfunction{anova}, \Rfunction{chisq.test}] Compare groups.
  \item[\Rfunction{dist}, \Rfunction{hclust}] Cluster data.
  \item[\Rfunction{plot}] Visualize data.
  \item[\Rfunction{lapply}, \Rfunction{sapply}, \Rfunction{mapply},
    \Rfunction{aggregate}] Apply a function to each element of a list or
    vector.
  \item[\Rfunction{ls}, \Rfunction{str}] List objects and their
    structure.
  \item[\Rfunction{library}, \Rfunction{search}] Attach to
    or describe the library search path.
  \end{description}
\end{frame}

\begin{frame}[fragile]
  \frametitle{Packages}
  \begin{description}
  \item[Base] \Rpackage{base}, \Rpackage{stats}, \Rpackage{graphics},
    \ldots
  \item[Recommended] \Rpackage{lattice}, \ldots
  \item[Contributed] \Rpackage{data.table}, \Rpackage{XML},
    \Rpackage{biglm}, \ldots
  \end{description}
  \begin{itemize}
  \item Install a contributed package
<<biocLite, eval=FALSE>>=
source("http://bioconductor.org/biocLite.R")
biocLite("data.table")
@ 
  \item Use during a session
<<library, eval=FALSE>>=
library(lattice)
@ 
  \end{itemize}
%% 
\end{frame}

\begin{frame}[fragile]
  \frametitle{From script to collaboration}
  Increasingly complicated tasks
  \begin{enumerate}
  \item Commands entered at the prompt
  \item Scripts and functions saved in \texttt{.R} files
  \item \texttt{.R} files and documentation ordered in packages
\begin{verbatim}
% dir MyPackage
data/ NAMESPACE DESCRIPTION man/ R/ vignettes/
\end{verbatim}
  \item Packages shared with colleagues
  \end{enumerate}
  Net result: sophisticated, highly reproducible research
\end{frame}

\begin{frame}[fragile]
  \frametitle{HELP!}
<<help, eval=FALSE>>=
help.start()
?t.test
vignette("datatable-faq")
@ 
\begin{itemize}
\item Books and training resources
\item \R{} web site and mailing
  list\footnote{\url{http://r-project.org}}
\item
  StackOverflow\footnote{\url{http://stackoverflow.com/questions/tagged/r}}
\end{itemize}
\end{frame}

\section{Bioconductor}

\begin{frame}{\Bioconductor: A short history}
  \begin{columns}[t]
    \column{.5\textwidth}
    Then
    \begin{itemize}
    \item Founded 2001
    \item Analysis and \emph{comprehension} of high throughput genomic
      data
    \item Initial focus: microarrays
    \item Reproducibility, statistical analysis, computation
    \end{itemize}

    \column{.5\textwidth}
    Now
    \begin{itemize}
    \item $>670$ software packages
    \item World-wide contributions
    \item Sequence analysis, microarrays, systems biology, flow cytometry,
      \ldots
    \end{itemize}
  \end{columns}
\end{frame}

\begin{frame}
  \includegraphics[width=\textwidth, height=!]{Bioc_website}
\end{frame}

\begin{frame}[fragile]
  \frametitle{\Bioconductor: A short history}
  \begin{center}
    \includegraphics[height=.18\textheight, width=!]{access_counts}
    \par
    \includegraphics[height=.67\textheight, width=!]{access_map}
  \end{center}
\end{frame}

\begin{frame}{Sequence Analysis (many packages!)}
\begin{tabular}{lp{.65\textwidth}}
  I/O & \Biocpkg{ShortRead} (FASTQ), \Biocpkg{Rsamtools}
  (BAM), \Biocpkg{rtracklayer} (GFF, WIG, BED),
  \Biocpkg{VariantAnnotation} (VCF), \ldots\\

  Representation & \Biocpkg{IRanges}, \Biocpkg{GenomicRanges},
  \Biocpkg{GenomicFeatures}, \Biocpkg{Biostrings},
  \Biocpkg{BSgenome}, \ldots\\


  Annotation & \Biocpkg{GenomicFeatures}, \Biocpkg{biomaRt}, 
  \Biocpkg{AnnotationHub}, \ldots.\\

  Alignment & \Biocpkg{gmapR}, \Biocpkg{Rsubread}, \Biocpkg{Biostrings}, 
  \ldots\\

  Visualization & \Biocpkg{ggbio}, \Biocpkg{Gviz}, \ldots\\

  RNA-seq & \Biocpkg{DESeq}, \Biocpkg{edgeR}, \Biocpkg{DEXSeq}, 
  \Biocpkg{cummeRbund}, \ldots \\

  ChIP-seq & \Biocpkg{DiffBind}, \Biocpkg{ChIPpeakAnno}, \ldots \\
  
  Variants & \Biocpkg{VariantAnnotation}, \Biocpkg{VariantTools}, \ldots \\
  
  Motifs & \Biocpkg{MotifDb}, \Biocpkg{seqLogo}, \ldots\\

  Work flows & \Biocpkg{QuasR},  \ldots \\

  \ldots & \ldots
\end{tabular}
\end{frame}

<<setup, echo=FALSE>>=
library(ShortRead)
op <- options(showHeadLines=3, showTailLines=1)
@ 

\begin{frame}[fragile]
  \frametitle{Classes, generics and methods}
<<readFastq>>=
library(ShortRead)
fq <- 
  readFastq("~/BigData/fastq/SRR031724_1_subset.fastq")
fq          # 'S4' class
sread(fq)   # 'generic' and 'method'; another S4 class
@ 
\end{frame}

\begin{frame}[fragile]
  \frametitle{HELP!}
  \begin{itemize}
  \item Use tab completion to find help on \emph{generics} and \emph{methods}
<<S4-help, eval=FALSE>>=
?sread
?"reverseComplement<tab>"  # tab key for completions!
?"reverseComplement,DNAStringSet-method"
@ 
  \item Discover available functions and their definition.
<<S4-discovery, eval=FALSE>>=
showMethods("reverseComplement")
showMethods(class="DNAStringSet", where=search())
selectMethod("reverseComplement", "DNAStringSet")
@ 
  \end{itemize}
\end{frame}

\begin{frame}{Acknowledgements}
  \begin{columns}[t]
    \column{.35\textwidth}
    \Bioconductor{} core
    \begin{itemize}
    \item Vince Carey
    \item Wolfgang Huber
    \item Robert Gentleman
    \item Rafael Irizzary
    \item Sean Davis
    \item Kasper Hansen
    \end{itemize}
    \column{.65\textwidth}
    \Bioconductor{} team
    \begin{itemize}
    \item Marc Carlson (annotation)
    \item Valerie Obenchain (variants, ranges)
    \item Herv\'e Pag\`es (ranges, strings)
    \item Paul Shannon (systems biology)
    \item Dan Tenenbaum (web, build)
    \end{itemize}
  \end{columns}
  \par\bigskip
  And the \Bioconductor{} community!
\end{frame}

\end{document}

%\VignetteIndexEntry{B.5 Called Variants: Manipulation and Annotation}

\SweaveOpts{keep.source=TRUE}
<<setup, echo=FALSE>>=
options(digits=2)
library(VariantAnnotation)
library(ggplot2)
library(SNPlocs.Hsapiens.dbSNP.20101109)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(BSgenome.Hsapiens.UCSC.hg19)
library(SIFT.Hsapiens.dbSNP132)
@ 

\chapter{Called Variants: Manipulation and Annotation}
\label{chpt:VariantAnnotation}

\section{Variants}

\subsection{Work flows}

The term `variant' applies to a number of different possible analyses:
\begin{itemize}
\item Single nucleotide polymorphism
\item Copy number change
\item Structural variation
\item Long-range interaction
\end{itemize}
Common steps in a variant analysis work flow include:
\begin{itemize}
\item Alignment. requires tools sensitive to variation, e.g.,
  \software{GSNAP}, \software{BWA}; \software{Bowtie} not optimized
  for this.
\item Variant calling, e.g.,
  \software{GATK}\footnote{\url{http://www.broadinstitute.org/gatk/}}
  or \Biocpkg{VariantTools}.
\item Filtering and manipulation.
\item Biological context -- variant annotation.
\item Integrative analysis, e.g., GWAS, genetical genomics, regulatory
  motifs.
\end{itemize}
This chapter explores filtering, manipulation and biological context
of variants; subsequent chapters delve into variant calling work flows
related to tumor / normal pairs (not covered in depth), and to
regulatory motifs.

\subsection{\Bioconductor{} software}

Selected \Bioconductor{} software relevant to DNA-seq work flows are
summarized in Table~\ref{tab:dnaseq}. The \Biocpkg{gmapR} package
provides access to the well-respected \software{GSNAP}
aligner. \Biocpkg{VariantTools} is an emerging tool that works with
aligned reads to call single-sample and sample-specific variants; we
will work with \Biocpkg{VariantTools} as part of this course. Packages
such as \Biocpkg{cn.mops} and \Biocpkg{exomeCopy} identify copy number
variants from high-throughput sequence data.

\Biocpkg{VariantAnnotation} provides facilities for manipulated called
variants stored in VCF files; the facilities are very flexible,
including simple range-based filtering, look-up in dbSNP, and coding
and effect prediction using standard data
bases. \Biocpkg{VariantAnnotation} plays well with
\Biocpkg{ensemblVEP} to feed data through the Ensembl Variant Effect
Predictor perl script, and to \Bioconductor{} facilities for SNP
analysis and genetical genomics like \Biocpkg{snpStats} and
\Biocpkg{GGtools}.

\begin{table}
  \centering
  \caption{Selected \Bioconductor{} packages for DNA-seq analysis.}
  \label{tab:dnaseq}
  \begin{tabular}{ll}
    Package & Description \\\hline
    \Biocpkg{VariantAnnotation} & Manipulating and annotating VCF files \\
    \Biocpkg{ensemblVEP} & Interface to the Ensembl Variant Effect
    Predictor \\

    \Biocpkg{VariantTools} & Single-sample and tumor specific variant calls \\
    \Biocpkg{gmapR} & Alignment (Linux only) \\
    
    \Biocpkg{deepSNV} & Sub-clonal SNVs in deep sequencing experiments \\
    \Biocpkg{cn.mops} & Mixture of Poissons copy number variation estimates \\
    \Biocpkg{exomeCopy} & Hidden Markov copy number variation estimates \\

    \Biocpkg{snpStats} & Down-stream GWAS; also \Biocpkg{GWAStools},
    \Biocpkg{GGtools} \\
    \hline
  \end{tabular}
\end{table}

\section{\Biocpkg{VariantAnnotation} and VCF Files}

A major product of DNASeq experiments are catalogs of called variants
(e.g., SNPs, indels).  We will use the \Biocpkg{VariantAnnotation}
package to explore this type of data.  Sample data included in the
package are a subset of chromosome 22 from the
\href{ftp://ftp-trace.ncbi.nih.gov/1000genomes/ftp/release/20110521/}{1000
  Genomes} project. Variant Call Format (VCF, see\footnote{\url{http://www.1000genomes.org/wiki/Analysis/Variant\%20Call\%20Format/vcf-variant-call-format-version-41}})
%% 
text files contain meta-information lines, a header line with
column names, data lines with information about a position in the
genome, and optional genotype information on samples for each
position.

Important operations on VCF files available with the
\Biocpkg{VariantAnnotation} package are summarized in
Table~\ref{tab:vcf-ops}.

\begin{table}
  \centering
  \caption{Working with \Rclass{VCF} files and data.} 
  \label{tab:vcf-ops}
  \begin{tabular}{lll}
    Category & Function & Description \\
    \hline

    Read & \Rfunction{scanVcfHeader} & Retrieve file header information \\
            & \Rfunction{scanVcfParam} & Select fields to read in \\
            & \Rfunction{readVcf} & Read VCF file into a VCF class \\
            & \Rfunction{scanVcf} & Read VCF file into a list \\
            & \Rfunction{readInfo}$*$ & Read a single `info' column \\
            & \Rfunction{readGeno}$*$ & Read a single `geno' matrix \\
            & \Rfunction{readGT}$*$ & Read `GT' (genotype) fields as matrix \\ 
    Filter  & \Rfunction{filterVcf} & Filter a VCF from one file to another \\
    Write   & \Rfunction{writeVcf} & Write a VCF file to disk \\

    Annotate & \Rfunction{locateVariants} & Identify
        where variant overlaps a gene annotation \\
    & \Rfunction{predictCoding} & Amino acid changes
        for variants in coding regions \\
    & \Rfunction{summarizeVariants} & Summarize variant counts
        by sample \\

    SNPs & \Rfunction{genotypeToSnpMatrix} & Convert genotypes to a SnpMatrix \\
         & \Rfunction{GLtoGP} & Convert genotype likelihoods to genotypes \\ 
         & \Rfunction{snpSummary} & Counts and distribution statistics
         for SNPs \\

    Manipulate & \Rfunction{expand} & Convert CompressedVCF to ExpandedVCF \\
    & \Rfunction{cbind}, \Rfunction{rbind} & Combine by column or row \\
    \hline
    \multicolumn{3}{l}{$*$: available in the `devel' version of \Bioconductor}
  \end{tabular}
\end{table}

\begin{Exercise}
  The objective of this exercise is to compare the quality of called
  SNPs that are located in dbSNP, versus those that are novel.

  Locate the sample data in the file system. Explore the metadata
  (information about the content of the file) using
  \Rfunction{scanVcfHeader}. Discover the `info' fields \Rcode{VT}
  (variant type), and \Rcode{RSQ} (genotype imputation quality).

  Input the sample data using \Rfunction{readVcf}. You'll need to
  specify the genome build (\Rfunarg{genome="hg19"}) on which the
  variants are annotated. Take a peak at the \Rfunction{rowData} to
  see the genomic locations of each variant.

  Data resources often adopt different naming conventions for
  sequences. For instance, dbSNP uses abbreviations such as
  \texttt{ch22} to represent chromosome 22, whereas our VCF file uses
  \texttt{22}. Use \Rfunction{rowData} and \Rfunction{seqlevels<-}
  to extract the row data of the variants, and rename the chromosomes.
\end{Exercise}

\begin{Solution}
%%
  Explore the header:
<<readVcf>>=
library(VariantAnnotation)
fl <- system.file("extdata", "chr22.vcf.gz", package="VariantAnnotation")
(hdr <- scanVcfHeader(fl))
info(hdr)[c("VT", "RSQ"),]
@
%%
  Input the data and peak at their locations:
<<readVcf>>=
(vcf <- readVcf(fl, "hg19"))
head(rowData(vcf), 3)
@
%%
  Rename chromosome levels:
<<renameSeqlevels>>=
seqlevels(vcf, force=TRUE)  <- c("22"="ch22")
@
\end{Solution}

\section{Large-scale filtering}

This section was developed from initial work by Paul Shannon.

One source of VCF files is from whole-genome sequencing and variant
calling; an example data set is from Complete Genomics, and a subset
is available in the \texttt{BigData} folder accompanying this course
<<vcf-AMI, eval=FALSE>>=
vcfDir <- "~/BigData/CompleteGenomics"
dir(vcfDir)
vcfFile <- dir(vcfDir, ".gz$", full=TRUE)
stopifnot(length(vcfFile) == 1)
@ 
%% 
The data were retrieved from the Complete Genomics web site, the first
750,000 of about 14 million variants selected, and the resulting file
compressed and indexed. Indexing makes them accessible to fast queries
using the \Rfunarg{which} argument to \Rfunction{ScanVcfParam}.

\begin{Exercise}
  The objective of this exercise is to filter the larger VCF file to a
  subset of interesting variants that we might wish to study in depth
  at a later date. We use the \Rfunction{filterVcf} function of the
  \Biocpkg{VariantAnnotation} package to perform the filtering.
  
  Start by taking a look at the (complicated) header information
<<eval=FALSE>>=
hdr <- scanVcfHeader(vcfFile)
@ 
%% 
We'll be paying attention to the \texttt{SS} INFO field, and the
\texttt{AD} GENO field. Determine the data types and possible values
for these fields, using commands like
<<eval=FALSE>>=
info(hdr)
geno(hdr)
@ 
%%
What data type would you use to represent the \texttt{SS} field for a
single or several VCF records in \R? What about the \texttt{AD} field,
across all samples?

This VCF file is big. While we can read this into memory all at once,
we will often want to `chunk' through a file, reading many (e.g., a
million) records at a time. We do this by creating a
\Rclass{TabixFile} and specifying a \Rfunarg{yieldSize} representing
the size of the chunk that we would like to read at each iteration. Create a
\Rclass{TabixFile} with \Rfunarg{yieldSize=100000} and verify with a
simple loop that the entire file appears to be processed in chunks of
the specified size, along the lines of\ldots
<<chunks, eval=FALSE>>=
tbx <- TabixFile(vcfFile, yieldSize=10000)
open(tbx)
while (len <- nrow(readVcf(tbx, "hg19")))
    cat("read", len, "rows\n")
@ 
%% 
As you can see from the chunking exercise, it takes quite a bit of
time to process these lines. To filter 14 million variants
effectively, it can pay to do a cheaper `pre-filter'. Specifically,
we're interested in variants tagged `Germline'. If we were to represents
each VCF record as an element of a character vector \Robject{x}, then
we could write a one-liner that returned \Robject{TRUE} if the line
contained the word `Germline':
<<germline-1, eval=FALSE>>=
grepl("Germline", x, fixed=TRUE)
@ 
%% 
This would be fast to read in to \R{}, and fast to perform the
filter. The \Rfunction{filterVcf} function allows us to specify a
pre-filter that works just like this. The filters are constructed
using \Rclass{FilterRules} in \Biocpkg{IRanges}, by
translating our one-liner into a simple function call, and placing the
function call into a list.
<<FitlerRules>>=
isGermline <- function(x)
    grepl("Germline", x, fixed=TRUE)
filters <- FilterRules(list(isGermline=isGermline))
@
%%
The idea is that several filters are chained together. Each filter
returns a logical vector indicating the subset of data to be processed
by the next filter.

Here is our pre-filter in action:
<<prefilter, eval=FALSE>>=
destination <- tempfile()               # temporary location
filterVcf(vcfFile, "hg19", destination, prefilters=filters)
@ 
%% 
This is pretty fast, and drops the number of variants under
consideration quite substantially, to about 110000.

Our next filter is more challenging to write. We're interested in
allelic depth, a summary of the evidence for the variant summarized in
the \texttt{AD} GENO field. There are many variants, each sample has
two values of AD, and there are two samples. This means that
\texttt{AD} is a three-dimensional array. Our filter criteria is that
the ratio of (`alternate allele' of the tumor sample \emph{or} the
`reference allele' of the the normal sample) to total reads is greater
than $0.1$. Here is a function implementing this:
<<allelicDepth>>=
allelicDepth <- function(x) 
{
    ##  ratio of AD of the 'alternate allele' for the tumor sample
    ##  OR 'reference allele' for normal samples to total reads for
    ##  the sample should be greater than some threshold (say 0.1,
    ##  that is: at least 10% of the sample should have the allele
    ##  of interest)
    ad <- geno(x)[["AD"]]
    tumorPct <- ad[,1,2,drop=FALSE] / rowSums(ad[,1,,drop=FALSE])
    normPct <- ad[,2,1, drop=FALSE] / rowSums(ad[,2,,drop=FALSE])
    test <- (tumorPct > 0.1) | (normPct > 0.1)
    !is.na(test) & test
}
@ 
We can add it to our list of filters
<<filters>>=
filters <- FilterRules(list(isGermline=isGermline, 
                            allelicDepth=allelicDepth))
@ 
%% 
To use this filter, we actually need to fully parse the VCF file into
the \Rclass{VCF} instance; the pre-filter trick used for germline
filtering is not enough. \Rfunction{filterVcf} allows us to perform a
filter on the VCF instance, too, and does so after pre-filtering
<<filterVcf, eval=FALSE>>=
destination <- tempfile()
filterVcf(vcfFile, "hg19", destination, prefilters=filters[1],
          filters=filters[2])
@
%% 
And finally input our interesting variants, confirming that we've
done our filtering as desired.
<<filterVariant-final, eval=FALSE>>=
vcf <- readVcf(destination, "hg19")
all(info(vcf)$SS == "Germline")
table(allelicDepth(vcf))
@ 
\end{Exercise}

\section{SNP Annotation}

This section is derived from a vignette by Valerie Obenchain in the
\Biocpkg{VariantAnnotation} package.

Variants can be easily identified according to region such as
\Rcode{coding}, \Rcode{intron}, \Rcode{intergenic}, \Rcode{spliceSite}
etc. Amino acid coding changes are computed for the non-synonymous
variants. SIFT and PolyPhen databases provide predictions of how
severely the coding changes affect protein function. Additional
annotations are easily crafted using the \Biocpkg{GenomicRanges} and
\Biocpkg{GenomicFeatures} software in conjunction with \Bioconductor{}
and broader community annotation resources.

\begin{Exercise}
  The \Biocannopkg{SNPlocs.Hsapiens.dbSNP.20101109} contains
  information about SNPs in a particular build of dbSNP. Load the
  package. 
  
  Review the short helper function \Rfunction{isInDbSNP}, in the
  \Rpackage{Morgan2013} package, to query whether SNPs are in the data
  base (a version of this function will be introduced to
  \Biocpkg{VariantAnnotation} before the next release)
<<isInDbSNP>>=
library(Morgan2013)
isInDbSNP
@ 

  Create a data frame containing the dbSNP membership status and
  imputation quality of each SNP. Create a density plot to illustrate
  the results.
\end{Exercise}

\begin{Solution}
  Discover whether SNPs are located in dbSNP, using our helper
  function.
<<dbSNP, eval=FALSE>>=
library(SNPlocs.Hsapiens.dbSNP.20101109)
inDbSNP <- .isInDbSNP(vcf, "ch22")
table(inDbSNP)
@
%%
  Create a data frame summarizing SNP quality and dbSNP membership:
<<SNP-quality, eval=FALSE>>=
metrics <-
    data.frame(inDbSNP=inDbSNP, RSQ=info(vcf)$RSQ)
@
%%
  Finally, visualize the data, e.g., using \Rpackage{ggplot2}
  (Figure~\ref{fig:variant-annotation:RSQ}).
<<RSQ-plot, fig=TRUE, include=FALSE, eval=FALSE>>=
library(ggplot2)
ggplot(metrics, aes(RSQ, fill=inDbSNP)) +
    geom_density(alpha=0.5) +
    scale_x_continuous(name="MaCH / Thunder Imputation Quality") +
    scale_y_continuous(name="Density") +
    theme(legend.position="top")
@

\begin{figure}
  \centering
  %% \includegraphics[width=.5\textwidth]{VariantAnnotation-RSQ-plot}
  \caption{Quality scores of variants in dbSNP, compared to those not
    in dbSNP.}
  \label{fig:variant-annotation:RSQ}
\end{figure}
\end{Solution}

\subsection{Variants in and around genes}

Variant location with respect to genes can be identified with the
\Rfunction{locateVariants} function. Regions are specified in the
\Rfunarg{region} argument and can be one of the following constructors:
\Rcode{CodingVariants()}, \Rcode{IntronVariants()},
\Rcode{FiveUTRVariants()}, \Rcode{ThreeUTRVariants()},
\Rcode{IntergenicVariants()}, \Rcode{SpliceSiteVariants()}, or
\Rcode{AllVariants()}. Location definitions are shown in
Table~\ref{table:location}.
\begin{table}
  \centering
  \caption{Variant locations}
  \label{table:location}
  \begin{tabular}{lp{.7\textwidth}}
    \hline 
    Location & Details \\ 
    \hline 
    \Rcode{coding} &  Within a coding region \\ 
    \Rcode{fiveUTR} &  Within a 5' untranslated region \\
    \Rcode{threeUTR} &   Within a 3' untranslated region \\
    \Rcode{intron} &   Within an intron region \\
    \Rcode{intergenic} & Not within a transcript associated with a gene \\
    \Rcode{spliceSite} & Overlaps any of the first or last 2 nucleotides of an
    intron \\
    \hline
  \end{tabular}
\end{table}

\begin{Exercise}
  Load the \Biocannopkg{TxDb.Hsapiens.UCSC.hg19.knownGene} annotation
  package, and read in the \texttt{chr22.vcf.gz} example file from the
  \Biocpkg{VariantAnnotation} package.
  
  Remembering to re-name sequence levels, use the
  \Rfunction{locateVariants} function to identify coding variants.
  
  Summarize aspects of your data, e.g., did any coding variants match
  more than one gene? How many coding variants are there per gene ID?
\end{Exercise}

\begin{Solution}
  Here we open the known genes data base, and read in the VCF file.
%% 
<<seqlevels_rename>>=
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene 

fl <- system.file("extdata", "chr22.vcf.gz", package="VariantAnnotation")
vcf <- readVcf(fl, "hg19")
seqlevels(vcf, force=TRUE) <- c("22"="chr22")
@ 
%%
  The next lines locate coding variants.
<<locateVariants_find>>=
rd <- rowData(vcf)
loc <- locateVariants(rd, txdb, CodingVariants())
head(loc, 3)
@ 
% 
  To answer gene-centric questions data can be summarized by gene
  regardless of transcript.
%% 
<<locateVariants_example>>=
## Did any coding variants match more than one gene?
splt <- split(loc$GENEID, loc$QUERYID)
table(sapply(splt, function(x) length(unique(x)) > 1))

## Summarize the number of coding variants by gene ID
splt <- split(loc$QUERYID, loc$GENEID)
head(sapply(splt, function(x) length(unique(x))), 3)
@
\end{Solution}

\subsection{Amino acid coding changes}

\Rfunction{predictCoding} computes amino acid coding changes for
non-synonymous variants. Only ranges in \Rcode{query} that overlap
with a coding region in \Rcode{subject} are considered. Reference
sequences are retrieved from either a \Robject{BSgenome} or fasta file
specified in \Rcode{seqSource}.  Variant sequences are constructed by
substituting, inserting or deleting values in the \Robject{varAllele}
column into the reference sequence. Amino acid codes are computed for
the variant codon sequence when the length is a multiple of 3.

The \Rfunarg{query} argument to \Rfunction{predictCoding} can be a
\Robject{GRanges} or \Robject{VCF}. When a \Robject{GRanges} is
supplied the \Rfunarg{varAllele} argument must be specified. In the
case of a \Robject{VCF} object, the alternate alleles are taken from
\Rcode{alt(<VCF>)} and the \Rfunarg{varAllele} argument is not
specified.

The result is a modified \Rcode{query} containing only variants that
fall within coding regions. Each row represents a variant-transcript
match so more than one row per original variant is possible.

<<predictCoding>>=
library(BSgenome.Hsapiens.UCSC.hg19)
coding <- predictCoding(vcf, txdb, seqSource=Hsapiens)
coding[5:9]
@
%% 
Using variant rs114264124 as an example, we see \Rcode{varAllele}
\Rcode{A} has been substituted into the \Rcode{refCodon} \Rcode{CGG}
to produce \Rcode{varCodon} \Rcode{CAG}. The \Rcode{refCodon} is the
sequence of codons necessary to make the variant allele substitution
and therefore often includes more nucleotides than indicated in the
range (i.e. the range is 50302962, 50302962, width of 1).  Notice it
is the second position in the \Rcode{refCodon} that has been
substituted. This position in the codon, the position of substitution,
corresponds to genomic position 50302962. This genomic position maps
to position 698 in coding region-based coordinates and to triplet 233
in the protein. This is a non-synonymous coding variant where the
amino acid has changed from \Rcode{R} (Arg) to \Rcode{Q} (Gln).

When the resulting \Rcode{varCodon} is not a multiple of 3 it cannot
be translated. The consequence is considered a \Rcode{frameshift} and
\Robject{varAA} will be missing.

<<predictCoding_frameshift>>=
coding[coding$CONSEQUENCE == "frameshift"]
@

\subsection{SIFT and PolyPhen databases}

From \Rfunction{predictCoding} we identified the amino acid coding
changes for the non-synonymous variants. For this subset we can
retrieve predictions of how damaging these coding changes may be. SIFT
(Sorting Intolerant From Tolerant) and PolyPhen (Polymorphism
Phenotyping) are methods that predict the impact of amino acid
substitution on a human protein. The SIFT method uses sequence
homology and the physical properties of amino acids to make
predictions about protein function. PolyPhen uses sequence-based
features and structural information characterizing the substitution to
make predictions about the structure and function of the protein.

Collated predictions for specific dbSNP builds are available as
downloads from the SIFT and PolyPhen web sites. These results have
been packaged into \Rpackage{SIFT.Hsapiens.dbSNP132.db} and
\Rpackage{PolyPhen.Hapiens.dbSNP131.db} and are designed to be
searched by rsid. Variants that are in dbSNP can be searched with
these database packages. When working with novel variants, SIFT and
PolyPhen must be called directly. See references for home pages.

Identify the non-synonymous variants and obtain the rsids.
<<nonsynonymous>>=
nms <- names(coding)
idx <- coding$CONSEQUENCE == "nonsynonymous"
nonsyn <- coding[idx]
names(nonsyn) <- nms[idx]
rsids <- unique(names(nonsyn)[grep("rs", names(nonsyn), fixed=TRUE)])
@
%% 
Detailed descriptions of the database columns can be found with
\Rcode{?SIFTDbColumns} and \Rcode{?PolyPhenDbColumns}. Variants in
these databases often contain more than one row per variant. The
variant may have been reported by multiple sources and therefore the
source will differ as well as some of the other variables.

<<sift>>=
library(SIFT.Hsapiens.dbSNP132)

## rsids in the package 
head(keys(SIFT.Hsapiens.dbSNP132), 3)
## list available columns
cols(SIFT.Hsapiens.dbSNP132)
## select a subset of columns
## a warning is thrown when a key is not found in the database
subst <- c("RSID", "PREDICTION", "SCORE", "AACHANGE", "PROTEINID")
sift <- select(SIFT.Hsapiens.dbSNP132, keys=rsids, cols=subst)
head(sift, 3)
@

PolyPhen provides predictions using two different training datasets
and has considerable information about 3D protein structure. See
\Rcode{?PolyPhenDbColumns} or the PolyPhen web site listed in the
references for more details.

\section{Annotation with \Biocpkg{ensemblVEP}}

\WARNING{This section requires an internet connection and additional
  software, and has been removed from the lab}. As an alternative,
consider working through the \Biocpkg{ensemblVEP} vignette, available
from the \Bioconductor{} web
site\footnote{\url{http://bioconductor.org/packages/release/bioc/html/ensemblVEP.html}}. This
section requires that \software{perl} is installed, and that the
Ensembl VEP perl script is available; see instructions in the
\Biocpkg{ensemblVEP}
README\footnote{\url{http://bioconductor.org/packages/release/bioc/readmes/ensemblVEP/README}}. The
necessary preconditions are tested by the following code;
\Rcode{VEP\_OK} should be \Rcode{TRUE}.

<<ensemblVEP-setup>>=
CONNECTION_OK <- tryCatch({ 
    con <- url("http://google.com", "r"); close(con); TRUE
}, error=function(...) FALSE)

VEP_OK <- CONNECTION_OK && require(ensemblVEP) && tryCatch({
    file.exists(ensemblVEP:::.getVepPath())
}, error=function(...) FALSE)
stopifnot(VEP_OK)
@ 

Functionality of the Ensembl VEP is given
on-line\footnote{\url{http://www.ensembl.org/info/docs/variation/vep/}}
and in \cite{mclaren2010deriving}.

%\VignetteIndexEntry{1.3 Sequence analysis}

\chapter{Sequencing}

\begin{Exercise}
  Set up your system to do the exercises in this lab. In addition to
  the packages you were asked to install prior to the course, you'll
  need to install the \Rpackage{Morgan2013} package and
  \texttt{BigData} directory of sample data files. Do this following
  the instructions in the lab. The following line MUST succeed
<<test>>=
SYSTEM_OK <- getRversion() > "3.0" && require(Morgan2013, quietly=TRUE)
stopifnot(SYSTEM_OK)
@ 
  %% 
  In addition, some of the exercises require access to data files. These
  should be installed at a convenient place; the exercises assume that
  the files are at the location returned by
<<BigData-path, eval=FALSE>>=
path.expand("~/BigData")
@ 
  %%
  There should be a total of 39 files
<<BigData-length>>=
stopifnot(length(dir("~/BigData", recursive=TRUE)) == 39)
@ 
\end{Exercise}

Recent technological developments introduce high-throughput sequencing
approaches. A variety of experimental protocols and analysis work
flows address gene expression, regulation, and encoding of genetic
variants. Experimental protocols produce a large number (tens to
hundreds of millions per sample) of short (e.g., 35-100's, single or
paired-end) nucleotide sequences. These are aligned to a reference or
other genome. Analysis work flows use the alignments to infer levels
of gene expression (RNA-seq), binding of regulatory elements to
genomic locations (ChIP-seq), or prevalence of structural variants
(e.g., SNPs, short indels, large-scale genomic rearrangements). Sample
sizes range from minimal replication (e.g,. 2 samples per treatment
group) to thousands of individuals.

\section{Technologies}

The most common `second generation' technologies readily available to
labs are
\begin{packeditemize}
\item Illumina single- and paired-end reads. Short ($\sim 100$ per
  end) and very numerous. Flow cell, lane, bar-code.
\item Roche 454. 100's of nucleotides, 100,000's of reads.
\item Life Technologies SOLiD. Unique `color space' model.
\item Complete Genomics. Whole genome sequence / variants / etc as a
  service; end user gets derived results.
\end{packeditemize}
Figure~\ref{fig:pcr} illustrates Illumina and 454
sequencing. \Bioconductor{} has good support for Illumina and Roche
454 sequencing products, and for derived data such as aligned reads or
called variants; use of SOLiD color space reads typically requires
conversion to FASTQ files that undermine the benefit of the color
space model.

\begin{figure}
  \centering
  \begin{minipage}[c]{.4\textwidth}
    \includegraphics[width=\textwidth, height=!]{Solexa-bridge-pcr}
  \end{minipage}
  \hfil
  \begin{minipage}[c]{.4\textwidth}
    \includegraphics[width=\textwidth, height=!]{nbt1485-F1}
  \end{minipage}
  \caption{High-throughput sequencing. Left: Illumina bridge
    PCR~\cite{bentley2008}; mis-call errors. Right: Roche
    454~\cite{rothberg2008}; homopolymer errors.}
  \label{fig:pcr}
\end{figure}

All second-generation technologies rely on PCR and other techniques to
generate reads from samples that represent aggregations of many DNA
molecules.  `Third-generation' technologies shift to single-molecule
sequencing, with relevant players including Pacific Biosciences and
IonTorent. This data is not widely available, and will not be
discussed further.

The most common data in \Bioconductor{} work flows is from Illumina
sequencers. Reads are either single-end or paired-end. Single-end
reads represent $30-\sim100$ nucleotides sequenced from DNA that
has been sheared into $\sim300$ nucleotide fragments. Paired-end
reads represent $30-\sim100$ nucleotide reads that are paired, and
from both ends of the $\sim300$ fragment.

Sequence data can be derived from a tremendous diversity of
experiments. Some of the most common include:
\begin{packeddescription}
\item [RNA-seq] Sequencing of reverse-complemented mRNA from the
  entire expressed transcriptome, typically. Used for
  \emph{differential expression} studies like micro-arrays, or for
  \emph{novel transcript discovery}.
\item [DNA-seq] Sequencing of whole or targeted (e.g., exome) genomic
  DNA. Common goals include \emph{SNP} detection, \emph{indel} and
  other structural polymorphisms, and \emph{CNV} (copy number
  variation). DNA-seq is also used for \emph{de novo} assembly, but
  \emph{de novo} assembly is not an area where \Bioconductor{}
  contributes.
\item [ChIP-seq] ChIP (chromatin immuno-precipitation) is used to
  enrich genomic DNA for regulatory elements, followed by sequencing
  and mapping of the enriched DNA to a reference genome. The initial
  statistical challenge is to identify regions where the mapped reads
  are enriched relative to a sample that did not undergo
  ChIP\cite{pmid19736561}; a subsequent task is to identify
  differential binding across a designed experiment, e.g.,
  \cite{ross2012differential}.
\item [Metagenomics] Sequencing generates sequences from samples
  containing multiple species, typically microbial communities sampled
  from niches such as the human oral cavity. Goals include inference
  of \emph{species composition} (when sequencing typically targets
  phylogenetically informative genes such as 16S) or \emph{metabolic
    contribution}.
\end{packeddescription}

\section{Data}

As a running example, we use the \emph{pasilla} data set, derived from
\cite{pasilla}. The authors investigate conservation of RNA
regulation between \Dmel{} and mammals. Part of their study used RNAi
and RNA-seq to identify exons regulated by Pasilla (\emph{ps}), the
\Dmel{} ortholog of mammalian NOVA1 and NOVA2. Briefly, their
experiment compared gene expression as measured by RNAseq in S2-DRSC
cells cultured with, or without, a 444bp dsRNA fragment corresponding
to the \emph{ps} mRNA sequence. Their assessment investigated
differential exon use, but our worked example will focus on gene-level
differences.  For several examples we look at a subset of the
\emph{ps} data, corresponding to reads obtained from lanes of their
RNA-seq experiment, and to the same reads aligned to a \Dmel{}
reference genome. Reads were obtained from GEO and the Short Read
Archive (SRA), and were aligned to the \Dmel{} reference genome
\emph{dm3} as described in the \Rpackage{pasilla} experiment data
package.

At a very high level, one can envision a work flow that starts with a
challenging biological question (how does \emph{ps} influence gene and
transcript regulation?). The biological question is framed in terms of
wet-lab protocols coupled with an appropriate and all-important
experimental design. There are several well-known statistical issues
at this stage, common to any experimental data. What treatments are
going to be applied? How many replicates will there be of each? Is
there likely to be sufficient power to answer the biologically
relevant question?  Reality is also important at this stage, as
evidenced in the \emph{pasilla} data where, as we will see, samples
were collected using different methods (single versus paired end
reads) over a time when there were rapid technological changes. Such
reality often introduces confounding factors that require appropriate
statistical treatment in subsequent analysis.

The work flow proceeds with data generation, involving both a wet-lab
(sample preparation) component and actual sequencing. It is essential
to acknowledge the biases and artifacts that are introduced at each of
these stages. Sample preparation involves non-trivial amounts of time
and effort. Large studies are likely to have batch effects (e.g.,
because work was done by different lab members, or different batches
of reagent). Samples might have been prepared in ways that are likely
to influence down-stream analysis, e.g., using a protocol involving
PCR and hence introducing opportunities for sample-specific bias. DNA
isolation protocols may introduce many artifacts, e.g., non-uniform
representation of reads across the length of expressed genes in
RNA-seq.  The sequencing reaction itself is far from bias-free, with
known artifacts of called base frequency, cycle-dependent accuracy and
bias, non-uniform coverage, etc. At a minimum, the researcher needs to
be aware of the opportunities for bias that can be introduced during
sample preparation and sequencing.

The informatics component of work flows becomes increasing important
during and after sequence generation.  The sequencer is often treated
as a `black box', producing short reads consisting of 10's to 100's of
nucleotides and with associated quality scores. Usually, the chemistry
and informatics processing pipeline are sufficiently well documented
that one can arrive at an understanding of biases and quality issues
that might be involved; such an understanding is likely to be
particularly important when embarking on questions or using protocols
that are at the fringe of standard practice (where, after all, the
excitement is).  

The first real data seen by users are \emph{fastq} files
(Table~\ref{tab:seq:fileformats}). These files are often simple text
files consisting of many millions of records, and are described in
greater detail in Section~\ref{sec:ShortRead}. The center performing
the sequencing typically vets results for quality, but these quality
measures are really about the performance of their machines. It is
very important to assess quality with respect to the experiment being
undertaken -- Are the numbers of reads consistent across samples? Are
GC content and other observable aspects of the reads consistent with
expectation? Are there anomalies in the sequence results that reflect
primers or other reagents used during sample preparation? Are
well-known artifacts of the experimental protocol evident in the reads
in hand?

\begin{table}
  \centering
  \caption{Common file types (e.g.,
    \url{http://genome.ucsc.edu/FAQ/FAQformat.html}) and
    \Bioconductor{} packages used for input.}
  \label{tab:seq:fileformats}
  \begin{tabular}{lp{.6\textwidth}l}
    File & Description & Package \\
    \hline
    FASTQ & Unaligned sequences: identifier, sequence, and encoded
    quality score tuples & \Biocpkg{ShortRead}\\

    BAM & Aligned sequences: identifier, sequence, reference sequence
    name, strand position, cigar and additional tags &
    \Biocpkg{Rsamtools} \\
    
    GFF, GTF & Gene annotations: reference sequence name, data source,
    feature type, start and end positions, strand, etc. &
    \Biocpkg{rtracklayer}\\
    
    BED & Range-based annotation: reference sequence name, start, end
    coordinates. & \Biocpkg{rtracklayer}\\
    
    WIG, bigWig & `Continuous' single-nucleotide annotation. &
    \Biocpkg{rtracklayer}\\
    
    VCF & Called single nucleotide, indel, copy number, and structural
    variants, often compressed and indexed (with \Biocpkg{Rsamtools}
    \Rfunction{bgzip}, \Rfunction{indexTabix}) &
    \Biocpkg{VariantAnnotation} \\ \hline

  \end{tabular}
\end{table}

The next step in many work flows involves alignment of reads to a
reference genome.  There are many aligners available, including
\href{http://bio-bwa.sourceforge.net/}{BWA} \cite{pmid20080505},
\href{http://bowtie-bio.sourceforge.net/}{Bowtie} /
\href{http://bowtie-bio.sourceforge.net/bowtie2/}{Bowtie2}
\cite{pmid19261174}, and
\href{http://research-pub.gene.com/gmap/}{GSNAP}; merits of these are
discussed in the literature. \Bioconductor{} packages `wrapping' these
tools are increasingly common (e.g., \Biocpkg{Rbowtie},
\Biocpkg{gmapR}; \Biocpkg{cummeRbund} for parsing output of the
\software{cufflinks} transcript discovery pathway). There are also
alignment algorithms implemented in \Bioconductor{} (e.g.,
\Rfunction{matchPDict} in the \Biocpkg{Biostrings} package, and the
\Biocpkg{Rsubread} package); \Rfunction{matchPDict} is particularly
useful for flexible alignment of moderately sized subsets of
data. Most main-stream aligners produce output in `SAM' or `BAM'
(binary alignment) format. BAM files are the primary starting point
for many analyses, and their manipulation and use in \Bioconductor{}
is introduced in Section~\ref{sec:Rsamtools}.

Common analyses often use well-established third-party tools for
initial stages of the analysis; some of these have \Bioconductor{}
counterparts that are particularly useful when the question under
investigation does not meet the assumptions of other facilities. Some
common work flows (a more comprehensive list is available on the
SeqAnswers wiki\footnote{\url{http://seqanswers.com/wiki/RNA-Seq}})
include:
\begin{packeddescription}
\item [ChIP-seq] ChIP-seq experiments typically use DNA sequencing to
  identify regions of genomic DNA enriched in prepared samples
  relative to controls. A central task is thus to identify peaks, with
  common tools including \software{MACS} and
  \software{PeakRanger}.
\item [RNA-seq] In addition to the aligners mentioned above, RNA-seq
  for differential expression might use the
  \software{HTSeq}\footnote{\url{http://www-huber.embl.de/users/anders/HTSeq/doc/overview.html}}
  python tools for counting reads within regions of interest (e.g.,
  known genes) or a pipeline such as the \software{bowtie} (basic
  alignment) / \software{tophat} (splice junction mapper) /
  \software{cufflinks} (esimated isoform abundance)
  (e.g., \footnote{\url{http://bowtie-bio.sourceforge.net/index.shtml}})
  or
  \software{RSEM}\footnote{\url{http://deweylab.biostat.wisc.edu/rsem/}}
  suite of tools for estimating transcript abundance.
\item [DNA-seq] especially variant calling can be facilitated by
  software such as the
  GATK\footnote{\url{http://www.broadinstitute.org/gatk/}} toolkit.
\end{packeddescription}
There are many \R{} packages that replace or augment the analyses
outlined above.

Programs such as those outlined the previous paragraph often rely on
information about gene or other structure as input, or produce
information about chromosomal locations of interesting features. The
GTF and BED file formats are common representations of this
information. Representing these files as \R{} data structures is often
facilitated by the \Biocpkg{rtracklayer} package. We explore these
files in the lab on gene and genome annotation.  Variants are very
commonly represented in VCF (Variant Call Format) files; these are
explored in the lab on variants.

\section{\emph{Bioconductor} for sequence analysis}

Table~\ref{tab:bioc-sequence-pkgs} enumerates some of the packages
available for sequence analysis. The table includes packages for
representing sequence-related data (e.g., \Biocpkg{GenomicRanges},
\Biocpkg{Biostrings}), as well as domain-specific analysis such as
RNA-seq (e.g., \Biocpkg{edgeR}, \Biocpkg{DESeq2}), ChIP-seq
(e.g,. \Biocpkg{ChIPpeakAnno}, \Biocpkg{DiffBind}), variants (e.g.,
\Biocpkg{VariantAnnotation}, \Biocpkg{VariantTools}, and SNPs and copy
number variation (e.g., \Biocpkg{genoset}, \Biocpkg{ggtools}).


\begin{table}
  \centering
  \caption{Selected \Bioconductor{} packages for high-throughput
    sequence analysis.}
  \label{tab:bioc-sequence-pkgs}
  \begin{tabular}{lp{.65\textwidth}}
    Concept & Packages\\
    \hline

    Data representation & \Biocpkg{IRanges}, \Biocpkg{GenomicRanges},
    \Biocpkg{GenomicFeatures}, \Biocpkg{Biostrings},
    \Biocpkg{BSgenome}, \Biocpkg{girafe}.\\

    Input / output & \Biocpkg{ShortRead} (fastq), \Biocpkg{Rsamtools}
    (bam), \Biocpkg{rtracklayer} (gff, wig, bed),
    \Biocpkg{VariantAnnotation} (vcf), \Biocpkg{R453Plus1Toolbox}
    (454).\\

    Annotation & \Biocpkg{GenomicFeatures}, \Biocpkg{ChIPpeakAnno},
    \Biocpkg{VariantAnnotation}.\\

    Alignment & \Biocpkg{gmapR}, \Biocpkg{Rsubread}, \Biocpkg{Biostrings}.\\

    Visualization & \Biocpkg{ggbio}, \Biocpkg{Gviz}.\\

    Quality assessment & \Biocpkg{qrqc}, \Biocpkg{seqbias},
    \Biocpkg{ReQON}, \Biocpkg{htSeqTools}, \Biocpkg{TEQC},
    \Biocpkg{Rolexa}, \Biocpkg{ShortRead}.\\

    RNA-seq & \Biocpkg{BitSeq}, \Biocpkg{cqn}, \Biocpkg{cummeRbund},
    \Biocpkg{DESeq2}, \Biocpkg{DEXSeq}, \Biocpkg{EDASeq},
    \Biocpkg{edgeR}, \Biocpkg{gage}, \Biocpkg{goseq},
    \Biocpkg{iASeq}, \Biocpkg{tweeDEseq}.\\

    ChIP-seq, etc. & \Biocpkg{BayesPeak}, \Biocpkg{baySeq},
    \Biocpkg{ChIPpeakAnno}, \Biocpkg{chipseq}, \Biocpkg{ChIPseqR},
    \Biocpkg{ChIPsim}, \Biocpkg{CSAR}, \Biocpkg{DiffBind},
    \Biocpkg{MEDIPS}, \Biocpkg{mosaics}, \Biocpkg{NarrowPeaks},
    \Biocpkg{nucleR}, \Biocpkg{PICS}, \Biocpkg{PING},
    \Biocpkg{REDseq}, \Biocpkg{Repitools}, \Biocpkg{TSSi}.\\
    
    Variants & \Biocpkg{VariantAnnotation}, \Biocpkg{VariantTools},
    \Biocpkg{gmapR} \\
    
    SNPs & \Biocpkg{snpStats}, \Biocpkg{GWASTools},
    \Biocpkg{hapFabia}, \Biocpkg{GGtools} \\

    Copy number & \Biocpkg{cn.mops}, \Biocpkg{genoset},
    \Biocpkg{CNAnorm}, \Biocpkg{exomeCopy}, \Biocpkg{seqmentSeq}.\\

    Motifs & \Biocpkg{MotifDb}, \Biocpkg{BCRANK}, \Biocpkg{cosmo}, \Biocpkg{cosmoGUI},
    \Biocpkg{MotIV}, \Biocpkg{seqLogo}, \Biocpkg{rGADEM}.\\

    3C, etc. & \Biocpkg{HiTC}, \Biocpkg{r3Cseq}.\\

    Microbiome & \Biocpkg{phyloseq}, \Biocpkg{DirichletMultinomial},
    \Biocpkg{clstutils}, \Biocpkg{manta}, \Biocpkg{mcaGUI}.\\

    Work flows & \Biocpkg{QuasR}, \Biocpkg{easyRNASeq}, 
    \Biocpkg{ArrayExpressHTS}, \Biocpkg{Genominator}, 
    \Biocpkg{oneChannelGUI}, \Biocpkg{rnaSeqMap}.\\

    Database & \Biocpkg{SRAdb}.\\

    \hline
  \end{tabular}
\end{table}

%\VignetteIndexEntry{B.6 Visualizing Sequence Data}

\chapter{Visualizing Sequence Data}

\R{} has some great visualization packages; essential references
include \cite{chang2012r} for a general introduction,
Murrell~\cite{murrell2005r} for base graphics,
Sarkar~\cite{sarkar2008lattice} for \Rpackage{lattice}, and
Wickham~\cite{wickham2009ggplot2} for \Rpackage{ggplot2}. Here we take
a quick tour of visualization facilities tailored for sequence data
and using \Bioconductor{} approaches. Our focus is on \Biocpkg{Gviz};
an exercise explores interactive visualization using \Rpackage{shiny}.

\section{\Biocpkg{Gviz}}

The \Biocpkg{Gviz} package produces very elegant images organized in a
more-or-less familiar `track' format. The following exercises walk
through the \Biocpkg{Gviz}
\href{http://bioconductor.org/packages/2.12/bioc/html/Gviz.html}{User
  guide} Section 2.

\begin{Exercise}
  Load the \Biocpkg{Gviz} package and sample \Rclass{GRanges}
  containing genomic coordinates of CpG islands. Create a couple of
  variables with information on the chromosome and genome of the data
  (how can this information be extracted from the \Robject{cpgIslands}
  object?).
\end{Exercise}
<<Gviz>>=
library(Gviz)
data(cpgIslands)
chr <- "chr7"
genome <- "hg19"
@ 
%% 
The basic idea is to create a track, perhaps with additional
attributes, and to plot it. There are different types of track, and we
create these one at a time. We start with a simple annotation track
<<AnnotationTrack>>=
atrack <- AnnotationTrack(cpgIslands, name="CpG")
plotTracks(atrack)
@ 
%% 
Then add a track that represents genomic coordinates. Tracks are
combined when plotted, as a simple list. The vertical ordering
of tracks is determined by their position in the list.
<<GenomeAxisTrack>>=
gtrack <- GenomeAxisTrack()
plotTracks(list(gtrack, atrack))
@ 
%% 
We can add an ideogram to provide overall orientation\ldots
<<IdeogramTrack>>=
itrack <- IdeogramTrack(genome=genome, chromosome=chr)
plotTracks(list(itrack, gtrack, atrack))
@
%% 
and a more elaborate gene model, as an \Rclass{data.frame} or
\Rclass{GRanges} object with specific columns of metadata.
<<GeneRegionTrack>>=
data(geneModels)
grtrack <- 
    GeneRegionTrack(geneModels, genome=genome,
                    chromosome=chr, name="Gene Model")
tracks <- list(itrack, gtrack, atrack, grtrack)
plotTracks(tracks)
@ 
%% 
Zooming out changes the location box on the ideogram
<<Gviz-zoom>>=
plotTracks(tracks, from=2.5e7, to=2.8e7)
@ 
%% 
When zoomed in we can add sequence data
<<Gviz-sequence>>=
library(BSgenome.Hsapiens.UCSC.hg19)
strack <- SequenceTrack(Hsapiens, chromosome=chr)
plotTracks(c(tracks, strack), from=26450430, to=26450490, cex=.8)
@ 

As the \Biocpkg{Gviz} vignette humbly says, `so far we have replicated
the features of a whole bunch of other genome browser tools out
there`. We'd like to be able integrate our data into these plots, with
a rich range of plotting options. The key is the \Rfunction{DataTrack}
function, which we demonstrate with some simulated data; this final
result is shown in Figure~\ref{fig:GvizFinal}.
<<Gviz-data>>=
## some data
lim <- c(26700000, 26900000)
coords <- seq(lim[1], lim[2], 101)
dat <- runif(length(coords) - 1, min=-10, max=10)

## DataTrack
dtrack <- 
    DataTrack(data=dat, start=coords[-length(coords)],
              end= coords[-1], chromosome=chr, genome=genome,
              name="Uniform Random")
plotTracks(c(tracks, dtrack))
@
%% 
<<Gviz-figure, echo=FALSE>>=
pdf("GvizFigure.pdf")
plotTracks(c(tracks, dtrack))
xx <- capture.output(dev.off())
@ 
Section~4.3 of the \Biocpkg{Gviz} vignette illustrates flexibility of
the data track.

\begin{figure}
  \centering
  \caption{\Biocpkg{Gviz} ideogram, genome coordinate, annotation, and data tracks.}
  \label{fig:GvizFinal}
  \includegraphics[width=.6\textwidth, height=!]{GvizFigure}
\end{figure}

\section{\Biocpkg{ggbio}}

The \Biocpkg{ggbio} package complements facilities in
\Biocpkg{Gviz}. It uses the central metaphors of the `grammar of
graphics' made popular by the \Rpackage{ggplot2} package, and
integrates closely with the \Bioconductor{} ranges infrastructure. For
example, the \Rfunction{autoplot} function applied to a
\Biocpkg{Rsamtools} \Rclass{BamFile} instances results in a coverage
plot. In addition to the grammar of graphics approach, the package
offers a wider range of plots, for instance circular plots. The use of
the package is covered in it's vignette.


\section{\Rpackage{shiny} for easy interactive reports}

As a final example of visualization, the \Rpackage{shiny} package and
web site\footnote{\url{http://www.rstudio.com/shiny/}} has recently
been introduced. It offers a new model for developing interactive,
browser-based visualizations. These visualizations could be an
excellent way to provide sophisticated exploratory or summary analysis
in a very accessible way. The idea is to write a `user interface'
component that describes how a page is to be presented to users, and a
`server' that describes how the data are to be calculated or modified
in responses to user choices. The programming model is `reactive',
where changes in a user choice automatically trigger re-calculations
in the server. This reactive model is like in a spreadsheet with a
formula, where adjusting a cell that the formula references triggers
re-calculation of the formula. As with a spreadsheet, someone creating
a \Rpackage{shiny} application does not have to work hard to make
reactivity work.

\begin{Exercise}
  We explore \Rpackage{shiny} by creating a simple application based
  on the \Biocannopkg{parathyroidSE} package. Start by copying the
  directory returned by
<<shiny-loc, eval=FALSE>>=
system.file(package="Morgan2013", "shiny")
@ 
%% 
to a convenient location on your disk, e.g., \texttt{~/shiny}. Start
\R{} and evaluate the commands
<<shiny-server, eval=FALSE>>=
library(shiny)
runApp("~/shiny/se-app0")
@ 
%% 
Where the path is correct for the location where you placed the
\texttt{shiny} folder. This should launch a web browser, with a simple
\Rpackage{shiny} application.

Add features to the user interface. Do this by adding commands to the
file \texttt{~/shiny/se-app0/ui.R} in the \Rfunction{sidebarPanel}
function. Add: (a) a \Rfunction{checkboxInput} to indicate that the
user would like to see the experiment data; and (b) a
\Rfunction{checkboxInput} to indicate that the user would like to see
the column (sample) data. Add some output to \Rfunction{mainPanel}, in
particular \Rfunction{verbatimTextOutput} for an overview of a
\Rclass{SummarizedExperiment}. Use the \Rpackage{shiny} help pages and
\texttt{~/shiny/se-app1/ui.R} as a guide to correct syntax. 

Re-load the browser page of the shiny app to check that the changes
you have made are correct.

Add functionality to the \texttt{~/shiny/se-app0/server.R}. Start by
loading the \Biocannopkg{parathyroidSE} data package. Then update the
body of \Rfunction{shinyServer} by: (a) writing a \Rfunction{reactive}
code chunk that evaluates \Rcode{data(parathyroidGenesSE)} to load the
data in to \R{}, and then returns the \Robject{parathyroidGenesSE}
object; (b) a \Rfunction{renderPrint} code chunk that assigns to the
\Robject{output} list the result of \Rfunction{print}'ing the object
returned by the reactive function; and (c) additional
\Rfunction{renderPrint} and \Rfunction{renderTable} functions to
finish the implementation of the server. Consult the \Rpackage{shiny}
package and \texttt{~/shiny/se-app1/server} file for the correct
syntax.

`Kill' the running app (cntrl-C in the \R{} session in which is was
created?), and reload the app with \Rcode{runApp("~/shiny/se-app0")}.

Add additional functionality that would help the user to understand
the data present in the \Robject{parathyroidGenesSE} instance.
\end{Exercise}

%% \VignetteIndexEntry{Talk: Annotation}

\documentclass[a4paper, notitlepage]{beamer}

\usepackage{BioconductorSlides}

\title{Annotation }
\author{
  Martin
  Morgan\footnote{\href{mailto:mtmorgan@fhcrc.org}{mtmorgan@fhcrc.org}}
}
\date{June 23 -- 28, 2013}

<<setup, echo=FALSE>>=
library(Morgan2013)
op <- options(prompt="  ", continue="  ")
@ 

\begin{document}

\begin{frame}
  \maketitle
\end{frame}

\begin{frame}{Overview}
  \begin{enumerate}
  \item Annotation
    \begin{itemize}
    \item Genes
    \item Gene models
    \item Web / cloud resources
    \end{itemize}
  \item Called variants
    \begin{itemize}
    \item VCF files
    \item Variant annotation
    \end{itemize}
  \end{enumerate}
\end{frame}

\begin{frame}[fragile]{Genes: \Rpackage{org.*} \& friends}
  Gene-centric annotation packages\footnote{\url{http://bioconductor.org/packages/release/BiocViews.html}}
  \begin{itemize}
  \item Organism: \Biocannopkg{org.Hs.eg.db}, \ldots
  \item Pathway: \Biocannopkg{GO.db}, \ldots
  \item Microarray: \Biocannopkg{hgu95av2.db}, \ldots
  \item And: \Biocpkg{MotifDb}, \ldots
  \end{itemize}
  The `select' interface
<<select, eval=FALSE>>=
library(org.Hs.eg.db)
keytypes(org.Hs.eg.db)       # available queries
keys(org.Hs.eg.db, "SYMBOL") # possible 'SYMBOL' values
cols(org.Hs.eg.db)           # available return values
select(org.Hs.eg.db, "TERT", keytype="SYMBOL",
    c("ENTREZID", "GENENAME", "GO"))
@ 
\end{frame}

\begin{frame}[fragile]{Gene models: \Rpackage{TxDb.*}}
  \begin{itemize}
  \item Exon and transcript coordinates for model organisms
  \item `Select' interface -- \Rfunction{keytypes}, \Rfunction{keys},
    \Rfunction{cols}, \Rfunction{select}
  \end{itemize}
<<TxDb-select, eval=FALSE>>=
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
select(txdb, "7015", keytype="GENEID", "TXNAME")
@ 
  \begin{itemize}
  \item \Rclass{GRanges} queries: \Rfunction{transcripts},
    \Rfunction{exons}, \Rfunction{cds}, \Rfunction{promoters}
  \item \Rclass{GRangesList} queries: \Rfunction{transcriptsBy},
    \Rfunction{exonsBy}, \Rfunction{cdsBy},
    \Rfunction{intronsByTranscript}, \Rfunction{fiveUTRsByTranscript},
    \Rfunction{threeUTRsByTranscript}
  \end{itemize}
<<TxDb-exonsBy, eval=FALSE>>=
exonsBy(txdb, "tx")
exonsBy(txdb, "gene")["7015"]
@ 
\end{frame}

\begin{frame}[fragile]{Web resources: \Biocpkg{biomaRt} \& friends}
  Ensembl Biomart\footnote{\url{http://www.ensembl.org/biomart}} queries
  \bigskip
\begin{Schunk}
\begin{Sinput}
library(biomaRt)
listMarts()                      # many marts!
listDatasets(useMart("ensembl")) # many datasets!
ensembl <- 
    useMart("ensembl", dataset="hsapiens_gene_ensembl")

listFilters(ensembl)             # restrict query
listAttributes(ensembl)          # specify return values

getBM(mart=ensembl,
    filters="chromosome_name", values=c("21", "22"),
    attributes=c("ensembl_gene_id", "chromosome_name"))
\end{Sinput}
\end{Schunk}
\end{frame}

\begin{frame}[fragile]{Web resources: \Biocpkg{biomaRt} \& friends}
  Also:
  \begin{itemize}
  \item \Biocpkg{KEGGREST}, \Biocpkg{uniprot.ws}, \ldots
  \item \Rfunction{GenomicFeatures::makeTranscriptDbFromBiomart}
  \end{itemize}
  \Rpackage{org.*} vs.\ \Biocpkg{biomaRt}?
  \begin{itemize}
  \item Scope: \Biocpkg{biomaRt} much more extensive
  \item Convenience: \Biocpkg{org.Hs.eg.db} passes the `airplane' test
  \item Reproducibility: \Biocpkg{org.Hs.eg.db} data consistent within
    each \Bioconductor{} release
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Cloud resources: \Biocpkg{AnnotationHub}}
  Goal
  \begin{itemize}
  \item 'Mirror' large resources in \Bioconductor-friendly formats
  \item Easily retrieve into \R{} session
  \item Embody \Bioconductor{} principles, e.g., metadata, versioning, \ldots
  \end{itemize}
  Available -- examples
  \begin{itemize}
  \item Ensembl FASTA (\Rclass{FaFile}), GTF (\Rclass{GRanges}), release 69$+$
  \item ENCODE tracks at UCSC (\Rclass{GRanges})
  \item dbSNP VCF files (\Rclass{GRanges})
  \end{itemize}
  Use
<<AnnotationHub, eval=FALSE>>=
library(AnnotationHub)
hub <- AnnotationHub()  # query for available resources
## metadata(hub) -- info. about available resources
## hub$<tab> -- tab completion to select resource
@ 
\end{frame}

\begin{frame}{Variants: VCF files}
  \begin{itemize}
  \item Text file describing called variants (SNPs or more complicated)
  \item Metadata, header, and then rows for each variant
  \item Exact content described by metadata, depends on source of VCF
  \end{itemize}
  9 fields plus fields for each sample
  \begin{itemize}
  \item \texttt{CHROM}, \texttt{POS}, \texttt{ID}
  \item \texttt{REF}, \texttt{ALT}: Reference and alternate
    (variant) sequence
  \item \texttt{QUAL}, \texttt{FILTER}
  \item \texttt{INFO}: Per-variant information
  \item \texttt{FORMAT}: Instructions for interpreting per-sample
    information
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Variants: VCF files}
  \begin{itemize}
  \item Example: 1000 genomes chr22, five samples.
  \end{itemize}
  Metadata:
  \begin{itemize}
  \item \verb|##INFO=<ID=AN,Number=1,Type=Integer,|
    \verb|Description="Total Allele Count">|
  \end{itemize}
  One row:
  \begin{itemize}
  \item \verb|22	50300078	rs7410291|
  \item \verb|A	G|
  \item \verb|100	PASS|
  \item \verb|AN=2184;AVGPOST=0.9890;THETA=0.0005;VT=SNP;|
    \verb|RSQ=0.9856;ERATE=0.0020;SNPSOURCE=LOWCOV;|
    \verb|AA=N;AC=751;LDAF=0.3431;AF=0.34;ASN_AF=0.19;|
    \verb|AMR_AF=0.20;AFR_AF=0.83;EUR_AF=0.22|
  \item \verb|GT:DS:GL|
  \item \verb!0|0:0.000:-0.00,-2.77,-5.00! (similar for each sample)
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Variants: \Biocpkg{VariantAnnotation}}
  Index
<<tabix, eval=FALSE>>=
library(Rsamtools)
indexTabix("chr22.vcf.gz", type="vcf4")
@ 
  Discovery
<<vcf-discovery, eval=FALSE>>=
library(VariantAnnotation)
scanVcfHeader("chr22.vcf.gz")
@ 
  Query: \Rclass{SummarizedExperiment}-like \Rclass{VCF} class
<<vcf-query, eval=FALSE>>=
which <- GRanges("22", 
    IRanges(c(321680, 14477080), c(321689, 14477090)))
param <- ScanVcfParam(info=c("AN", "LDAF"), geno=NA,
    which=which)
readVcf("chr22.vcf.gz", "hg19", param=param)
@ 
  In devel
  \begin{itemize}
  \item \Rfunction{readInfo}, \Rfunction{readGeno}, \Rfunction{readGT}
    for simple queries
  \end{itemize}
\end{frame}

\begin{frame}{Variant annotation}
  \Bioconductor{}
  \begin{itemize}
  \item \Rfunction{locateVariants} with \Rclass{TranscriptDb} /
    \Rclass{GRangesList}
  \item \Rfunction{predictCoding} with \Rclass{TranscriptDb} and
    \Rclass{BSgenome} / \Rclass{FaFile}
  \item \Rfunction{find} / \Rfunction{countOverlaps}
  \end{itemize}
  SIFT / PolyPhen
  \begin{itemize}
  \item \Biocannopkg{SIFT.Hsapiens.dbSNP132},
    \Biocannopkg{PolyPhen.Hapiens.dbSNP131.db}: rsid look-up via
    `select' interface
  \end{itemize}
  \Biocpkg{ensemblVEP}
  \begin{itemize}
  \item Interface to Ensembl Variant Effect Predictor using Ensembl
    perl script and web interface
  \end{itemize}
\end{frame}

\begin{frame}{Summary \& Acknowledgments}
  \begin{columns}[t]
    \column{.4\textwidth}
    Summary
    \begin{enumerate}
    \item Annotation
      \begin{itemize}
      \item Genes
      \item Gene models
      \item Web / cloud resources
      \end{itemize}
    \item Called variants
      \begin{itemize}
      \item VCF files
      \item Variant annotation
      \end{itemize}
    \end{enumerate}
    \column{.6\textwidth}
    Acknowledgments
    \begin{itemize}
    \item Marc Carlson (Genes, gene models)
    \item Valerie Obenchain (Variants)
    \item Dan Tenenbaum (\Biocpkg{AnnotationHub})
    \item Herv\'e Pag\`es (Gene models)
    \item Paul Shannon (\Biocpkg{MotifDb}, \Biocpkg{AnnotationHub})
    \end{itemize}
    And
    \begin{itemize}
    \item Steffen Durink (\Biocpkg{biomaRt})
    \end{itemize}
  \end{columns}
\end{frame}

\end{document}

%\VignetteIndexEntry{1.7 Strategies for working with large data}

<<setup,echo=FALSE>>=
library(RNAseqData.HNRNPC.bam.chr14)
library(TxDb.Dmelanogaster.UCSC.dm3.ensGene)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(Rsamtools)
library(ShortRead)
library(parallel); options(mc.cores=detectCores())
library(lattice)
@ 

\chapter{Strategies for working with large data}
\label{chpt:large-data}

Bioinformatics data is now very large; it is not reasonable to expect
all of a fastq or bam file, for instance, to fit into memory. How is
this data to be processed? This challenge confronts us in whatever
language or tool we are using. In \R{} and \Bioconductor{}, main
approaches are to: (1) \emph{restrict} data input to the interesting
subset of the larger data set; (2) \emph{sample} from the large data,
knowing that an appropriately sized sample will accurately estimate
statistics we are interested in; (3) \emph{iterate} through large data
in chunks; and (4) use \emph{parallel} evaluation on one or several
computers. Let's look at each of these approaches.

\section{Restriction}

Just because a file contains a lot of data does not mean that we
are interested in all of it. In base \R, one might use the
\Rcode{colClasses} argument to \Rcode{read.delim} or similar function
(e.g., setting some elements to \code{NULL}) to read only some columns
of a large comma-separated value file. In addition to the obvious
benefit of using less memory than if all of the file had been read in,
input will be substantially faster because less computation needs to
be done to coerce values from their representation in the file to
their representation in \R's memory.

A variation on the idea of restricting data input is to organize the
data on disk into a representation that facilitates restriction. In
base \R, large data might be stored in a relational data base like the
\software{sqlite} data bases that are built in to \R{} and used in the
\Biocpkg{AnnotationDbi} \Bioconductor{} packages.
%% FIXME: simple relational database
In addition to facilitating restriction, these approaches are
typically faster than parsing a plain text file, because the data base
software has stored data in a way that efficiently transforms data
from its on-disk to in-memory representation.

Let's use BAM files and the \Biocpkg{Rsamtools} package to illustrate
restriction. Rather than using simple text files (``sam'' format), we
use ``bam'' (binary alignment) files that have been indexed. Use of a
binary format enhances data input speed, while the index facilitates
restrictions that take into account genomic coordinates. The basic
approach will use the \Rfunction{ScanBamParam} function to specify a
restriction.

A BAM record can contain a lot of information, including the
relatively large sequence, quality, and query name strings. Not all
information in the BAM file is needed for some calculations. For
instance, one could calculate coverage (number of nucleotides
overlapping each reference position) using only the \code{rname}
(reference sequence name), \code{pos}, and \code{cigar} fields. We
could arrange to input just this information with
<<restriction-what>>=
param <- ScanBamParam(what=c("rname", "pos", "cigar"))
@ 

Another common restriction is to particular genomic regions of
interest. Regions of interest might be known genes in an RNAseq
differential expression study, or promoter regions in a ChIP-seq
study. Restrictions in genome space are specified using
\Robject{GRanges} objects (typically computed from some reference
source, rather than entered by hand) provided as the \Rfunarg{which}
argument to \Rfunction{ScanBamParam}. Here we create a
\Robject{GRanges} instance representing all exons on \Dmel{}
chromosome 3L, and use that as a restriction to
\Rfunction{ScanBamParam}'s \Rfunarg{which} argument:
<<restriction-which>>=
library(TxDb.Dmelanogaster.UCSC.dm3.ensGene)
exByGn <- exonsBy(TxDb.Dmelanogaster.UCSC.dm3.ensGene, "gene")
seqlevels(exByGn, force=TRUE) <- "chr3L"
gns <- unlist(range(exByGn))
param <- ScanBamParam(which=gns)
@ 
%% 
The \Rfunarg{what} and \Rfunarg{which} restrictions can be combined
with other restrictions into a single \Robject{ScanBamParam} object
<<restrictions-several>>=
param <- ScanBamParam(what=c("rname", "pos", "cigar"), which=gns)
@ 
%% 
We can also restrict input to, e.g., paired-end reads that represent
the primary (best) alignment; see the help page \Rcode{?ScanBamParam}
for a more complete description.
 
Here are some BAM files from an experiment in \Dmel; the BAM files
contain a subset of aligned reads
<<bigdata>>=
bigdata <- "~/BigData"
bamfls <- dir(file.path(bigdata, "bam"), ".bam$", full=TRUE) #$
names(bamfls) <- sub("_subset.bam", "", basename(bamfls))
@ 
%% 
We'll read in the first BAM file, but restrict input to ``rname'' to
find how many reads map to each chromosome. We use the ``low-level''
function \Rfunction{scanBam} to input the data
<<scanBam-restriction>>=
param <- ScanBamParam(what="rname")
bam <- scanBam(bamfls[1], param=param)[[1]]
table(bam$rname)
@ 

Restriction is such a useful concept that many \Bioconductor{} high
throughput sequence analysis functions enable doing the right
thing. Functions such as \code{coverage,BamFile-method} use
restrictions to read in the specific data required for them to compute
the statistic of interest. Most ``higher level'' functions have a
\Rfunarg{param=ScanBamParam()} argument. For instance, the primary
user-friendly function for reading BAM files is
\Rfunction{readGappedAlignments} (this is renammed to
\Rfunction{readGAlignments} in \Bioconductor{} version 2.13) reads the
most useful information, allowing the user to specify additional
fields if desired.
<<readGappedAlignments-restriciton>>=
gal <- readGappedAlignments(bamfls[1])
head(gal, 3)
param <- ScanBamParam(what="seq")  ## also input sequence
gal <- readGappedAlignments(bamfls[1], param=param)
head(mcols(gal)$seq)
@ 

\section{Sampling}

\R{} is after all a statistical language, and it sometimes makes sense
to draw inferences from a sample of large data. For instance, many
quality assessment statistics summarize overall properties (e.g., GC
content or per-nucleotide base quality of FASTQ reads) that do not
require processing of the entire data. For these statistics to be
valid, the sample from the file needs to be a random sample, rather
than a sample of convenience. 

There are two advantages to sampling from a FASTQ (or BAM) file. The
sample uses less memory than the full data. And because less data
needs to be parsed from the on-disk to in-memory representation the
input is faster.

The \Biocpkg{ShortRead} package \Rfunction{FastqSampler} function (see also
\Rfunction{Rsamtools::BamSampler} visits a FASTQ file but retains only
a random sample from the file. Here is our function to calculate GC
content from a \Robject{DNAStringSet}:
<<GC-sampling>>=
library(Morgan2013)
gcFunction
@ 
%% 
and a subset of a FASTQ file with 1 million reads:
<<fastq-files>>=
bigdata <- "~/BigData"
fqfl <- dir(file.path(bigdata, "fastq"), ".fastq$", full=TRUE) #$
@
%% 
\Rfunction{FastqSampler} works by specifying the file name and desired
sample size, e.g., 100,000 reads. This creates an object from which an
independent sample can be drawn using the \code{yield} function. 
<<fastq-sampling>>=
sampler <- FastqSampler(fqfl, 100000)
fq <- yield(sampler)                    # 100,000 reads
lattice::densityplot(gcFunction(sread(fq)), plot.points=FALSE)
fq <- yield(sampler)                    # a different 100,000 reads
@ 
%% 
Generally, one would choose a sample size large enough to adequately
characterize the data but not so large as to consume all (or a
fraction, see section~\ref{sec:parallel} below) of the memory. The
default (1 million) is a reasonable starting point.

\Robject{FastqSampler} relies on the \R{} random number generator, so
the same sequence of reads can be sampled by using the same random
number seed. This is a convenient way to sample the same read pairs
from the FASTQ files typically used to represent paired-end reads
<<fastq-paired-end, eval=FALSE>>=
## NOT RUN
set.seed(123)
end1 <- yield(FastqSampler("end_1.fastq"))
set.seed(123)
end2 <- yield(FastqSampler("end_2.fastq"))
@ 

\section{Iteration}

Restriction may not be enough to wrestle large data down to size, and
sampling may be inappropriate for the task at hand. A solution is then
to iterate through the file. An example in base \R{} is to open a file
connection, and then read and process successive chunks of the file,
e.g., reading chunks of 10000 lines
<<readLines-chunks, eval=FALSE>>=
## NOT RUN
con <- file("<hypothetical-file>.txt")
open(f)
while (length(x <- readLines(f, n=10000))) {
    ## work on character vector 'x'
}
close(f)
@ 
%% 
The pattern \Rcode{length(x <- readLines(f, n=10000))} is a convenient
short-hand pattern that reads the \emph{next} 10000 lines into a
variable \Robject{x} and then asks \Robject{x} it's
length. \Robject{x} is created in the calling environment (so it is
available for processing in the \Rcode{while} loop) When there are no
lines left to read, \Rcode{length(x)} will evaluate to zero and the
\Rcode{while} loop will end.

Iteration really involves three steps: input of a `chunk' of the data;
calculation of a desired summary; and aggregation of summaries across
chunks. We illustrate this with BAM files in the \Biocpkg{Rsamtools}
package; see also \Rfunction{FastqStreamer} in the \Biocpkg{ShortRead}
package and \Rfunction{TabixFile} for iterating through large VCF
files (via \Rfunction{readVCF} in the \Biocpkg{VariantAnnotation}
package).

The first stage in iteration is to arrange for input of a chunk of
data. In many programming languages one would iterate
`record-at-a-time', reading in one record, processing it, and moving
to the next. \R{} is not efficient when used in this fashion. Instead,
we want to read in a larger chunk of data, typically as much as can
comfortably fit in available memory. In \Biocpkg{Rsamtools} for
reading BAM files we arrange for this by creating a \Robject{BamFile}
(or \Robject{TabixFile} for VCF) object where we specify an
appropriate \Rfunarg{yieldSize}. Here we go for a bigger BAM file
<<iteration-bam>>=
library(RNAseqData.HNRNPC.bam.chr14)
bamfl <- RNAseqData.HNRNPC.bam.chr14_BAMFILES[1]
countBam(bamfl)
bf <- BamFile(bamfl, yieldSize=200000) # could be larger, e.g., 2-10 million
@ 
%% 
A \Robject{BamFile} object can be used to read data from a BAM file,
e.g., using \Rfunction{readGappedAlignments}. Instead of reading all
the data, the reading function will read just \Rfunarg{yieldSize}
records. The idea then is to open the BAM file and iterate through
until no records are input. The pattern is
<<BamFile-iter, eval=FALSE>>=
## initialize, e.g., for step 3 ...
open(bf)
while (length(gal <- readGappedAlignments(bf))) {
    ## step 2: do work...
    ## step 3: aggregate results...
}
close(bf)
@ 

The second step is to perform a useful calculation on the chunk of
data. This is particularly easy to do if chunks are independent of one
another. For instance, a common operation is to count the number of
times reads overlap regions of interest. There are functions that
implement a variety of counting modes (see, e.g.,
\Rfunction{summarizeOverlaps} in the \Biocpkg{GenomicRanges} package);
here we'll go for a simple counter that arranges to tally one `hit'
each time a read overlaps (in any way) at most one range. Here is our
counter function, taking as arguments a \Robject{GRanges} or
\Robject{GRangesList} object representing the regions for which counts
are desired, and a \Robject{GappedAlignments} object representing
reads to be counted:
<<counter-iter>>=
counter <- 
    function(query, subject, ..., ignore.strand=TRUE)
    ## query: GRanges or GRangesList
    ## subject: GappedAlignments
{
    if (ignore.strand)
        strand(subject) <- "*"
    hits <- countOverlaps(subject, query)
    countOverlaps(query, subject[hits==1])
}
@ 
%% 
To set this step up a little more completely, we need to know the
regions over which counting is to occur. Here we retrieve exons
grouped by gene for the genome to which the BAM files were
aligned:
<<counter-roi>>=
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
query <- exonsBy(TxDb.Hsapiens.UCSC.hg19.knownGene, "gene")
@ 
Thus we'll add the following lines to our loop:
<<counter-work, eval=FALSE>>=
## initialize, e.g., for step 3 ...
open(bf)
while (length(gal <- readGappedAlignments(bf))) {
    ## step 2: do work...
    count0 <- counter(query, gal, ignore.strand=TRUE)
    ## step 3: aggregate results...
}
close(bf)
@ 
%% 
It is worth asking whether the `do work' step will always be as
straight-forward. The current example is easy because counting
overlaps of one read does not depend on other reads, so the chunks can
be processed independently of one another. \FIXME{These are paired-end
  reads, so counting is \emph{not} this easy! See the lab on RNA-seq}.

The final step in iteration is to aggregate results across chunks. In
our present case, \Rfunction{counter} always returns an integer vector
with \Rcode{length(query)} elements. We want to add these over chunks,
and we can arrange to do this by starting with an initial vector of
counts \Rcode{counts <- integer(length(query))} and simply adding
\Rcode{count0} at each iteration. The complete iteration, packaged as
a function to facilitate re-use is
<<counter-work>>=
counter1 <- 
    function(bf, query, ...)
{
    ## initialize, e.g., for step 3 ...
    counts <- integer(length(query))
    open(bf)
    while (length(gal <- readGappedAlignments(bf, ...))) {
        ## step 2: do work...
        count0 <- counter(query, gal, ignore.strand=TRUE)
        ## step 3: aggregate results...
        counts <- counts + count0
    }
    close(bf)
    counts
}
@ 
%% 
In action, this is invoked as
<<counter1>>=
bf <- BamFile(bamfl, yieldSize=500000)
counts <- counter1(bf, query)
@ 


Counting is a particularly simple operation; one will often need to
think carefully about how to aggregate statistics derived from
individual chunks. A useful general approach is to identify
\emph{sufficient statistics} that represent a description of the data
and can be easily aggregated across chunks. This is the approach taken
by, for instance, the \Rpackage{biglm} package for fitting linear
models to large data sets -- the linear model is fit to successive
chunks and the fit reduced to sufficient statistics, the sufficient
statistics are then aggregated across chunks to arrive at an overall
fit.

\section{Parallel evaluation}
\label{sec:parallel}

Each of the preceding sections addressed memory management; what about
overall performance?

The starting point is really writing efficient, vectorized code, with
common strategies outlined elsewhere. Performance differences between
poorly written versus well written \R{} code can easily span two
orders of magnitude, whereas parallel processing can only increase
throughput by an amount inversely proportional to the number of
processing units (e.g., CPUs) available.

The memory management techniques outlined earlier in this chapter are
important in a parallel evaluation context. This is because we will
typically be trying to exploit multiple processing cores on a single
computer, and the cores will be competing for the same pool of shared
memory. We thus want to arrange for the collection of processors to
cooperate in dividing available memory between them, i.e., each
processor needs to use only a fraction of total memory.

There are a number of ways in which \R{} code can be made to run in
parallel. The least painful and most effective will use `multicore'
functionality provided by the \Rpackage{parallel} package; the
\Rpackage{parallel} package is installed by default with base \R, and
has a useful vignette~\cite{Rparallel}. Unfortunately, multicore
facilities are not available on Windows computers.

Parallel evaluation on several cores of a single Linux or MacOS
computer is particularly easy to achieve when the code is already
vectorized. The solution on these operating systems is to use the
functions \Rfunction{mclapply} or \Rfunction{pvec}. These functions
allow the `master' process to `fork' processes for parallel evaluation
on each of the cores of a single machine. The forked processes
initially share memory with the master process, and only make copies
of data when the forked process modifies a memory location (`copy on
write' semantics). On Linux and MacOS, the \Rfunction{mclapply}
function is meant to be a `drop-in' replacement for
\Rfunction{lapply}, but with iterations being evaluated on different
cores.  The following illustrates the use of \Rfunction{mclapply} for
a toy vectorized function \Rfunction{f}:
\begin{Schunk}
\begin{Sinput}
> library(parallel)
> f <- function(i) {
+     cat("'f' called, length(i) = ", length(i), "\n")
+     sqrt(i)
+ }
> res0 <- mclapply(1:5, f, mc.cores=2)
\end{Sinput}
\begin{Soutput}
'f' called, length(i) =  1 
'f' called, length(i) =  1 
'f' called, length(i) =  1 
'f' called, length(i) =  1 
'f' called, length(i) =  1 
\end{Soutput}
\end{Schunk}
\Rfunction{pvec} is a little more subtle. It takes a vectorized
function and distributes computation of different chunks of the vector
across cores.
\begin{Schunk}
\begin{Sinput}
> res1 <- pvec(1:5, f, mc.cores=2)
\end{Sinput}
\begin{Soutput}
'f' called, length(i) =  3 
'f' called, length(i) =  2 
\end{Soutput}
\begin{Sinput}
> identical(unlist(res0), res1)
\end{Sinput}
\begin{Soutput}
[1] TRUE
\end{Soutput}
\end{Schunk}
%% 
Both \Rfunction{mclapply} and \Rfunction{pvec} functions allow the
user to specify the number of cores used, and how the data are divided
into chunks.

The \Rpackage{parallel} package does not support fork-like
behavior on Windows, where users need to more explicitly create a
cluster of \R{} workers and arrange for each to have the same data
loaded into memory; similarly, parallel evaluation across computers
(e.g., in a cluster) require more elaborate efforts to coordinate
workers; this is typically done using \Rfunction{lapply}-like
functions provided by the \Rpackage{parallel} package but specialized
for simple (`snow') or more robust (`MPI') communication protocols
between workers.

Data movement and random numbers are two important additional
considerations in parallel evaluation.  Moving data to and from cores
to the manager can be expensive, so strategies that minimize explicit
movement (e.g., passing file names or data base queries rather than
\R{} objects read from files; reducing data on the worker before
transmitting results to the manager) are important.  Random numbers
need to be synchronized across cores to avoid generating the same
sequences on each `independent' computation.

How might parallel evaluation be used in \Bioconductor{} work flows?
One approach when working with BAM files exploits the fact that data
are often organized with one sample per BAM file. Suppose we are
interested in running our iterating counter \Rfunction{counter1} over
several BAM files. We could do this by creating a \Rcode{BamFileList}
with appropriate \Rfunarg{yieldSize}
<<count-bfl-make>>=
fls <- RNAseqData.HNRNPC.bam.chr14_BAMFILES  # 8 BAM files
bamfls <- BamFileList(fls, yieldSize=500000) # use a larger yieldSize
@ 
%% 
and using an \Rfunction{lapply} to take each file in turn and
performing the count.
<<count-bams, eval=FALSE>>=
counts <- simplify2array(lapply(bamfls, counter1, query))
@ 
%% 
The parallel equivalent of this is simply (note the change from
\Rfunction{lapply} to \Rfunction{mclapply})
<<count-bams-mclapply>>=
options(mc.cores=detectCores())         # use all cores
counts <- simplify2array(mclapply(bamfls, counter1, query))
head(counts[rowSums(counts) != 0,], 3)
@ 
%% 
Note that \Rcode{names(bamfls)} and \Rcode{names(query)} are returned
as row and column names of the data, reducing chance of mistaken
labelling.

\section{And\ldots}

The \Rpackage{foreach} package can be useful for parallel evaluation
written using coding styles more like \Rcode{for} loops rather than
\Rcode{lapply}. The \Rpackage{iterator} package is an abstraction that
simplifies the notion of iterating over objects. The \Rpackage{Rmpi}
package provides access to MPI, a structured environment for
calculation on clusters. The \Rpackage{pbdR}
formalism\footnote{\url{https://rdav.nics.tennessee.edu/2012/09/pbdr/}}
is especially useful for well-structured distributed matrix
computations.

The \Rpackage{MatrixEQTL} package is an amazing example implementing
high performance algorithms on large data; the corresponding
publication~\cite{shabalin2012matrix} is well worth studying.

\Bioconductor{} provides an Amazon machine instance with MPI and
\Rpackage{Rmpi}
installed\footnote{\url{http://bioconductor.org/help/bioconductor-cloud-ami/}}. This
can be an effective way to gain access to large computing resources.

%\VignetteIndexEntry{1.5 Alignments and Ranges}

\chapter{Ranges and Alignments}
\label{chpt:RangesAndAlignments}

<<setup,echo=FALSE>>=
library(GenomicFeatures)
plotRanges <- function(x, xlim = x, main = deparse(substitute(x)),
                       col = "black", sep = 0.5, ...)
{
    height <- 1
    if (is(xlim, "Ranges"))
        xlim <- c(min(start(xlim)), max(end(xlim)))
    bins <- disjointBins(IRanges(start(x), end(x) + 1))
    plot.new()
    par(mai=c(0.6, 0.2, 0.6, 0.2))
    plot.window(xlim, c(0, max(bins)*(height + sep)))
    ybottom <- bins * (sep + height) - height
    rect(start(x)-0.5, ybottom, end(x)+0.5, ybottom + height, col = col, ...)
    title(main, cex.main=2.8, font.main=1)
    axis(1)
}
@

Ranges describe both features of interest (e.g., genes, exons,
promoters) and reads aligned to the genome. \Bioconductor{} has very
powerful facilities for working with ranges, some of which are
summarized in Table~\ref{tab:ranges-pkgs}.

\begin{table}
  \centering
  \caption{Selected \Bioconductor{} packages for representing and
    manipulating ranges.}
  \label{tab:ranges-pkgs}
  \begin{tabular}{lp{.7\textwidth}}
    Package & Description\\
    \hline

    \Biocpkg{IRanges} & Defines important classes (e.g.,
    \Rclass{IRanges}, \Rclass{Rle}) and methods (e.g.,
    \Rfunction{findOverlaps}, \Rfunction{countOverlaps}) for
    representing and manipulating ranges of consecutive values. Also
    introduces \Rclass{DataFrame}, \Rclass{SimpleList} and other
    classes tailored to representing very large data.\\

    \Biocpkg{GenomicRanges} & Range-based classes tailored to sequence
    representation (e.g., \Rclass{GRanges}, \Rclass{GRangesList}),
    with information about strand and sequence name.\\

    \Biocpkg{GenomicFeatures} & Foundation for manipulating data bases
    of genomic ranges, e.g., representing coordinates and organization
    of exons and transcripts of known genes.\\
    
    \Biocpkg{AnnotationHub} & Access many common large-data resources (e.g., 
    Encode tracks; Ensembl GTF files)  as \Rclass{GRanges} instances.\\

    \hline
  \end{tabular}
\end{table}

\section{Ranges and the \Biocpkg{GenomicRanges} package}

Next-generation sequencing data consists of a large number of short
reads. These are, typically, aligned to a reference genome. Basic
operations are performed on the alignment, asking e.g., how many reads
are aligned in a genomic range defined by nucleotide coordinates
(e.g., in the exons of a gene), or how many nucleotides from all the
aligned reads cover a set of genomic coordinates. How is this type of
data, the aligned reads and the reference genome, to be represented in
\R{} in a way that allows for effective computation?

The \Biocpkg{IRanges}, \Biocpkg{GenomicRanges}, and
\Biocpkg{GenomicFeatures} \Bioconductor{} packages
(Table~\ref{tab:ranges-pkgs}) provide the essential infrastructure for
these operations; we start with the \Rclass{GRanges} class, defined in
\Biocpkg{GenomicRanges}.

\paragraph{\Rclass{GRanges}}

Instances of \Rclass{GRanges} are used to specify genomic
coordinates. Suppose we wish to represent two \Dmel{} genes. The
first is located on the positive strand of chromosome 3R, from
position 19967117 to 19973212. The second is on the minus strand of
the X chromosome, with `left-most' base at 18962306, and right-most
base at 18962925. The coordinates are \emph{1-based} (i.e., the first
nucleotide on a chromosome is numbered 1, rather than 0),
\emph{left-most} (i.e., reads on the minus strand are defined to
`start' at the left-most coordinate, rather than the 5' coordinate),
and \emph{closed} (the start and end coordinates are included in the
range; a range with identical start and end coordinates has width 1, a
0-width range is represented by the special construct where the end
coordinate is one less than the start coordinate).

A complete definition of these genes as \Rclass{GRanges} is:
<<GRanges-genes>>=
genes <- GRanges(seqnames=c("3R", "X"),
                 ranges=IRanges(
                     start=c(19967117, 18962306),
                     end=c(19973212, 18962925)),
                 strand=c("+", "-"),
                 seqlengths=c(`3R`=27905053L, `X`=22422827L))
@
The components of a \Rclass{GRanges} object are defined as vectors,
e.g., of \Rfunarg{seqnames}, much as one would define a
\Rclass{data.frame}. The start and end coordinates are grouped into an
\Rclass{IRanges} instance. The optional \Rfunarg{seqlengths} argument
specifies the maximum size of each sequence, in this case the lengths
of chromosomes 3R and X in the `dm2' build of the \Dmel{} genome. This
data is displayed as
<<GRanges-display>>=
genes
@
For the curious, the gene coordinates and sequence lengths are derived
from the \Biocannopkg{org.Dm.eg.db} package for genes with Flybase
identifiers FBgn0039155 and FBgn0085359, using the annotation
facilities described in the lab on gene and genome annotation.

The \Rclass{GRanges} class has many useful methods defined on
it. Consult the help page
<<GRanges-help, eval=FALSE>>=
?GRanges
@
and package vignettes (especially `An Introduction to
\Biocpkg{GenomicRanges}')
<<GRanges-vignettes, eval=FALSE>>=
vignette(package="GenomicRanges")
@
for a comprehensive introduction. A \Rclass{GRanges} instance can be
subset, with accessors for getting and updating information.
<<GRanges-basics>>=
genes[2]
strand(genes)
width(genes)
length(genes)
names(genes) <- c("FBgn0039155", "FBgn0085359")
genes  # now with names
@ 
\Rfunction{strand} returns the strand information in a compact
representation called a \emph{run-length encoding}, this is introduced
in greater detail below.  The `names' could have been specified when
the instance was constructed; once named, the \Rclass{GRanges}
instance can be subset by name like a regular vector.

As the \Rfunction{GRanges} function suggests, the \Rclass{GRanges}
class extends the \Rclass{IRanges} class by adding information about
\Rfunarg{seqnames}, \Rfunarg{strand}, and other information
particularly relevant to representing ranges that are on genomes. The
\Rclass{IRanges} class and related data structures (e.g.,
\Rclass{RangedData}) are meant as a more general description of ranges
defined in an arbitrary space. Many methods implemented on the
\Rclass{GRanges} class are `aware' of the consequences of genomic
location, for instance treating ranges on the minus strand differently
(reflecting the 5' orientation imposed by DNA) from ranges on the plus
strand.

\paragraph{Operations on ranges}

The \Rclass{GRanges} class has many useful methods from the
\Rclass{IRanges} class; some of these methods are illustrated here. We
use \Rclass{IRanges} to illustrate these operations to avoid
complexities associated with strand and seqnames, but the operations
are comparable on \Rclass{GRanges}. We begin with a simple set of
ranges:
<<ranges-ir>>=
ir <- IRanges(start=c(7, 9, 12, 14, 22:24),
              end=c(15, 11, 12, 18, 26, 27, 28))
@
%%
<<ranges-ir-plot, results=hide, echo=FALSE, fig=FALSE>>=
png("ranges-ir-plot.png", width=800, height=160)
plotRanges(ir, xlim=c(5, 35), main="Original")
dev.off()
png("ranges-shift-ir-plot.png", width=800, height=160)
plotRanges(shift(ir, 5), xlim=c(5, 35), main="Shift")
dev.off()
png("ranges-reduce-ir-plot.png", width=800, height=160)
plotRanges(reduce(ir), xlim=c(5, 35), main="Reduce")
dev.off()
@
%
These and some common operations are illustrated in the upper panel of
Figure~\ref{fig:ranges} and summarized in Table~\ref{tab:range-ops}.

\begin{figure}
\centering
\includegraphics[width=.5\textwidth,height=!]{ranges-ir-plot}\\
\includegraphics[width=.5\textwidth,height=!]{ranges-shift-ir-plot}\\
\includegraphics[width=.5\textwidth,height=!]{ranges-reduce-ir-plot}
\caption{Ranges}
\label{fig:ranges}
\end{figure}

Methods on ranges can be grouped as follows:
\begin{packeddescription}
\item[Intra-range] methods act on each range independently. These
  include \Rfunction{flank}, \Rfunction{narrow}, \Rfunction{reflect},
  \Rfunction{resize}, \Rfunction{restrict}, and \Rfunction{shift},
  among others. An illustration is \Rfunction{shift}, which translates
  each range by the amount specified by the \Rfunarg{shift} argument.
  Positive values shift to the right, negative to the left;
  \Rfunarg{shift} can be a vector, with each element of the vector
  shifting the corresponding element of the \Rclass{IRanges}
  instance. Here we shift all ranges to the right by 5, with the
  result illustrated in the middle panel of Figure~\ref{fig:ranges}.
<<ranges-shift-ir>>=
shift(ir, 5)
@
<<ranges-shift-ir-plot, results=hide, echo=FALSE, fig=FALSE>>=
png("ranges-shift-ir-plot.png", width=800, height=160)
plotRanges(shift(ir, 5), xlim=c(5, 35), main="Shift")
dev.off()
@

\item[Inter-range] methods act on the collection of ranges as a
  whole. These include \Rfunction{disjoin}, \Rfunction{reduce},
  \Rfunction{gaps}, and \Rfunction{range}. An illustration is
  \Rfunction{reduce}, which reduces overlapping ranges into a single
  range, as illustrated in the lower panel of
  Figure~\ref{fig:ranges}.
<<ranges-reduce-ir>>=
reduce(ir)
@
<<ranges-reduce-ir-plot, results=hide, echo=FALSE, fig=FALSE>>=
png("ranges-reduce-ir-plot.png", width=800, height=160)
plotRanges(reduce(ir), xlim=c(5, 35), main="Reduce")
dev.off()
@

  \Rfunction{coverage} is an inter-range operation that calculates how
  many ranges overlap individual positions. Rather than returning
  ranges, \Rfunction{coverage} returns a compressed representation
  (run-length encoding)
<<coverage>>=
coverage(ir)
@    
  The run-length encoding can be interpreted as `a run of length 6 of
  nucleotides covered by 0 ranges, followed by a run of length 2 of
  nucleotides covered by 1 range.

\item[Between] methods act on two (or sometimes more) \Rclass{IRanges}
  instances. These include \Rfunction{intersect}, \Rfunction{setdiff},
  \Rfunction{union}, \Rfunction{pintersect}, \Rfunction{psetdiff}, and
  \Rfunction{punion}.  The \Rfunction{countOverlaps} and
  \Rfunction{findOverlaps} functions operate on two sets of
  ranges. \Rfunction{countOverlaps} takes its first argument (the
  \Rfunarg{query}) and determines how many of the ranges in the second
  argument (the \Rfunarg{subject}) each overlaps. The result is an
  integer vector with one element for each member of
  \Rfunarg{query}. \Rfunction{findOverlaps} performs a similar
  operation but returns a more general matrix-like structure that
  identifies each pair of query / subject overlaps. Both arguments
  allow some flexibility in the definition of `overlap'.
\end{packeddescription}

Common operations on ranges are summarized in Table~\ref{tab:range-ops}.

\begin{table}
  \centering
  \caption{Common operations on \Rclass{IRanges}, \Rclass{GRanges} and
    \Rclass{GRangesList}.}
  \label{tab:range-ops}
  \begin{tabular}{lll}
    Category & Function & Description \\
    \hline

    Accessors & \Rfunction{start}, \Rfunction{end}, \Rfunction{width} & 
        Get or set the starts, ends and widths \\
    & \Rfunction{names} & Get or set the names \\
    & \Rfunction{mcols}, \Rfunction{metadata} & 
        Get or set metadata on elements or object \\
    & \Rfunction{length} & Number of ranges in the vector \\
    & \Rfunction{range} & Range formed from min start and max end \\

    Ordering & \Rfunction{<}, \Rfunction{<=}, \Rfunction{>}, \Rfunction{>=}, 
        \Rfunction{==}, \Rfunction{!=} & 
        Compare ranges, ordering by start then width \\
    & \Rfunction{sort}, \Rfunction{order}, \Rfunction{rank} & 
        Sort by the ordering \\
    & \Rfunction{duplicated} & Find ranges with multiple instances \\
    & \Rfunction{unique} & Find unique instances, removing duplicates \\

    Arithmetic & \Rcode{r + x}, \Rcode{r - x}, \Rcode{r * x} & 
        Shrink or expand ranges \Robject{r} by number \Robject{x} \\
    & \Rfunction{shift} & Move the ranges by specified amount \\
    & \Rfunction{resize} & Change width, anchoring on start, end or mid \\
    & \Rfunction{distance} & Separation between ranges (closest endpoints) \\
    & \Rfunction{restrict} & Clamp ranges to within some start and end \\
    & \Rfunction{flank} & Generate adjacent regions on start or end \\

    Set operations & \Rfunction{reduce} & 
        Merge overlapping and adjacent ranges \\
    & \Rfunction{intersect}, \Rfunction{union}, \Rfunction{setdiff} & 
        Set operations on reduced ranges \\
    & \Rfunction{pintersect}, \Rfunction{punion}, \Rfunction{psetdiff} & 
        Parallel set operations, on each \Rcode{x[i]}, \Rcode{y[i]} \\
    & \Rfunction{gaps}, \Rfunction{pgap} & 
        Find regions not covered by reduced ranges \\
    & \Rfunction{disjoin} & Ranges formed from union of endpoints \\

    Overlaps & \Rfunction{findOverlaps} & 
        Find all overlaps for each \Robject{x} in \Robject{y} \\
    & \Rfunction{countOverlaps} & 
        Count overlaps of each \Robject{x} range in \Robject{y} \\
    & \Rfunction{nearest} & 
        Find nearest neighbors (closest endpoints) \\
    & \Rfunction{precede}, \Rfunction{follow} & 
        Find nearest \Robject{y} that \Robject{x} precedes or follows \\
    & \Rcode{x \%in\% y} & 
        Find ranges in \Robject{x} that overlap range in \Robject{y} \\

    Coverage & \Rfunction{coverage} & Count ranges covering each position \\

    Extraction & \Rcode{r[i]} & Get or set by logical or numeric index \\
    & \Rcode{r[[i]]} & 
        Get integer sequence from \Rcode{start[i]} to \Rcode{end[i]} \\
    & \Rfunction{subsetByOverlaps} & 
        Subset \Robject{x} for those that overlap in \Robject{y} \\
    & \Rfunction{head}, \Rfunction{tail}, \Rfunction{rev}, \Rfunction{rep} & 
        Conventional R semantics \\

    Split, combine & \Rfunction{split} & 
        Split ranges by a factor into a \Rclass{RangesList} \\
    & \Rfunction{c} & Concatenate two or more range objects \\
    \hline
  \end{tabular}
\end{table}

\paragraph{\Rfunction{mcols} and \Rfunction{metadata}}

The \Rclass{GRanges} class (actually, most of the data structures
defined or extending those in the \Biocpkg{IRanges} package) has two
additional very useful data components. The \Rfunction{mcols} function
allows information on each range to be stored and manipulated (e.g.,
subset) along with the \Rclass{GRanges} instance. The element metadata
is represented as a \Rclass{DataFrame}, defined in \Biocpkg{IRanges}
and acting like a standard \R{} \Rclass{data.frame} but with the
ability to hold more complicated data structures as columns (and with
element metadata of its own, providing an enhanced alternative to the
\Biocpkg{Biobase} class \Rclass{AnnotatedDataFrame}).
<<GRanges-mcols>>=
mcols(genes) <- DataFrame(EntrezId=c("42865", "2768869"),
                          Symbol=c("kal-1", "CG34330"))
@
\Rfunction{metadata} allows addition of information to the entire
object. The information is in the form of a list; any data can be
provided.
<<GRanges-metadata>>=
metadata(genes) <-
    list(CreatedBy="A. User", Date=date())
@

\paragraph{\Rclass{GRangesList}}

The \Rfunction{GRanges} class is extremely useful for representing
simple ranges. Some next-generation sequence data and genomic features
are more hierarchically structured. A gene may be represented by
several exons within it. An aligned read may be represented by
discontinuous ranges of alignment to a reference.  The
\Rclass{GRangesList} class represents this type of information. It is
a list-like data structure, which each element of the list itself a
\Rclass{GRanges} instance. The gene FBgn0039155 contains several
exons, and can be represented as a list of length 1, where the element
of the list contains a \Rclass{GRanges} object with 7 elements (the
\Rclass{GRangesList} instance shown here is from a `TranscriptDb'
instance, covered in a later lab).
<<GRangesList-eg-setup, echo=FALSE>>=
library(TxDb.Dmelanogaster.UCSC.dm3.ensGene)
txdb <- TxDb.Dmelanogaster.UCSC.dm3.ensGene # alias
fbgn <- exonsBy(txdb, "gene")["FBgn0039155"]
seqlevels(fbgn) <- "chr3R"
@
<<GRangesList-eg, echo=FALSE>>=
fbgn
@

The \Rclass{GRangesList} object has methods one would expect for lists
(e.g., \Rfunction{length}, sub-setting). Many of the methods
introduced for working with \Rclass{IRanges} are also available,
with the method applied element-wise.

\paragraph{The \Biocpkg{GenomicFeatures} packages}

Many public resources provide annotations about genomic features. For
instance, the UCSC genome browser maintains the `knownGene' track of
established exons, transcripts, and coding sequences of many model
organisms. The \Biocpkg{GenomicFeatures} package provides a way to
retrieve, save, and query these resources. The underlying
representation is as sqlite data bases, but the data are available in
\R{} as \Rclass{GRangesList} objects. The following exercise explores
the \Biocpkg{GenomicFeatures} package and some of the functionality
for the \Rclass{IRanges} family introduced above.

\begin{Exercise}
  Load the \Biocannopkg{TxDb.Dmelanogaster.UCSC.dm3.ensGene}
  annotation package, and create an alias \Robject{txdb} pointing to
  the \Rclass{TranscriptDb} object this class defines.

  Extract all exon coordinates, organized by gene, using
  \Rfunction{exonsBy}. What is the class of this object? How many
  elements are in the object? What does each element correspond to?
  And the elements of each element? Use \Rfunction{elementLengths} and
  \Rfunction{table} to summarize the number of exons in each gene, for
  instance, how many single-exon genes are there?

  Select just those elements corresponding to flybase gene ids
  FBgn0002183, FBgn0003360, FBgn0025111, and FBgn0036449. Use
  \Rfunction{reduce} to simplify gene models, so that exons that
  overlap are considered `the same'.
\end{Exercise}

\begin{Solution}
<<txdb>>=
library(TxDb.Dmelanogaster.UCSC.dm3.ensGene)
txdb <- TxDb.Dmelanogaster.UCSC.dm3.ensGene # alias
ex0 <- exonsBy(txdb, "gene")
head(table(elementLengths(ex0)))
ids <- c("FBgn0002183", "FBgn0003360", "FBgn0025111", "FBgn0036449")
ex <- reduce(ex0[ids])
@
\end{Solution}

%% \begin{Exercise}
%%   It is crucial that annotations and alignments are to the same
%%   reference genome, so \Rclass{GRanges} objects contain information
%%   about the expected sequence names and lengths, and many functions
%%   check to make sure that the sequence information is consistent
%%   between objects involved in, e.g.,
%%   \Rfunction{findOverlaps}. Unfortunately, different naming schemes
%%   are in use to refer to the same reference genome.
%%   \begin{packedenumerate}
%%   \item Use the \Rfunction{supportedSeqnameStyles} function from the
%%     \Biocpkg{GenomicFeatures} package to discover the sequence naming
%%     styles supported for \Dmel.
%%   \item Discover the current sequence name style associated with the
%%     \Robject{txdb} instance, above, using \Rfunction{seqnameStyle}.
%%   \item Use the `setter` version of \Rfunction{seqnameStyle} to change
%%     the naming style on the \Robject{txdb} instance to your favorite,
%%     and view the results for exons grouped by gene.
%%   \end{packedenumerate}
%% \end{Exercise}

%% \begin{Solution}
%%   Load the \Biocpkg{GenomicFeatures} package and query for supported
%%   sequence name styles
%% <<seqnameStyles-discover-available>>=
%% library(GenomicFeatures)
%% names(supportedSeqnameStyles())
%% supportedSeqnameStyles()$Drosophila_melanogaster
%% @ 
%% %% 
%% Discover the current sequence name style on a \Rclass{TranscriptDb}
%% object
%% <<seqnameStyles-discover-txdb>>=
%% head(seqlevels(txdb))
%% seqnamessStyle(txdb)
%% @ 
%% %% 
%% Change the naming style
%% <<seqnamessStyle-update>>=
%% seqnameStyle(txdb) <- "Ensembl"
%% head(seqlevels(txdb))
%% head(exonsBy(txdb, "gene"), 2)
%% @ 

%% \end{Solution}

\section{Alignments and the \Biocpkg{Rsamtools} Package}
\label{sec:Rsamtools}

Most down-stream analysis of short read sequences is based on reads
aligned to reference genomes. 

\paragraph{Alignment formats}

Most main-stream aligners produce output in SAM (text-based) or BAM
format. A SAM file is a text file, with one line per aligned read, and
fields separated by tabs. Here is an example of a single SAM line,
split into fields.
<<SAM>>=
fl <- system.file("extdata", "ex1.sam", package="Rsamtools")
strsplit(readLines(fl, 1), "\t")[[1]]
@

Fields in a SAM file are summarized in Table~\ref{tbl:sam}.
\begin{table}
  \centering
  \caption{Fields in a SAM record. From
    \url{http://samtools.sourceforge.net/samtools.shtml}}
  \medskip
  \label{tbl:sam}
  \begin{tabular}{lll}
    Field & Name & Value \\\hline
    1 & QNAME & Query (read) NAME \\
    2 & FLAG & Bitwise FLAG, e.g., strand of alignment \\
    3 & RNAME & Reference sequence NAME \\
    4 & POS & 1-based leftmost POSition of sequence \\
    5 & MAPQ & MAPping Quality (Phred-scaled) \\
    6 & CIGAR & Extended CIGAR string \\
    7 & MRNM & Mate Reference sequence NaMe \\
    8 & MPOS & 1-based Mate POSition \\
    9 & ISIZE & Inferred insert SIZE \\
    10 & SEQ & Query SEQuence on the reference strand \\
    11 & QUAL & Query QUALity \\
    12$+$ & OPT & OPTional fields, format TAG:VTYPE:VALUE \\\hline
  \end{tabular}
\end{table}
We recognize from the FASTQ file the identifier string, read sequence
and quality. The alignment is to a chromosome `seq1' starting at
position 1. The strand of alignment is encoded in the `flag' field.
The alignment record also includes a measure of mapping quality, and a
CIGAR string describing the nature of the alignment. In this case, the
CIGAR is 36M, indicating that the alignment consisted of 36
\texttt{M}atches or mismatches, with no indels or gaps; indels
(relative to the reference) are represented by \texttt{I} and
\texttt{D}; gaps (e.g., from alignments spanning introns) by
\texttt{N}.

BAM files encode the same information as SAM files, but in a format
that is more efficiently parsed by software; BAM files are the primary
way in which aligned reads are imported in to \R{}. 

\paragraph{Aligned reads in \R{}}

The \Rfunction{readGappedAlignments} function (this is renamed
\Rfunction{readGalignments} in the `devel' version of \Bioconductor)
from the \Biocpkg{GenomicRanges} package reads essential information
from a BAM file in to \R. The result is an instance of the
\Rclass{GappedAlignments} class. The \Rclass{GappedAlignments} class
has been designed to allow useful manipulation of many reads (e.g., 20
million) under moderate memory requirements (e.g., 4 GB); strategies
for dealing with large data are discussed in Chaptar~\ref{chpt:large-data}.
<<readGappedAlignments>>=
alnFile <- system.file("extdata", "ex1.bam", package="Rsamtools")
aln <- readGappedAlignments(alnFile)
head(aln, 3)
@
%% 
The \Rfunction{readGappedAlignments} function takes an additional
argument, \Rfunarg{param}, allowing the user to specify regions of the
BAM file (e.g., known gene coordinates) and characteristics of the
alignments (e.g., `proper' pairs, as identified by the aligner) from
which to extract alignments.

A \Rclass{GappedAlignments} instance is like a data frame, but with
accessors as suggested by the column names. It is easy to query, e.g.,
the distribution of reads aligning to each strand, the width of reads,
or the cigar strings
<<GappedAlignments-accessors>>=
table(strand(aln))
table(width(aln))
head(sort(table(cigar(aln)), decreasing=TRUE))
@ 

\begin{Exercise}
  Use \Rfunction{bigdata}, \Rfunction{file.path} and \Rfunction{dir}
  to obtain file paths to the BAM files. These are a subset of the
  aligned reads, overlapping just four genes.
  
  Input the aligned reads from one file using
  \Rfunction{readGappedAlignments}. Explore the reads, e.g., using
  \Rfunction{table} or \Rfunction{xtabs}, to summarize which chromosome
  and strand the subset of reads is from.
  
  The object \Robject{ex} is created in a later exercises, but we will
  use it now. It contains coordinates of four genes. Use
  \Rfunction{countOverlaps} to first determine the number of genes an
  individual read aligns to, and then the number of uniquely aligning
  reads overlapping each gene. Since the RNAseq protocol was not
  strand-sensitive, set the strand of \Robject{aln} to \code{*}.
  
  Write the sequence of steps required to calculate counts as a simple
  function, and calculate counts on each file. On Mac or Linux, can
  you easily parallelize this operation?
\end{Exercise}

\begin{Solution}
  We discover the location of files using standard \R{} commands:
<<bam-ex-fls>>=
bigdata <- "~/BigData"
fls <- dir(file.path(bigdata, "bam"), ".bam$", full=TRUE) #$
names(fls) <- sub("_subset.bam", "", basename(fls))
@ 
Use \Rfunction{readGappedAlignments} to input data from one of the
files, and standard \R{} commands to explore the data.
<<bam-ex-input>>=
## input
aln <- readGappedAlignments(fls[1])
xtabs( ~ seqnames + strand, as.data.frame(aln))
@
To count overlaps in regions defined in a previous exercise, load
the regions.
<<bam-ex-roi>>=
data(ex)             # from a later exercise
@ 
Many RNA-seq protocols are not strand aware, i.e., reads align to the
plus or minus strand regardless of the strand on which the
corresponding gene is encoded. Adjust the strand of the aligned reads
to indicate that the strand is not known.
<<bam-ex-strand>>=
strand(aln) <- "*"   # protocol not strand-aware
@ 

One important issue when counting reads is to make sure that the
reference names in both the annotation and the read files are
identical.
\begin{Exercise}
  Check the reference name in both the \Robject{ex} and
  \Robject{aln}. If they are not similar, how could you correct them?  
\end{Exercise}

For simplicity, we are interested in reads that align to only a single
gene. Count the number of genes a read aligns to\ldots
<<bam-ex-hits>>=
hits <- countOverlaps(aln, ex)
table(hits)
@ 
%% 
Subset the aligned reads to contain just those aligning once,
\Rcode{aln[hits == 1]}.  Finally, reverse the counting operation to
count the number of times each region of interest aligns to a uniquely
overlapping alignment.
<<bam-ex-cnt>>=
cnt <- countOverlaps(ex, aln[hits==1])
@ 
%% 
A simple function for counting reads (see
\Rfunction{GenomicRangese::summarizeOverlaps} for more realistic
counting schemes) is
<<bam-count-fun>>=
counter <- 
    function(filePath, range)
{
    aln <- readGappedAlignments(filePath)
    strand(aln) <- "*"
    hits <- countOverlaps(aln, range)
    countOverlaps(range, aln[hits==1])
}
@ 
This can be applied to all files using \Rfunction{sapply}
<<bam-count-all>>=
counts <- sapply(fls, counter, ex)
@ 
The counts in one BAM file are independent of counts in another BAM
file. This encourages us to count reads in each BAM file in parallel,
decreasing the length of time required to execute our program. On
Linux and Mac OS, a straight-forward way to parallelize this operation
is:
<<bam-count-mclapply, eval=FALSE>>=
if (require(parallel))
    simplify2array(mclapply(fls, counter, ex))
@ 
\end{Solution}

%\VignetteIndexEntry{B.2 Genomic Annotation}

\chapter{Genomic Annotation}
\label{chpt:GenomicAnnotation}

\section{\Biocpkg{AnnotationHub}}

\WARNING{This section requires an internet connection, and has been
  removed from the lab.}

\section{Whole genome sequences}

There are a diversity of packages and classes available for
representing large genomes. Several include:
\begin{packeddescription}
\item [\Rpackage{TxDb.*}] For transcript and other genome / coordinate
  annotation.
\item [\Biocpkg{BSgenome}] For whole-genome representation. See
  \Rfunction{available.packages} for pre-packaged genomes, and the
  vignette `How to forge a BSgenome data package' in the
\item [\Biocannopkg{Homo.sapiens}] For integrating \Rpackage{TxDb*} and
  \Rpackage{org.*} packages.
\item [\Rpackage{SNPlocs.*}] For model organism SNP locations derived
  from dbSNP.
\item [\Rfunction{FaFile}] (\Biocpkg{Rsamtools}) for accessing indexed
  FASTA files.
\item [ \Rpackage{SIFT.*}, \Rpackage{PolyPhen}] Variant effect scores.
\end{packeddescription}

\section{Gene models}

\begin{figure}
  \centering
  \includegraphics{GeneModel}
  \caption{Gene model showing exons on three transcripts.}
  \label{fig:anno:genemodel}
\end{figure}

\subsection{\Rpackage{TxDb.*} packages for model organisms}

Genome-centric packages are very useful for annotations involving
genomic coordinates. It is straight-forward, for instance, to discover
the coordinates of coding sequences in regions of interest, and from
these retrieve corresponding DNA or protein coding sequences. Other
examples of the types of operations that are easy to perform with
genome-centric annotations include defining regions of interest for
counting aligned reads in RNA-seq experiments and retrieving DNA
sequences underlying regions of interest in ChIP-seq analysis, e.g.,
for motif characterization.

\begin{Exercise}
  Load the `transcript.db' package relevant to the dm3 build of
  \emph{D.\ melanogaster}. Use \Rfunction{select} and friends to
  select the Flybase gene ids of the top table \Robject{tt} and the
  Flybase transcript names (TXNAME) and Entrez gene identifiers
  (GENEID).
  
  Use \Rfunction{cdsBy} to extract all coding sequences, grouped by
  transcript. Subset the coding sequences to contain just the
  transcripts relevant to the top table. How many transcripts are
  there? What is the structure of the first transcript's coding
  sequence?
  
  Load the `BSgenome' package for the dm3 build of
  \emph{D.\ melanogaster}. Use the coding sequences ranges of the
  previous part of this exercise to extract the underlying DNA
  sequence, using the \Rfunction{extractTranscriptsFromGenome}
  function. Use \Biocpkg{Biostrings}' \Rfunction{translate} to convert
  DNA to amino acid sequences.
\end{Exercise}

\begin{Solution}
  The following loads the relevant Transcript.db package, and creates
  a more convenient alias to the \Rclass{TranscriptDb} instance
  defined in the package.
<<txdb>>=
library(TxDb.Dmelanogaster.UCSC.dm3.ensGene)
txdb <- TxDb.Dmelanogaster.UCSC.dm3.ensGene
@ 
%% 

  We also need the data -- flybase IDs from our differential
  expression analysis.
<<de>>=
library(Morgan2013)
library(edgeR)
data(lrTest)
fbids <- rownames(topTags(lrTest))
@ 
%% 
  We can discover available keys (using \Rfunction{keys}) and columns
  (\Rfunction{cols}) in \Rcode{txdb}, and then use \Rfunction{select}
  to retrieve the transcripts associated with each differentially
  expressed gene. The mapping between gene and transcript is not
  one-to-one -- some genes have more than one transcript.
<<flybase-tx-gn>>=
txnm <- select(txdb, fbids, "TXNAME", "GENEID")
nrow(txnm)
head(txnm, 3)
@ 
%% 
  The \Rclass{TranscriptDb} instances can be queried for data that is
  more structured than simple data frames, and in particular return
  \Rclass{GRanges} or \Rclass{GRangesList} instances to represent
  genomic coordinates. These queries are performed using
  \Rfunction{cdsBy} (coding sequence), \Rfunction{transcriptsBy}
  (transcripts), etc., where the function argument \Rfunarg{by}
  specifies how coding sequences or transcripts are grouped.  Here we
  extract the coding sequences grouped by transcript, returning the
  transcript names, and subset the resulting \Rclass{GRangesList} to
  contain just the transcripts of interest to us. The first transcript
  is composed of 6 distinct coding sequence regions.
<<cdsBy>>=
cds <- cdsBy(txdb, "tx", use.names=TRUE)[txnm$TXNAME]
length(cds)
cds[1]
@ 
%% 

  The following code loads the appropriate BSgenome package; the
  \Robject{Dmelanogaster} object refers to the whole genome sequence
  represented in this package. The remaining steps extract the DNA
  sequence of each transcript, and translates these to amino acid
  sequences. Issues of strand are handled such that gene regions on
  the minus strand are reverse compelemented, so returned 
  in 5' to 3' orientation).
<<BSgenome>>=
library(BSgenome.Dmelanogaster.UCSC.dm3)
txx <- extractTranscriptsFromGenome(Dmelanogaster, cds)
length(txx)
head(txx, 3)
head(translate(txx), 3)
@ 
\end{Solution}

\section{UCSC tracks}

\subsection{Easily creating \Rclass{TranscriptDb} objects from GTF files}

\begin{Exercise}
  \WARNING{Internet connection required}
  (Adapted
  from\footnote{\url{http://www.sph.emory.edu/~hwu/teaching/bioc/bios560R.html}})
  The `track' curated annotations at UCSC are a great resource; this
  exercise creates a \Rclass{TranscriptDb} instance from one such
  track.
  \begin{enumerate}
  \item Load the \Biocpkg{GenomicFeatures} and \Biocpkg{rtracklayer}
    packages.
  \item Discover available genomes with \Rfunction{ucscGenomes}, and
    available tables with the \Rfunction{supportedUCSCtables}.
  \item Use the \Rfunction{makeTranscriptDbFromUCSC} from a suitable
    track, e.g., genome \Rfunarg{genome="ce2",
      tablename="refGene"}. There are some warnings; are these
    something to be concerned about?
  \item Exercise the object that you've created, e.g., exploring the
    basis of the warnings.
  \item Save and load the \Rclass{TranscriptDb} object you've created,
    illustrating how one can make these annotations convenient and
    reproducible.
  \item What's the difference between
    \Rfunction{makeTranscriptDbFromUCSC} and
    \Rfunction{makeFeatureDbFromUCSC}? Where else can transcript and
    feature data bases be made from?
  \end{enumerate}
\end{Exercise}
\begin{Solution}
  Load the \Rpackage{GenomicFeatures} and \Biocpkg{rtracklayer}
  packages and discover available genomes and tables:
<<makeTranscriptDbFromUCSC-discover>>=
library(rtracklayer)
library(GenomicFeatures)

## genomes
gnms <- ucscGenomes()
nrow(gnms)
gnms[grep("elegans", gnms$species),]

## tables
tbls <- supportedUCSCtables()
nrow(tbls)
head(tbls)
@ 
%% 
Make the \Rclass{TranscriptDb} object (this will take a minute)
<<makeTranscriptDbFromUCSC-make, eval=FALSE>>=
## Not run
txdb <- makeTranscriptDbFromUCSC("ce10", "refGene")
saveDb(txdb, file="/path/to/file.sqlite")
@ 
%% 
The warnings during object creation are about unusual lengths for CDS
(coding sequences should be in multiples of 3, since there are three
nucleotide residues per amino acid residue).
\begin{Schunk}
\begin{Soutput}
1: In .extractUCSCCdsStartEnd(cdsStart[i], cdsEnd[i], ... :
  UCSC data anomaly in transcript NM_001129046: the cds cumulative
  length is not a multiple of 3
\end{Soutput}
\end{Schunk}
but we seem to have a useful object with relevant metadata information
for reproducible research:
\begin{Schunk}
\begin{Sinput}
> txdb
\end{Sinput}
\begin{Soutput}
TranscriptDb object:
| Db type: TranscriptDb
| Supporting package: GenomicFeatures
| Data source: UCSC
| Genome: ce10
| Organism: Caenorhabditis elegans
| UCSC Table: refGene
| Resource URL: http://genome.ucsc.edu/
| Type of Gene ID: Entrez Gene ID
| Full dataset: yes
| miRBase build ID: NA
| transcript_nrow: 48714
| exon_nrow: 152542
| cds_nrow: 129947
| Db created by: GenomicFeatures package from Bioconductor
| Creation time: 2013-02-10 10:33:50 -0800 (Sun, 10 Feb 2013)
| GenomicFeatures version at creation time: 1.11.8
| RSQLite version at creation time: 0.11.2
| DBSCHEMAVERSION: 1.0
\end{Soutput}
\end{Schunk}
%% 
Let us investigate the source of the warnings -- what fraction of the
CDS have lengths that are not a multiple of 3? To do this we need to
determine the sum of the widths of the coding sequence exons in each
transcript. Start by extracting all coding sequence exons, grouped by
transcript; verify that this is a \Rclass{GRangesList} with a
reasonable number of entries.
\begin{Schunk}
\begin{Sinput}
> cdsByTx <- cdsBy(txdb, "tx", use.names=TRUE)
> length(cdsByTx)
\end{Sinput}
\begin{Soutput}
[1] 26146
\end{Soutput}
\begin{Sinput}
> cdsByTx[1:2]
\end{Sinput}
\begin{Soutput}
GRangesList of length 2:
$NM_058259 
GRanges with 3 ranges and 3 metadata columns:
      seqnames         ranges strand |    cds_id    cds_name exon_rank
         <Rle>      <IRanges>  <Rle> | <integer> <character> <integer>
  [1]     chrI [11641, 11689]      + |         1        <NA>         1
  [2]     chrI [14951, 15160]      + |         2        <NA>         2
  [3]     chrI [16473, 16585]      + |         3        <NA>         3

$NM_058264 
GRanges with 5 ranges and 3 metadata columns:
      seqnames         ranges strand | cds_id cds_name exon_rank
  [1]     chrI [43733, 43961]      + |      4     <NA>         1
  [2]     chrI [44030, 44234]      + |      5     <NA>         2
  [3]     chrI [44281, 44324]      + |      6     <NA>         3
  [4]     chrI [44372, 44468]      + |      7     <NA>         4
  [5]     chrI [44521, 44677]      + |      8     <NA>         5

---
seqlengths:
     chrI    chrII   chrIII    chrIV     chrV     chrX     chrM
 15072423 15279345 13783700 17493793 20924149 17718866    13794
\end{Soutput}
\end{Schunk}
%% 
Extract the width of each each exon; this is an \Rclass{IntegerList}
instance with one element of the list for each transcript, and one
integer value for each exon.
\begin{Schunk}
\begin{Sinput}
> wd <- width(cdsByTx)
> length(wd)
\end{Sinput}
\begin{Soutput}
[1] 26146
\end{Soutput}
\begin{Sinput}
> head(wd, 3)
\end{Sinput}
\begin{Soutput}
CompressedIntegerList of length 3
[["NM_058259"]] 49 210 113
[["NM_058264"]] 229 205 44 97 157
[["NM_001026606"]] 139 163 183 166
\end{Soutput}
\end{Schunk}
%% 
Use \Rfunction{sum} to add up the widths within each list element;
note that we're using the \Rmethod{sum,CompressedIntegerList-method},
and that this has been specialized to do the summation within list
elements.
\begin{Schunk}
\begin{Sinput}
> head(sum(wd))
\end{Sinput}
\begin{Soutput}
   NM_058259    NM_058264 NM_001026606    NM_058265 NM_001026607    NM_182094 
         372          732          651         1341         1620         1221 
\end{Soutput}
\end{Schunk}
%% 
We now have a standard \R{} vector; a one-liner asking about the
number of transcripts with exons that do not sum to 3 is
\begin{Schunk}
\begin{Sinput}
> table( (sum(width(cdsBy(txdb, "tx"))) %% 3) != 0 )
\end{Sinput}
\begin{Soutput}
FALSE  TRUE 
25676   470 
\end{Soutput}
\end{Schunk}
\end{Solution}

\begin{Exercise}
  (Adapted from\footnote{\url{http://www.sph.emory.edu/~hwu/teaching/bioc/bios560R.html}})
  Suppose you have a list of transcription factor binding sites on
  hg19. How would you obtain (a) the GC content of each site and (b)
  the percentage of gene promoters covered by the binding sites?
\end{Exercise}

\begin{Solution}
  As an outline of a solution, the steps for calculating GC content
  might be
  \begin{packedenumerate}
  \item Represent the list of transcription factor binding sites
    (`regions of interest') as a \Rclass{GRanges} instance,
    \Robject{roi}.
  \item Load \Rpackage{BSgenome} and the appropriate genome package,
    e.g., \Biocannopkg{BSgenome.Hsapiens.UCSC.hg19}.
  \item Use \Rfunction{getSeq} to retrieve the sequences, \Rcode{seqs
    <- getSeq(Hsapiens, gr)}.
  \item Use \Rcode{alphabetFrequency(seqs)} to summarize nucleotide
    use, and simple \R{} functions to determine GC content of each
    region of interest.
  \item Summarize these as density plots, etc. A meaningful extension
    of this exercise might compare the observed GC content to the
    expected content, where expectation is the product of the
    independent G and C frequencies.
  \end{packedenumerate}
  To calculate the percentage of promoters covered by binding sites,
  we might
  \begin{packedenumerate}
  \item Load the reference genome \Rpackage{TxDb} package,
    \Biocannopkg{TxDb.Hsapiens.UCSC.hg19.knownGene}.
  \item Query the package for promoters using the
    \Rfunction{promoters} function, or otherwise manipulating exon or
    transcript coordinates to get a \Rclass{GRanges} or
    \Rclass{GRangesList} representing genomic regions of interest,
    \Robject{groi}.
  \item Use \Rcode{countOverlaps(groi, roi)} to find how many
    transcription factor binding sites overlap each promoter, and from
    there use standard \R{} functions to tally the number of promoters
    that have zero overlaps.
  \end{packedenumerate}
\end{Solution}

%% \VignetteIndexEntry{B.4 Regulatory Variants: From BAM To Binding Motif}

\chapter{Regulatory Variants: BAM to Motif}

<<setup,echo=FALSE>>=
library(Morgan2013)
library(org.Hs.eg.db)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(BSgenome.Hsapiens.UCSC.hg19)
library(seqnames.db)
library(gmapR)
library(VariantTools)
library(lattice)
library(MotifDb)
library(parallel)
@ 

\section{Introduction}

This work flow was originally constructed by Paul Shannon and Valerie
Obenchain.

This portion of the lab represents a work flow from aligned reads
through variant calls to consequences for regulatory motif binding
sites. The work flow reproduces part of Huang \emph{et al}'s `Highly
recurrent TERT promoter mutations in human
melanoma'~\cite{huang2013highly}. Briefly, previous sequencing studies
identified mutations in the TERT promoter locus; Huang et al.\
validated these in additional cell lines, and noted that the mutation
introduced a binding site for the E-twenty-six transcription
factor. We reproduce some of these results, notably calling variants
in the TERT region across cell lines, and matching a data base of
binding motifs to the original and modified promoter regions.

If you are not using windows, load the \Rpackage{parallel} package
and set the number of cores to use to the number of cores on your
machine.
<<parallel>>=
library(parallel); options(mc.cores=detectCores())
@ 
%%
We'll use annotation resources for humans, specifically the
gene-centric \Biocannopkg{org.Hs.eg.db} for basic information about
TERT, the \Biocannopkg{TxDb.Hsapiens.UCSC.hg19.knownGene} package for
information about exon and transcript structure of TERT, and the
\Biocannopkg{BSgenome.Hsapiens.UCSC.hg19} package for sequence information.
<<annotation-libraries>>=
library(org.Hs.eg.db)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(BSgenome.Hsapiens.UCSC.hg19)
@ 
%% 
Huang \emph{et al} provide BAM files of reads aligning in the
neighborhood of TERT for several cell lines; a subset of these are
available for this lab. Create a variable \code{path} that points to
the directory containing these files. For me, the path is
<<path-to-bam>>=
path <- "~/BigData/TERT/bam"
@ 
%% 
As a sanity check, confirm that there are 22 files in this directory,
11 BAM and 11 index files.
<<sanity-check>>=
stopifnot(length(dir(path, "bam$")) == 11)
stopifnot(length(dir(path, "bai$")) == 11)
@ 
%% 
A common challenge in real-world analysis is that the sequence names
used in one part of a work flow (e.g., alignment) differ from sequence
names in another part of the work flow, e.g., annotation. Here the BAM
files are aligned using NCBI notation (``7'') but the annotations
follow UCSC notation (``chr7''). We need to make these consistent, and
it's easier to change the behavior of our annotation packages than to
change the bam files.
<<consistent-names>>=
seqnameStyle(BSgenome.Hsapiens.UCSC.hg19) <- 
    seqnameStyle(TxDb.Hsapiens.UCSC.hg19.knownGene) <- "NCBI"
@ 
%% 
It is important that we think carefully before re-naming sequence names
-- the underlying genome coordinates used for alignment need to match
exactly the genome coordinates used for annotation. As a final
preparation, let's make some convenient abbreviations for our genome
and txdb, and figure out what the Entrez ID is for the gene symbol
TERT.
<<anno-symbols>>=
bsgenome <- BSgenome.Hsapiens.UCSC.hg19
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
geneid <- select(org.Hs.eg.db, "TERT", "ENTREZID", "SYMBOL")
@ 

\section{Tallying variants}

\WARNING{This section requires Linux to tally variants with the
  \Biocpkg{gmapR} package}. If you are not using Linux, then read
through the steps and load the \Robject{called} object at the start of
the next section. The necessary precondition to evaluate the code
blocks in this section are tested by the following.
<<VariantTools-setup>>=
VARIANTTOOLS_OK <- local({
    sys <- !Sys.info()["sysname"] %in% c("Darwin", "Windows")
    sys && require(VariantTools) && require(gmapR)
})
stopifnot(VARIANTTOOLS_OK)
@ 

The main goal of this section is to tally variants in our region of
interest. We'll use an algorithm implemented in the
\Rfunction{callVariants} function of the \Biocpkg{VariantTools}
package. This in turn relies on the \Biocpkg{gmapR} package, which
provides an \R{} interface to the GMAP aligner, \Biocpkg{gmapR} needs
a reference genome to do its work. A neat feature is that the
reference genome can be created on the fly from arbitrary nucleotide
sequences. 

TERT is located on chromosome 5 (how would we discover that?) so we
make an indexed mini-reference genome of chr5. We get the coordinates
and actual sequence for this chromosome from the \Rpackage{BSgenome}
package.
<<mini-genome>>=
roi <- GRanges("5", IRanges(1, seqlengths(bsgenome)[["5"]]))
chr5seq <- getSeq(bsgenome, roi)
names(chr5seq) <- "5" 
@ 
%% 
and then make the reference genome in \Biocpkg{gmapR} (\Biocpkg{gmapR}
maintains a cache of sequences, so this is only `expensive' the first
time; it is important to use a descriptive name, because this is the
key used to retrieve a previously built genome from the cache).
<<make-mini>>=
library(gmapR)
genome.5 <- GmapGenome(chr5seq, name="hg19_5", create=TRUE)
@ 

We want to call variants in the promoter region of TERT, so query the
\Rcode{txdb} for transcripts grouped by gene, and then select the TERT
gene from the result. 
<<TERT-promoters>>=
rng <- transcriptsBy(txdb, "gene")[[geneid$ENTREZID]]
@ 
%% 
There are three unique start sites.
<<TERT-starts>>=
unique(start(rng))
@
%% 
For simplicity we treat the gene as a single range (using
\Rfunction{range}), use an \emph{ad hoc} definition of promoter as 330
nt upstream of the transcription start site, and define the
appropriate ranges using \Rfunction{promoter}. We restrict the
seqlevels to just chromosome five (seqlevels are acting in some ways
like factor levels, they persist even if there are no elements with
the corresponding level).
<<TERT-promoter>>=
unique(start(rng))
pregion <- promoters(range(rng), upstream=330, downstream=0)
seqlevels(pregion) <- "5"
@ 
 
Our objective is to use the \Biocpkg{VariantTools} package to call
variants. Variant calling is influenced by parameters specified in
creation of a \Rclass{VariantTallyParam} object; details of the
arguments to this function, and how they influence variant calling,
are present on the \Rfunction{VariantTallyParam} help page and in the
\Biocpkg{VariantTools} vignette.
<<setup-variant-calling>>=
library(VariantTools)
vtparam <- VariantTallyParam(genome.5, readlen=101L, 
    which=pregion, indels=TRUE)
@ 

The next step is to call variants. The basic approach is to invoked
the \Rfunction{callVariants} function on each bam file, using our
\Robject{vtparam} object to influence how variants are called.  
\begin{Exercise}
  (Linux only) Consult section 2.2 of the \Rpackage{VariantTools}
  vignette for a brief description of how variants are called.
\end{Exercise}
The following two lines calls variants in each of our files.
<<call-variants>>=
fls <- dir(path, "bam$", full=TRUE)
called <- lapply(fls, callVariants, tally.param=vtparam)
@                              
%% 
The results can be cleaned up a little. We currently have one
\Robject{GRanges} object for each BAM file, but it's convenient to
create a single \Robject{GRanges} object, adding a column (`id') to
remember which range came from which file.
<<call-variants-tidy>>=
len <- elementLengths(called)
called <- do.call(c, called)
id <- sub(".TERT.bam", "", basename(fls))
called$id <- factor(rep(id, len), levels=unique(id))
@ 
%% 
We'll explore the \Rcode{called} object in the next section.  

\section{Manipulation}

Here we pick up from the previous section, loading a saved version of
the data those of us on Linux were able to create.
<<load-called>>=
data(called, package="Morgan2013")
@ 
%% 
\begin{Exercise}
  What class of object is \Rcode{called}? How many rows does it have?
  How many metadata columns?
\end{Exercise}

\begin{Solution}
  The object is a \Rclass{GRanges} object with length
  \Sexpr{length(called)} and \Sexpr{ncol(mcols(called))} metadata
  columns.
\end{Solution}
  
Each row represents a genomic location for which some evidence of a
variant was discovered. The \Robject{ref} and \Robject{alt} columns
contain the reference and alternate sequence observed at that
location. From the \Biocpkg{VariantTools} package, some of the
important columns are:
\begin{verbatim}
 ncycles: The number of unique cycles at which the alternate allele was
          observed, 'NA' for the reference allele row.
   count: The number of reads with the alternate allele, 'NA' for the
          reference allele row.
high.quality: The number of reads for the alternate allele that were
          above 'high_quality_cutoff', 'NA' for the reference allele
          row.
mean.quality: The mean mapping quality for the alternate allele, 'NA'
          for the reference allele row.
count.pos: The number of positive strand reads for the alternate
          allele, 'NA' for the reference allele row.
cycleCount: An additional column is present for each bin formed by the
          'cycle_breaks' parameter, with the read count for that bin.
\end{verbatim}
Additional columns are also appended with `.ref', `.total', `.pos',
`.neg', etc., to indicate reference, total, positive strand and
negative strand. The idea is that the metadata columns are providing
further guidance on the nature of evidence supporting each called
variant. It is useful to get a sense of the evidence supporting the
called variants by exploring \Robject{called} using standard \R{}
commands, e.g., plotting \Robject{count} and \Robject{count.ref}
columns against one another. The called variants depend critically on
parameters used in \Robject{VariantTallyParam}, so we would want to
spend some time giving calling and quality assessment parameters
careful consideration.

A quick assessment of called variants, sufficient for reproducing
results in \cite{huang2013highly}, can be obtained by plotting the
number of reads supporting each call, across samples. We focus on the
highest-quality read cycles 10 to 91. The result is shown in
Figure~\ref{fig:variant-levelplot}.
<<explore-variants>>=
library(lattice)
altCounts <-
    xtabs(cycleCount.10.91 ~ start(called) + id, mcols(called))
plt <- levelplot(altCounts, xlab="Position", ylab=NULL,
          scales=list(x=list(rot=45)), aspect="fill",
          col.regions=rev(gray.colors(100, 0, 1)))
@ 
<<variant-levelplot, echo=FALSE>>=
pdf("variant-levelplot.pdf", width=10, height=3)
print(plt)
xx <- dev.off()
@ 
\begin{figure}
  \includegraphics[width=\textwidth, height=!]{variant-levelplot.pdf}
  \caption{Called variants across samples in regulatory regions of TERT}
  \label{fig:variant-levelplot}
\end{figure}

\section{Regulatory signatures}

Supposing that we have identified, as Huang \emph{et al}.\ did, a
mutation occurring at position 1295228 across samples or cell
lines. How can we relate this variant to regulatory signature?

We start by extracting the sequence surrounding the SNP in the
reference. We do this by creating a \Robject{GRanges} instance at the
SNP, then selecting flanking sequence of say 10 nt.
<<snp-def>>=
snp <- GRanges("5", IRanges(1295228, width=1))
snp <- flank(snp, 10, both=TRUE)
@ 
%%
We then retrieve the sequence from a data source, e.g., the
\Robject{BSgenome}, \Robject{gmapR}, or \Biocpkg{Rsamtools}'
\Rclass{FaFile} on which alignments were based.
<<ref-seq>>=
refSeq <- getSeq(bsgenome, snp)
@ 
%% 
Alternate sequences are a little more difficult; the helper function
\Rfunction{variantSequences} has been defined to do the work. It takes
the called variants, our SNP regions of interest, and the reference
sequence as arguments. It subsets our called variants to include only
those that overlap our region of interest using
\Rfunction{subsetByOverlaps}. It then injects the variants into the
reference sequence using \Rfunction{replaceLetterAt}.
<<variantSequences>>=
library(Morgan2013)
variantSequences
altSeq <- variantSequences(called, snp, refSeq)
@ 
%% 
We can perform various operations on the alt sequences; here we
suppose a common signal and create a consensus string.
<<alt-seq>>=
altConsensus <- DNAStringSet(consensusString(altSeq))
@ 
%% 
We can see the C228T transition in the middle of a DNAStringSet
containing first the (complements) of the reference and consensus
alternate sequence.
<<complement>>=
complement(c(refSeq, altConsensus))
@ 

The \Biocpkg{MotifDb} package contains a data base of protein binding
motifs. Here we load the data base and query it for all motifs present
in humans and derived from the well-respected JASPAR
core\footnote{\url{http://jaspar.cgb.ki.se/}} data set.
<<pwms>>=
library(MotifDb)
idx <- with(mcols(MotifDb), 
            organism=="Hsapiens" & dataSource == "JASPAR_CORE")
jasparHumanPWMs <- MotifDb[idx]
@ 
%% 
We now run all motifs over the regulatory region, searching for
possible similarity. We do this for the the reference sequence and for
the alternative consensus.
<<pwm-match>>=
## matchPWMs: helper in Morgan2013
minScore = "90%"             # high min. matching score: 1 base change
(refHits <- matchPWMs(jasparHumanPWMs, reverseComplement(refSeq)[[1]],
                      minScore))
(altHits <- matchPWMs(jasparHumanPWMs, reverseComplement(altConsensus)[[1]],
                      minScore))
@ 
%% 
Comparison of results shows that the consensus sequence contains a
novel high-scoring binding site for ETS1, as reported in Huang et al.

\section{Conclusions}

This work flow has provided brief tour through key steps in calling
regulatory variants, using previous results by Huang et al., to
motivate identification of a novel binding motif associated with
introduction of a called variant. Major components of this work flow
include the \Biocpkg{VariantTools}, \Biocpkg{Biostrings}, and
\Biocpkg{MotifDb} packages.

%\VignetteIndexEntry{B.1 Gene-centric Annotation}

\SweaveOpts{keep.source=TRUE, pdf=FALSE, png=TRUE}
<<setup, echo=FALSE>>=
options(digits=2)
library(org.Dm.eg.db)
CONNECTION_OK <- tryCatch({ 
    con <- url("http://google.com", "r"); close(con); TRUE
}, error=function(...) FALSE)
@ 

\chapter{Gene-centric Annotation}
\label{chpt:GeneCentricAnnotation}

Be sure to update your package to the current version by visiting the
course web server 192.168.0.9 and installing (if neccessary) the
current version of the \Rpackage{Morgan2013} package.
<<PKG_OK>>=
PKG_OK <- packageDescription("Morgan2013")$Version >= "0.9.0"
stopifnot(PKG_OK)
@ 

\Bioconductor{} provides extensive annotation resources, some of which
are summarized in Figure~\ref{fig:dbtypes}. These can be \emph{gene}-,
or \emph{genome}-centric. Annotations can be provided in packages
curated by \Bioconductor, or obtained from web-based
resources. Gene-centric \Biocpkg{AnnotationDbi} packages include:
\begin{packeditemize}
  \item Organism level: e.g. \Biocannopkg{org.Mm.eg.db},
    \Biocannopkg{Homo.sapiens}.
  \item Platform level: e.g. \Biocannopkg{hgu133plus2.db},
        \Biocannopkg{hgu133plus2.probes}, \Biocannopkg{hgu133plus2.cdf}.
  \item Homology level: e.g. \Biocannopkg{hom.Dm.inp.db}.
  \item System biology level: \Biocpkg{GO.db}, \Biocpkg{KEGG.db},
    \Biocpkg{Reactome.db}.
\end{packeditemize}
Examples of genome-centric packages include:
\begin{packeditemize}
  \item \Biocpkg{GenomicFeatures}, to represent genomic features,
    including constructing reproducible feature or transcript data
    bases from file or web resources.
  \item Pre-built transcriptome packages,
    e.g. \Biocannopkg{TxDb.Hsapiens.UCSC.hg19.knownGene} based on the
    \Hsap{} UCSC hg19 knownGenes track.
  \item \Biocpkg{BSgenome} for whole genome sequence representation
    and manipulation.
  \item Pre-built genomes, e.g.,
    \Biocannopkg{BSgenome.Hsapiens.UCSC.hg19} based on the \Hsap{}
    UCSC hg19 build.
\end{packeditemize}
Web-based resources include
\begin{packeditemize}
  \item \Biocpkg{biomaRt} to query
    \href{http://www.biomart.org/}{biomart} resource for genes,
    sequence, SNPs, and etc.
  \item \Biocpkg{rtracklayer} for interfacing with browser tracks,
    especially the \href{http:://genome.ucsc.edu}{UCSC} genome browser.
  \item \Biocpkg{AnnotationHub} for retrieving common large genomic
    resources in formats that readily fit into \R{} work flows.
\end{packeditemize}

\begin{figure}
  \centering
  \includegraphics[width=.5\textwidth]{databaseTypes.pdf}
  \caption{Annotation Packages: the big picture}
  \label{fig:dbtypes}
\end{figure}

\section{Gene-centric annotations with \Biocpkg{AnnotationDbi}}

Organism-level (`org') packages contain mappings between a central
identifier (e.g., Entrez gene ids) and other identifiers (e.g. GenBank
or Uniprot accession number, RefSeq id, etc.).  The name of an
Rpackage{org} package is always of the form \emph{org.<Sp>.<id>.db}
(e.g. \Biocannopkg{org.Sc.sgd.db}) where \emph{<Sp>} is a 2-letter
abbreviation of the organism (e.g. \texttt{Sc} for \emph{Saccharomyces
  cerevisiae}) and \emph{<id>} is an abbreviation (in lower-case)
describing the type of central identifier (e.g. \texttt{sgd} for gene
identifiers assigned by the \emph{Saccharomyces} Genome Database, or
\texttt{eg} for Entrez gene ids).  The `How to use the ``.db''
annotation packages' vignette in the \Biocpkg{AnnotationDbi} package
(org packages are only one type of `.db' annotation packages) is a
key reference.  The `.db' and most other \Bioconductor{} annotation
packages are updated every 6 months.

Annotation packages contain an object named after the package itself.
These objects are collectively called \Rclass{AnnotationDb} objects,
with more specific classes named \Rclass{OrgDb}, \Rclass{ChipDb} or
\Rclass{TranscriptDb} objects.  Methods that can be applied to these
objects include \Rfunction{cols}, \Rfunction{keys},
\Rfunction{keytypes} and \Rfunction{select}.  Common operations for
retrieving annotations are summarized in Table~\ref{tab:select-ops}.

\begin{table}
  \centering
  \caption{Common operations for retrieving and manipulating annotations.}
  \label{tab:select-ops}
  \begin{tabular}{lll}
    Category & Function & Description \\
    \hline

    Discover & \Rfunction{cols} & List the kinds of columns that can be returned \\
    & \Rfunction{keytypes} & List columns that can be used as keys \\
    & \Rfunction{keys} & List values that can be expected for a given keytype \\
    & \Rfunction{select} & Retrieve annotations matching
    \Rfunarg{keys}, \Rfunarg{keytype} and \Rfunarg{cols} \\
    
    Manipulate & \Rfunction{setdiff}, \Rfunction{union}, \Rfunction{intersect} & Operations on sets \\
    & \Rfunction{duplicated}, \Rfunction{unique} & Mark or remove duplicates \\
    & \Rfunction{\%in\%},  \Rfunction{match} &  Find matches  \\
    & \Rfunction{any}, \Rfunction{all} &  Are any \code{TRUE}?  Are all? \\
    & \Rfunction{merge} & Combine two different \Robject{data.frames} based on shared keys \\

    \Rclass{GRanges*} & \Rfunction{transcripts}, \Rfunction{exons}, \Rfunction{cds} & 
        Features (transcripts, exons, coding sequence) as \Rclass{GRanges}. \\

    & \Rfunction{transcriptsBy} , \Rfunction{exonsBy} & 
    Features group by  gene, transcript, etc., as \Rclass{GRangesList}.\\
    & \Rfunction{cdsBy}\\
    
    \hline
  \end{tabular}
\end{table}

%% select exercise
\begin{Exercise}
  What is the name of the org package for \emph{Drosophila}? Load it.
  Display the \Rclass{OrgDb} object for the \Biocpkg{org.Dm.eg.db}
  package.  Use the \Rfunction{cols} method to discover which sorts of
  annotations can be extracted from it.

  Use the \Rfunction{keys} method to extract UNIPROT identifiers and
  then pass those keys in to the \Rfunction{select} method in such a
  way that you extract the SYMBOL (gene symbol) and KEGG pathway
  information for each.

  Use \Rfunction{select} to retrieve the ENTREZ and SYMBOL
  identifiers of all genes in the KEGG pathway \texttt{00310}.
\end{Exercise}
\begin{Solution}
  The \Rclass{OrgDb} object is named \Rcode{org.Dm.eg.db}.
<<select>>=
library(org.Dm.eg.db)
cols(org.Dm.eg.db)
keytypes(org.Dm.eg.db)
uniprotKeys <- head(keys(org.Dm.eg.db, keytype="UNIPROT"))
cols <- c("SYMBOL", "PATH")
select(org.Dm.eg.db, keys=uniprotKeys, cols=cols, keytype="UNIPROT")
@
Selecting UNIPROT and SYMBOL ids of KEGG pathway \texttt{00310} is
very similar:
<<select-kegg>>=
kegg <- select(org.Dm.eg.db, "00310", c("UNIPROT", "SYMBOL"), "PATH")
nrow(kegg)
head(kegg, 3)
@
\end{Solution}

\begin{Exercise}
  For convenience, \Robject{lrTest}, a \Rclass{DGEGLM} object from an
  RNA-seq experiment, is included in the \Rpackage{Morgan2013}
  package.  The following code loads this data and creates a `top
  table' of the ten most differentially represented genes. This top
  table is then coerced to a \Rcode{data.frame}.
<<tt-to-eg>>=
library(Morgan2013)
library(edgeR)
library(org.Dm.eg.db)
data(lrTest)
tt <- as.data.frame(topTags(lrTest))
@
%% 

  Extract the Flybase gene identifiers (\Rcode{FLYBASE}) from the row
  names of this table and map them to their corresponding Entrez gene
  (\Rcode{ENTREZID}) and symbol ids (\Rcode{SYMBOL}) using
  \Rfunction{select}. Use \Rfunction{merge} to add the results of
  \Rfunction{select} to the top table.
\end{Exercise}

\begin{Solution}
<<tt-to-eg2>>=
fbids <- rownames(tt)
cols <- c("ENTREZID", "SYMBOL")
anno <- select(org.Dm.eg.db, fbids, cols, "FLYBASE")
ttanno <- merge(tt, anno, by.x=0, by.y="FLYBASE")
dim(ttanno)
head(ttanno, 3)
@
\end{Solution}

\section{\Biocpkg{biomaRt} and other web-based resources}

A short summary of select \Bioconductor{} packages enabling web-based
queries is in Table~\ref{tab:webannoservices}.

\begin{table}
  \centering
  \caption{Selected packages querying web-based annotation services.}
  \label{tab:webannoservices}
  \begin{tabular}{ll}
    Package & Description\\
    \hline
    \Biocpkg{biomaRt} & \url{http://biomart.org}, Ensembl and other annotations\\
    \Biocpkg{rtracklayer} & \url{http://genome.ucsc.edu}, genome tracks.\\
    \Biocpkg{AnnotationHub} & Ensembl, Encode, dbSNP, UCSC data objects \\
    \Biocpkg{uniprot.ws} & \url{http://uniprot.org}, protein annotations\\
    \Biocpkg{KEGGREST} & \url{http://www.genome.jp/kegg}, KEGG pathways\\
    \Biocpkg{SRAdb} & \url{http://www.ncbi.nlm.nih.gov/sra}, sequencing experiments.\\
    \Biocpkg{GEOquery} & \url{http://www.ncbi.nlm.nih.gov/geo/}, array and other data\\
    \Biocpkg{ArrayExpress} & \url{http://www.ebi.ac.uk/arrayexpress/}, array and other data\\
    \hline
  \end{tabular}
\end{table}

\subsection{Using biomaRt}

The \Biocpkg{biomaRt} package offers access to the online
\href{http://www.biomart.org}{biomart} resource. this consists of
several data base resources, referred to as `marts'.  Each mart allows
access to multiple data sets; the \Biocpkg{biomaRt} package provides
methods for mart and data set discovery, and a standard method
\Rfunction{getBM} to retrieve data.

\begin{Exercise}
  \WARNING{Internet connection required}

  Load the \Biocpkg{biomaRt} package and list the available marts.
  Choose the \emph{ensembl} mart and list the datasets for that mart.
  Set up a mart to use the \emph{ensembl} mart and the
  \emph{hsapiens\_gene\_ensembl} dataset.
 
  A \Biocpkg{biomaRt} dataset can be accessed via
  \Rfunction{getBM}. In addition to the mart to be accessed, this
  function takes filters and attributes as arguments.  Use
  \Rfunction{filterOptions} and \Rfunction{listAttributes} to discover
  values for these arguments.  Call \Rfunction{getBM} using filters
  and attributes of your choosing.
\end{Exercise}

\begin{Solution}
<<biomaRt1, eval=FALSE, results=hide>>=
library(biomaRt)
head(listMarts(), 3)                      ## list the marts
head(listDatasets(useMart("ensembl")), 3) ## mart datasets
ensembl <-                                ## fully specified mart
    useMart("ensembl", dataset = "hsapiens_gene_ensembl")

head(listFilters(ensembl), 3)             ## filters
myFilter <- "chromosome_name"
head(filterOptions(myFilter, ensembl), 3) ## return values
myValues <- c("21", "22")
head(listAttributes(ensembl), 3)          ## attributes
myAttributes <- c("ensembl_gene_id","chromosome_name")

## assemble and query the mart
res <- getBM(attributes =  myAttributes, filters =  myFilter,
             values =  myValues, mart = ensembl)
@
Use \code{head(res)} to see the results.
\end{Solution}

%% \FiXME{update this}
%% \section{Advanced aspects of \Rpackage{*.org} packages}

%% \subsection{\Biocpkg{AnnotationForge} to create custom packages}

%% \subsection{\software{mysql} data base and \code{SQL} queries}

%\VignetteIndexEntry{1.4 Reads and Strings}

\chapter{Strings and Reads}
\label{chpt:SequencesAndReads}

\begin{table}
  \centering
  \caption{Selected \Bioconductor{} packages for representing strings
    and reads.}
  \label{tab:strings-pkgs}
  \begin{tabular}{lp{.7\textwidth}}
    Package & Description\\
    \hline
    \Biocpkg{Biostrings} & Classes (e.g., \Rclass{DNAStringSet}) and
    methods (e.g., \Rfunction{alphabetFrequency},
    \Rfunction{pairwiseAlignment}) for representing and manipulating
    DNA and other biological sequences.\\

    \Biocpkg{BSgenome} & Representation and manipulation of large
    (e.g., whole-genome) sequences.\\
    
    \Biocpkg{ShortRead} & I/O and manipulation of FASTQ files.\\
    \hline
  \end{tabular}
\end{table}

\section{DNA (and other) Strings with the \Biocpkg{Biostrings} package}

\begin{table}
  \centering
  \caption{Operations on strings in the \Biocpkg{Biostrings} package.}
  \label{tab:ops:biostrings}
  \begin{tabular}{lll}
    & Function & Description \\
    \hline

    Access & \Rfunction{length}, \Rfunction{names} & Number and
        names of sequences\\ 
    & \Rfunction{[}, \Rfunction{head}, \Rfunction{tail}, \Rfunction{rev}
    & Subset, first, last, or reverse sequences\\
    & \Rfunction{c} & Concatenate two or more objects\\
    & \Rfunction{width}, \Rfunction{nchar} & Number of letters of each
        sequence \\
    & \Rfunction{Views} & Light-weight sub-sequences of a sequence\\

    Compare & \Rfunction{==}, \Rfunction{!=}, \Rfunction{match}, 
        \Rfunction{\%in\%} & Element-wise comparison\\ 
    & \Rfunction{duplicated}, \Rfunction{unique} &
        Analog to \Rfunction{duplicated} and \Rfunction{unique} on character
        vectors \\
    & \Rfunction{sort}, \Rfunction{order} & Locale-independent sort, order\\
    & \Rfunction{split}, \Rfunction{relist} & Split or relist objects to,
        e.g., \Rclass{DNAStringSetList} \\

    Edit & \Rfunction{subseq}, \Rfunction{subseq<-} &
        Extract or replace sub-sequences in a set of sequences \\
    & \Rfunction{reverse}, \Rfunction{complement} & 
        Reverse, complement, or reverse-complement DNA \\
    & \Rfunction{reverseComplement} \\
    & \Rfunction{translate} & Translate DNA to Amino Acid sequences \\
    & \Rfunction{chartr} & Translate between letters \\
    & \Rfunction{replaceLetterAt} & Replace letters at a set of
        positions by new letters \\
    & \Rfunction{trimLRPatterns} & Trim or find flanking patterns \\

    Count & \Rfunction{alphabetFrequency} & Tabulate letter occurrence \\
    & \Rfunction{letterFrequency} \\
    & \multicolumn{2}{l}{\Rfunction{letterFrequencyInSlidingView}}\\
    & \Rfunction{consensusMatrix} & 
        Nucleotide $\times$ position summary of letter counts \\
    & \Rfunction{dinucleotideFrequency} & 2-mer, 3-mer, and k-mer counting \\
    & \Rfunction{trinucleotideFrequency} \\
    & \Rfunction{oligonucleotideFrequency} \\
    & \Rfunction{nucleotideFrequencyAt} & 
        Nucleotide counts at fixed sequence positions\\

    Match & \Rfunction{matchPattern}, \Rfunction{countPattern} & 
        Short patterns in one or many (\texttt{v*}) sequences\\
    & \multicolumn{2}{l}{\Rfunction{vmatchPattern}, \Rfunction{vcountPattern}}\\
    & \Rfunction{matchPDict}, \Rfunction{countPDict} & 
        Short patterns in one or many (\texttt{v*}) sequences (mismatch only)\\
    & \Rfunction{whichPDict}, \Rfunction{vcountPDict} \\
    & \Rfunction{vwhichPDict} \\
    & \Rfunction{pairwiseAlignment} & Needleman-Wunsch,
        Smith-Waterman, etc. pairwise alignment\\
    & \Rfunction{matchPWM}, \Rfunction{countPWM} & 
        Occurrences of a position weight matrix\\
    & \Rfunction{matchProbePair} & Find left or right flanking patterns \\
    & \Rfunction{findPalindromes} & Palindromic regions in a sequence. Also \\
    & & \Rfunction{findComplementedPalindromes} \\
    & \Rfunction{stringDist} & 
        Levenshtein, Hamming, or pairwise alignment scores\\

    I/0 & \Rfunction{readDNAStringSet} & 
        FASTA (or sequence only from FASTQ). Also\\
    & & \Rfunction{readBStringSet}, \Rfunction{readRNAStringSet},
        \Rfunction{readAAStringSet}\\
    & \Rfunction{writeXStringSet}\\
    & \Rfunction{writePairwiseAlignments} &
        Write \Rfunction{pairwiseAlignment} as ``pair'' format\\
    & \Rfunction{readDNAMultipleAlignment} &
        Multiple alignments (FASTA, ``stockholm'', or ``clustal''). Also\\
    & & \Rfunction{readRNAMultipleAlignment}, 
        \Rfunction{readAAMultipleAlignment} \\
    & \Rfunction{write.phylip}\\\hline
  \end{tabular}
\end{table}

Table~\ref{tab:strings-pkgs} lists select \Bioconductor{} packages for
representing strings and reads.  The \Biocpkg{Biostrings} package
provides tools for working with sequences.  The essential data
structures are \Rclass{DNAString} and \Rclass{DNAStringSet}, for
working with one or multiple DNA sequences. The \Biocpkg{Biostrings}
package contains additional classes for representing amino acid and
general biological strings.  The \Biocpkg{BSgenome} and related
packages (e.g., \Biocannopkg{BSgenome.Dmelanogaster.UCSC.dm3}) are
used to represent whole-genome
sequences. Table~\ref{tab:ops:biostrings} summarizes common
operations; The following exercise explores these packages.

\begin{Exercise}
  The objective of this exercise is to calculate the GC content of the
  exons of a single gene. We jump into the middle of some of the data
  structures common in \Bioconductor{}; these are introduced more
  thoroughly in later exercises..

  Load the \Biocannopkg{BSgenome.Dmelanogaster.UCSC.dm3} data package,
  containing the UCSC representation of \Dmel{} genome assembly
  dm3. Discover the content of the package by evaluating
  \Robject{Dmelanogaster}.
  
  Load the \Rpackage{Morgan2013} package, and evaluate the
  command \Rcode{data(ex)} to load an example of a
  \Rclass{GRangesList} object. the \Rclass{GRangesList} represents
  coordinates of exons in the \Dmel{} genome, grouped by gene.

  Look at \Rcode{ex[1]}. These are the genomic coordinates of the
  first gene in the \Rcode{ex} object. Load the \Dmel{} chromosome
  that this gene is on by subsetting the \Robject{Dmelanogaster}
  object.

  Use \Rfunction{Views} to create views on to the chromosome that span
  the start and end coordinates of all exons in the first gene; the
  start and end coordinates are accessed with \Rcode{start(ex[[1]])}
  and similar.

  Develop a function \Rfunction{gcFunction} to calculate GC
  content. Use this to calculate the GC content in each of the exons.
\end{Exercise}

\begin{Solution}
  Here we load the \Dmel{} genome, select a single chromosome, and
  create \Rfunction{Views} that reflect the ranges of the
  \texttt{FBgn0002183}.
<<gc-genome>>=
library(BSgenome.Dmelanogaster.UCSC.dm3)
Dmelanogaster
library(Morgan2013)
data(ex)
ex[1]
nm <- "chr3L"
chr <- Dmelanogaster[[nm]]
v <- Views(chr, start=start(ex[[1]]), end=end(ex[[1]]))
@ 
%% 
Here is the \Rfunction{gcFunction} helper function to calculate GC
content:
<<gcFunction-definition>>=
gcFunction
@ 
%
The \Rfunction{gcFunction} is really straight-forward: it invokes the
function \Rfunction{alphabetFrequency} from the \Biocpkg{Biostrings}
package. This returns a simple matrix of exon $\times$ nucleotide
probabilities. The row sums of the \texttt{G} and \texttt{C} columns
of this matrix are the GC contents of each exon.

The subject GC content is
<<gcFunction-genome, eval=FALSE>>=
subjectGC <- gcFunction(v)
@ 
\end{Solution}

\section{Reads and the \Biocpkg{ShortRead} package}
\label{sec:ShortRead}

\paragraph{Short read formats}

Illumina technologies generate sequences by measuring incorporation of
florescent nucleotides over successive PCR cycles. These sequencers
produce output in a variety of formats, but \emph{FASTQ} is
ubiquitous. Each read is represented by a record of four components:
<<fastq-format, echo=FALSE>>=
bigdata <- "~/BigData"
fls <- dir(file.path(bigdata, "fastq"), full=TRUE)
cat(noquote(readLines(fls[[1]], 4)), sep="\n")
@ 
The first and third lines (beginning with \verb|@| and \verb|+|
respectively) are unique identifiers. The identifier produced by the
sequencer typically includes a machine id followed by colon-separated
information on the lane, tile, x, and y coordinate of the read. The
example illustrated here also includes the SRA accession number, added
when the data was submitted to the archive. The machine identifier
could potentially be used to extract information about batch
effects. The spatial coordinates (lane, tile, x, y) are often used to
identify optical duplicates; spatial coordinates can also be used
during quality assessment to identify artifacts of sequencing, e.g.,
uneven amplification across the flow cell, though these spatial
effects are rarely pursued.

The second and fourth lines of the FASTQ record are the nucleotides
and qualities of each cycle in the read. This information is given in
5' to 3' orientation as seen by the sequencer. A letter \texttt{N} in
the sequence is used to signify bases that the sequencer was not able
to call.  The fourth line of the FASTQ record encodes the quality
(confidence) of the corresponding base call. The quality score is
encoded following one of several conventions, with the general notion
being that letters later in the visible ASCII alphabet
<<ascii, echo=FALSE>>=
cat(rawToChar(as.raw(32+1:75)),
    rawToChar(as.raw(32+76:94)), sep="\n")
@ 
are of higher quality; this is developed further below. Both the
sequence and quality scores may span multiple lines.

Technologies other than Illumina use different formats to represent
sequences. Roche 454 sequence data is generated by `flowing' labeled
nucleotides over samples, with greater intensity corresponding to
longer runs of A, C, G, or T. This data is represented as a series of
`flow grams' (a kind of run-length encoding of the read) in Standard
Flowgram Format (SFF). The \Bioconductor{} package
\Biocpkg{R453Plus1Toolbox} has facilities for parsing SFF files, but
after quality control steps the data are frequently represented (with
some loss of information) as FASTQ. 

\paragraph{Short reads in \R{}}

FASTQ files can be read in to \R{} using the \Rfunction{readFastq}
function from the \Biocpkg{ShortRead} package. Use this function by
providing the path to a FASTQ file. There are sample data files
available in the \texttt{~/BigData} directory, each consisting
of 1 million reads from a lane of the Pasilla data set.
<<readFastq>>=
library(ShortRead)
bigdata <- "~/BigData"  ## e.g., "C:/Users/mtmorgan/"
fastqDir <- file.path(bigdata, "fastq")
fastqFiles <- dir(fastqDir, full=TRUE)
fq <- readFastq(fastqFiles[1])
fq
@
The data are represented as an object of class \Rclass{ShortReadQ}.
<<sread>>=
head(sread(fq), 3)
head(quality(fq), 3)
head(id(fq), 3)
@ 
The \Rclass{ShortReadQ} class illustrates \emph{class
  inheritance}. It extends the \Rclass{ShortRead} class
<<getClasse>>=
getClass("ShortReadQ")
@ 
Methods defined on \Rclass{ShortRead} are available for
\Rclass{ShortReadQ}.
<<showMethods-ShortRead, eval=FALSE>>=
showMethods(class="ShortRead", where=search())
@ 
For instance, the \Rfunction{width} can be used to demonstrate that
all reads consist of \Sexpr{unique(width(fq))} nucleotides.
<<width-ShortRead>>=
table(width(fq))
@ 
The \Rfunction{alphabetByCycle} function summarizes use
of nucleotides at each cycle in a (equal width) \Rclass{ShortReadQ} or
\Rclass{DNAStringSet} instance.
<<width-ShortReadQ>>=
abc <- alphabetByCycle(sread(fq))
abc[1:4, 1:8]
@ 

FASTQ files are getting larger. A very common reason for looking at
data at this early stage in the processing pipeline is to explore
sequence quality. In these circumstances it is often not necessary to
parse the entire FASTQ file. Instead create a representative sample
<<FastqSampler>>=
sampler <- FastqSampler(fastqFiles[1], 1000000)
yield(sampler) # sample of 1000000 reads
@ 
A second common scenario is to pre-process reads, e.g., trimming
low-quality tails, adapter sequences, or artifacts of sample
preparation. The \Rclass{FastqStreamer} class can be used to `stream'
over the fastq files in chunks, processing each chunk independently.

\Biocpkg{ShortRead} contains facilities for quality assessment of
FASTQ files. Here we generate a report from a sample of 1 million
reads from each of our files and display it in a web browser
<<qa, eval=FALSE>>=
qas0 <- Map(function(fl, nm) {
    fq <- FastqSampler(fl)
    qa(yield(fq), nm)
}, fastqFiles,
   sub("_subset.fastq", "", basename(fastqFiles)))
qas <- do.call(rbind, qas0)
rpt <- report(qas, dest=tempfile())
browseURL(rpt)
@ 
A report from a larger subset of the experiment is available
<<report,eval=FALSE >>=
rpt <- system.file("GSM461176_81_qa_report", "index.html",
                   package="Morgan2013")
browseURL(rpt)
@ 

\begin{Exercise}
  Use the file path \Rfunction{bigdata} and the \Rfunction{file.path}
  and \Rfunction{dir} functions to locate the fastq file from
  \cite{pasilla} (the file was obtained as described in the
  \Rpackage{pasilla} experiment data package).

  Input the fastq files using \Rfunction{readFastq} from the
  \Biocpkg{ShortRead} package.
  
  Use \Rfunction{alphabetFrequency} to summarize the GC content of all
  reads (hint: use the \Rfunction{sread} accessor to extract the
  reads, and the \Rfunarg{collapse=TRUE} argument to the
  \Rfunction{alphabetFrequency} function). Using the helper function
  \Rfunction{gcFunction} defined in the \Rpackage{Morgan2013} package,
  draw a histogram of the distribution of GC frequencies across reads.
  
  Use \Rfunction{alphabetByCycle} to summarize the frequency of each
  nucleotide, at each cycle. Plot the results using
  \Rfunction{matplot}, from the \Rpackage{graphics} package.

  As an advanced exercise, and if on Mac or Linux, use the
  \Rpackage{parallel} package and \Rfunction{mclapply} to read and
  summarize the GC content of reads in two files in parallel.
\end{Exercise}

\begin{Solution}
Discovery:
<<fastq-discovery>>=
dir(bigdata)
fls <- dir(file.path(bigdata, "fastq"), full=TRUE)
@ 
Input:
<<fastq-input-gc, echo=FALSE>>=
rm(fq); invisible(gc())
@ 
<<fastq-input>>=
fq <- readFastq(fls[1])
@ 
GC content:
<<gcC>>=
alf0 <- alphabetFrequency(sread(fq), as.prob=TRUE, collapse=TRUE)
sum(alf0[c("G", "C")])
@ 
A histogram of the GC content of individual reads is obtained with
<<gc-reads>>=
gc <- gcFunction(sread(fq))
hist(gc)
@ 
Alphabet by cycle:
<<abc>>=
abc <- alphabetByCycle(sread(fq))
matplot(t(abc[c("A", "C", "G", "T"),]), type="l")
@ 
Advanced (Mac, Linux only): processing on multiple cores.
<<abc-mclapply, eval=FALSE>>=
library(parallel)
gc0 <- mclapply(fls, function(fl) {
  fq <- readFastq(fl)
  gc <- gcFunction(sread(fq))
  table(cut(gc, seq(0, 1, .05)))
})
## simplify list of length 2 to 2-D array
gc <- simplify2array(gc0)
matplot(gc, type="s")
@ 
\end{Solution}

\begin{Exercise}
  Use \Rfunction{quality} to extract the quality scores of the short
  reads. Interpret the encoding qualitatively.
  
  Convert the quality scores to a numeric matrix, using
  \Rfunction{as()}. Inspect the numeric matrix (e.g., using
  \Rfunction{dim}) and understand what it represents.
  
  Use \Rfunction{colMeans} to summarize the average quality score by
  cycle. Use \Rfunction{plot} to visualize this.
\end{Exercise}

\begin{Solution}
<<quality>>=
head(quality(fq))
qual <- as(quality(fq), "matrix")
dim(qual)
plot(colMeans(qual), type="b")
@ 
\end{Solution}

\begin{Exercise}
  As an independent exercise when an internet connection is available,
  visit the \Biocpkg{qrqc} landing page and explore the package
  vignette. Use the \Biocpkg{qrqc} package (you may need to install
  this) to generate base and average quality plots for the data, like
  those in the report generated by \Biocpkg{ShortRead}.
\end{Exercise}

%% \FIXME{Paired-end reads}

\name{IntermediateSequenceAnalysis2013-package}
\Rdversion{1.1}
\alias{IntermediateSequenceAnalysis2013-package}
\alias{IntermediateSequenceAnalysis2013}
\docType{package}

\title{Supporting material, CSAMA 2013}

\description{

  This package contains supporting material for lectures and labs
  delivered by Martin Morgan during the CSAMA 2013 course.

}

\author{

  Author: Marc Carlson, Valerie Obenchain, Herv\'e Pag\`es, Paul
  Shannon, Dan Tenenbaum, Martin Morgan

  Maintainer: Biocore Team c/o BioC user list
  <bioconductor@stat.math.ethz.ch>

}

\keyword{ package }

\examples{
packageDescription("Morgan2013")
}
